(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    403744,       8617]
NotebookOptionsPosition[    394741,       8485]
NotebookOutlinePosition[    395299,       8504]
CellTagsIndexPosition[    395256,       8501]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Four-bar function generation", "Title",
 CellChangeTimes->{{3.8268639769905972`*^9, 
  3.82686398286312*^9}},ExpressionUUID->"11233cd8-bee2-42b9-a262-\
04a2194cf3c1"],

Cell[BoxData[
 RowBox[{
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzsnQeYFMXWhg8GDOwuiBlUEAUxJ1TMmLNgRkBFxJwREwoOmFHEgKAiGDFj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     "], {{0, 349.}, {525., 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag[
    "Byte", ColorSpace -> "RGB", Interleaving -> True, 
     MetaInformation -> <|
      "Comments" -> <|"Software" -> "www.inkscape.org"|>|>],
    Selectable->False],
   DefaultBaseStyle->"ImageGraphics",
   ImageSize->{270.6666666666665, Automatic},
   ImageSizeRaw->{525., 349.},
   PlotRange->{{0, 525.}, {0, 349.}}], ";"}]], "Text", "Input",
 CellChangeTimes->{{3.826863933854255*^9, 3.8268639367623878`*^9}, {
   3.8268646296280046`*^9, 3.8268646433617*^9}, 3.8273260159606557`*^9, {
   3.828324794022497*^9, 3.8283247945187645`*^9}, 3.8283248373394747`*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"0b950a6c-dfe6-4dab-960f-97d8c3da6f92"],

Cell[TextData[{
 Cell[BoxData[
  RowBox[{"rm", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "/", "2"}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["r", "2"], "-", 
      SuperscriptBox["s", "2"], "-", 
      SuperscriptBox["t", "2"], "-", 
      SuperscriptBox["u", "2"], "-", 
      SuperscriptBox["v", "2"]}], ")"}]}]}]],
  CellChangeTimes->{{3.8268640538739276`*^9, 3.8268641822800436`*^9}, {
    3.826864240646454*^9, 3.8268642436420207`*^9}, 3.8268642768565083`*^9},
  ExpressionUUID->"a9e50958-66b2-4388-bd3b-1b47330bdb82"],
 "\n",
 Cell[BoxData[
  RowBox[{"d", "=", 
   RowBox[{"{", 
    RowBox[{
    "rm", ",", " ", "s", ",", " ", "t", ",", " ", "u", ",", " ", "v"}], 
    "}"}]}]],
  CellChangeTimes->{{3.8268640538739276`*^9, 3.8268641822800436`*^9}, {
    3.826864240646454*^9, 3.8268642436420207`*^9}, 3.8268642768565083`*^9},
  ExpressionUUID->"94cd49b4-34a2-4c81-a326-181beb11cfff"],
 "\nInput ",
 Cell[BoxData["\[Mu]j"],
  CellChangeTimes->{{3.8268640538739276`*^9, 3.8268641822800436`*^9}, {
    3.826864240646454*^9, 3.8268642436420207`*^9}, 3.8268642768565083`*^9},
  ExpressionUUID->"636b93a9-8b6b-4117-b430-faf2ff558518"],
 " ----- Output ",
 Cell[BoxData["\[Psi]j"],
  CellChangeTimes->{{3.8268640538739276`*^9, 3.8268641822800436`*^9}, {
    3.826864240646454*^9, 3.8268642436420207`*^9}, 3.8268642768565083`*^9},
  ExpressionUUID->"1aa8fa4d-d14e-4333-9a9f-c6710b525562"]
}], "Text",
 CellChangeTimes->{{3.8268646485584106`*^9, 3.8268646635265083`*^9}, {
  3.8273260071325974`*^9, 3.82732600846527*^9}, {3.828324708339011*^9, 
  3.828324721763838*^9}, {3.8283248636219435`*^9, 3.8283249170260544`*^9}, {
  3.828376171280833*^9, 
  3.8283762283496046`*^9}},ExpressionUUID->"94d771a2-06d8-446b-b178-\
84454b14df4f"],

Cell[CellGroupData[{

Cell["Bertini related modules,", "Chapter",
 CellChangeTimes->{{3.8268659790360584`*^9, 3.826865981852149*^9}, {
  3.827593343408186*^9, 3.827593346476427*^9}, {3.8553326441319027`*^9, 
  3.8553326740748835`*^9}},ExpressionUUID->"37365eae-d1ec-488b-adec-\
610a9b1f0b7e"],

Cell[TextData[{
 "The following module computes the coefficients of the objective function \
for a given function task specification ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", "\[Mu]j"}], TraditionalForm]],ExpressionUUID->
  "9595e6e6-28f6-4aa7-82b7-d218522c9f35"],
 ", \[Psi]j)."
}], "Text",
 CellChangeTimes->{{3.8283682938703732`*^9, 3.828368377919958*^9}, {
  3.8283684227856226`*^9, 
  3.8283684284286213`*^9}},ExpressionUUID->"a1cb924a-3267-42c5-b94f-\
2eb4c6f84338"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Mu]\[Psi]", "=", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\[Mu]\[Psi]j", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "]"}], "2"]}], ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Cos", "[", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "]"}]}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
            "\[RightDoubleBracket]"}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          SuperscriptBox[
           RowBox[{"Cos", "[", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "]"}], "2"]}], ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Sin", "[", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "]"}]}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
              "\[RightDoubleBracket]"}], "-", 
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
              "\[RightDoubleBracket]"}]}], "]"}]}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
            "\[RightDoubleBracket]"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"Cos", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
            "\[RightDoubleBracket]"}], "]"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}], "]"}]}], ",", 
         RowBox[{"Cos", "[", 
          RowBox[{
           RowBox[{"2", " ", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}]}], "-", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"Cos", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
            "\[RightDoubleBracket]"}], "]"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "-", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
             "\[RightDoubleBracket]"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
             "\[RightDoubleBracket]"}], "]"}], "2"]}], ",", 
         RowBox[{
          RowBox[{"Cos", "[", 
           RowBox[{
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "-", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
             "\[RightDoubleBracket]"}]}], "]"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          SuperscriptBox[
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
              "\[RightDoubleBracket]"}], "-", 
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
              "\[RightDoubleBracket]"}]}], "]"}], "2"]}], ",", 
         RowBox[{
          RowBox[{"Sin", "[", 
           RowBox[{
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "-", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
             "\[RightDoubleBracket]"}]}], "]"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
              "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
               "\[RightDoubleBracket]"}], "-", 
              RowBox[{
              "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
               "\[RightDoubleBracket]"}]}], ")"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", 
            RowBox[{
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
              "\[RightDoubleBracket]"}], "-", 
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
              "\[RightDoubleBracket]"}]}], "]"}], "2"]}], ",", 
         RowBox[{
          RowBox[{"Cos", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}], "]"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
            "\[RightDoubleBracket]"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"Sin", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
            "\[RightDoubleBracket]"}], "]"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "-", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
             "\[RightDoubleBracket]"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Cos", "[", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "]"}]}], " ", 
          RowBox[{"Cos", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"Sin", "[", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
              "\[RightDoubleBracket]"}]}], "-", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
             "\[RightDoubleBracket]"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"Cos", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
            "\[RightDoubleBracket]"}], "]"}], " ", 
          RowBox[{"Cos", "[", 
           RowBox[{
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "-", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
             "\[RightDoubleBracket]"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Cos", "[", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
             "\[RightDoubleBracket]"}], "]"}]}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"Cos", "[", 
           RowBox[{
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "-", 
            RowBox[{"2", " ", 
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
              "\[RightDoubleBracket]"}]}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
              "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
               "\[RightDoubleBracket]"}], "-", 
              RowBox[{
              "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
               "\[RightDoubleBracket]"}]}], ")"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"Sin", "[", 
           RowBox[{
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "-", 
            RowBox[{"2", " ", 
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
              "\[RightDoubleBracket]"}]}]}], "]"}]}], ",", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
              "\[RightDoubleBracket]"}], "-", 
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
              "\[RightDoubleBracket]"}]}], ")"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
              "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
               "\[RightDoubleBracket]"}], "-", 
              RowBox[{
              "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
               "\[RightDoubleBracket]"}]}], ")"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          SuperscriptBox[
           RowBox[{"Cos", "[", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
             "\[RightDoubleBracket]"}], "]"}], "2"]}], ",", 
         RowBox[{
          RowBox[{"Cos", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}], "]"}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "-", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
             "\[RightDoubleBracket]"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", 
            RowBox[{
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
              "\[RightDoubleBracket]"}], "-", 
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
              "\[RightDoubleBracket]"}]}], "]"}], "2"]}], ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
              "\[RightDoubleBracket]"}], "-", 
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
              "\[RightDoubleBracket]"}]}], "]"}]}], " ", 
          RowBox[{"Cos", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
              "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
               "\[RightDoubleBracket]"}], "-", 
              RowBox[{
              "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
               "\[RightDoubleBracket]"}]}], ")"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          SuperscriptBox[
           RowBox[{"Cos", "[", 
            RowBox[{
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
              "\[RightDoubleBracket]"}], "-", 
             RowBox[{
             "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
              "\[RightDoubleBracket]"}]}], "]"}], "2"]}], ",", 
         RowBox[{"-", 
          RowBox[{"Sin", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
            "\[RightDoubleBracket]"}], "]"}]}], ",", 
         RowBox[{"Cos", "[", 
          RowBox[{
          "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
           "\[RightDoubleBracket]"}], "]"}], ",", 
         RowBox[{"Sin", "[", 
          RowBox[{
          "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
           "\[RightDoubleBracket]"}], "]"}], ",", 
         RowBox[{"Cos", "[", 
          RowBox[{
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
            "\[RightDoubleBracket]"}], "-", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}]}], "]"}], ",", 
         RowBox[{"Sin", "[", 
          RowBox[{
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
            "\[RightDoubleBracket]"}], "-", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"Cos", "[", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"Sin", "[", 
           RowBox[{
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
             "\[RightDoubleBracket]"}], "-", 
            RowBox[{
            "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
             "\[RightDoubleBracket]"}]}], "]"}]}], ",", 
         RowBox[{"Cos", "[", 
          RowBox[{
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "1", 
            "\[RightDoubleBracket]"}], "-", 
           RowBox[{
           "\[Mu]\[Psi]j", "\[LeftDoubleBracket]", "2", 
            "\[RightDoubleBracket]"}]}], "]"}], ",", 
         FractionBox["1", "2"]}], "}"}]}], "]"}], ",", 
     RowBox[{"CompilationOptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<InlineExternalDefinitions\>\"", "\[Rule]", "True"}], 
       "}"}]}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.826971749396822*^9, 3.826971831896801*^9}, {
   3.826973522939657*^9, 3.8269735233821774`*^9}, {3.827323594730801*^9, 
   3.827323613707602*^9}, {3.8273236681409564`*^9, 3.827323669067852*^9}, {
   3.8273237474284945`*^9, 3.827323819607422*^9}, {3.8273239692456594`*^9, 
   3.8273239711438313`*^9}, 3.8273243573520064`*^9, {3.827324392403702*^9, 
   3.827324479748355*^9}, 3.8273245379137745`*^9, {3.8273245836334286`*^9, 
   3.8273246575750265`*^9}, {3.8273247625033984`*^9, 3.827324803953826*^9}, {
   3.82732484903017*^9, 3.827324850528166*^9}, {3.8273250496735687`*^9, 
   3.8273250630622487`*^9}, {3.8273251186964226`*^9, 
   3.8273251535545855`*^9}, {3.827325194415311*^9, 3.8273252147285223`*^9}, {
   3.827325311156064*^9, 3.8273253388282967`*^9}, 3.827325371726897*^9, 
   3.827325443384774*^9, {3.8273255445960207`*^9, 3.827325561752428*^9}, {
   3.827325728070162*^9, 3.827325732271931*^9}, 3.827325776628809*^9, {
   3.827325843356385*^9, 3.8273259835348144`*^9}, 3.828368451094777*^9, 
   3.8553972097083616`*^9, {3.8553974792756786`*^9, 3.8553974796328754`*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"3746a4e6-b124-452b-bf62-eb8f2084f2c1"],

Cell["\<\
The following module computes the vector sum of the coefficients for all \
given task specifications. \
\>", "Text",
 CellChangeTimes->{{3.8283682938703732`*^9, 3.828368377919958*^9}, {
  3.8283684227856226`*^9, 3.8283684284286213`*^9}, {3.8283684596845636`*^9, 
  3.828368491327593*^9}},ExpressionUUID->"7843c74a-1105-41c0-a217-\
5fbad5db64e9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Mu]\[Psi]set", ":=", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\[Mu]\[Psi]data", ",", "_Real", ",", "2"}], "}"}], "}"}], ",", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{"\[Mu]\[Psi]", "[", 
          RowBox[{"\[Mu]\[Psi]data", "[", 
           RowBox[{"[", "j", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"Length", "[", "\[Mu]\[Psi]data", "]"}]}], "}"}]}], 
        "]"}]}], "]"}], ",", 
     RowBox[{"CompilationOptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<InlineExternalDefinitions\>\"", "\[Rule]", "True"}], 
       "}"}]}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.826971749396822*^9, 3.826971831896801*^9}, {
   3.826973522939657*^9, 3.8269735233821774`*^9}, {3.827323594730801*^9, 
   3.827323613707602*^9}, {3.8273236681409564`*^9, 3.827323669067852*^9}, {
   3.8273237474284945`*^9, 3.827323819607422*^9}, {3.8273239692456594`*^9, 
   3.8273239711438313`*^9}, 3.8273243573520064`*^9, {3.827324392403702*^9, 
   3.827324479748355*^9}, 3.8273245379137745`*^9, {3.8273245836334286`*^9, 
   3.8273246575750265`*^9}, {3.8273247625033984`*^9, 3.827324803953826*^9}, {
   3.82732484903017*^9, 3.827324850528166*^9}, {3.8273250496735687`*^9, 
   3.8273250630622487`*^9}, {3.8273251186964226`*^9, 
   3.8273251535545855`*^9}, {3.827325194415311*^9, 3.8273252147285223`*^9}, {
   3.827325311156064*^9, 3.8273253388282967`*^9}, 3.827325371726897*^9, 
   3.827325443384774*^9, {3.8273255445960207`*^9, 3.827325561752428*^9}, {
   3.827325728070162*^9, 3.827325732271931*^9}, 3.827325776628809*^9, {
   3.827325843356385*^9, 3.8273259835348144`*^9}, 3.828368451094777*^9, 
   3.8553972155292664`*^9, {3.855397484101907*^9, 3.8553974844270573`*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"2fdf425f-bdd2-4e5a-bab3-9aa6a7c734d6"],

Cell["\<\
The following module calls in Bertini to solve a system of polynomial \
equations. \
\>", "Text",
 CellChangeTimes->{{3.8283682938703732`*^9, 3.828368377919958*^9}, {
  3.8283684227856226`*^9, 3.8283684284286213`*^9}, {3.8283684596845636`*^9, 
  3.8283685209400663`*^9}},ExpressionUUID->"5de4dba7-0608-490f-9772-\
d4b9aa4a723b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSolve", "[", 
   RowBox[{"F_", ",", "vars_", ",", 
    RowBox[{"paramSubs_", ":", "0"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "OS", ",", "nF", ",", "fvars", ",", "nvars", ",", "varsPresent", ",", 
      "varsLetter", ",", "finalParameters", ",", "config", ",", 
      "variableGroups", ",", "function", ",", "equations", ",", "parameter", 
      ",", "inputBertini", ",", "instance", ",", "solns1", ",", "solns2", ",",
       "solns3", ",", "solns4", ",", "solns5", ",", "solns6", ",", "solns7", 
      ",", "solns8", ",", "end", ",", "shellscript", ",", "instnoslash"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "Code", " ", "optimized", " ", "for", " ", "PC", " ", "the", " ", 
      "best"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"F", " ", "-", 
       RowBox[{
       "the", " ", "list", " ", "containing", " ", "the", " ", "polynomial", 
        " ", "equations", " ", "to", " ", "solve"}]}], ",", " ", 
      RowBox[{
       RowBox[{"do", " ", "not", " ", "include"}], " ", "\[Equal]", "0"}]}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"vars", " ", "-", 
      RowBox[{
      "the", " ", "list", " ", "containing", " ", "the", " ", "variables", 
       " ", "to", " ", "be", " ", "solved", " ", "for"}]}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"vars", " ", "-", 
       RowBox[{"for", " ", "m"}], "-", 
       RowBox[{"homogeneous", " ", "groups", " ", "of", " ", "variables"}]}], 
      ",", " ", 
      RowBox[{
      "vars", " ", "should", " ", "be", " ", "multiple", " ", "lists"}]}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"paramSubs", " ", "-", 
       RowBox[{
       "optional", " ", "argument", " ", "for", " ", "parameter", " ", 
        "homotopy"}]}], ",", " ", 
      RowBox[{
      "parameters", " ", "and", " ", "their", " ", "values", " ", "are", " ", 
       "input", " ", "as", " ", "a", " ", "list", " ", "of", " ", 
       RowBox[{"substitutions", ".", "  ", "Equations"}], " ", "F", " ", 
       "must", " ", "remain", " ", "symbolic", " ", "for", " ", "parameter", 
       " ", 
       RowBox[{"homotopy", ".", "  ", "As"}], " ", "well"}], ",", " ", 
      RowBox[{
      "the", " ", "files", " ", "start_parameters", " ", "and", " ", 
       "general_solutions", " ", "must", " ", "be", " ", "located", " ", "in",
        " ", "the", " ", "Bertini", " ", 
       RowBox[{"directory", ".", "  ", "start_parameters"}], " ", "and", " ", 
       "general_solutions", " ", "need", " ", "to", " ", "have", " ", "been", 
       " ", "previously", " ", "created", " ", "using", " ", "the", " ", 
       RowBox[{"PARAMETERHOMOTOPY", ":", " ", 
        RowBox[{"1", " ", "configuration"}]}]}]}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "You", " ", "can", " ", "edit", " ", "Bertini", " ", "configurations", 
      " ", "directly", " ", "by", " ", "editing", " ", "\"\<config\>\"", " ", 
      "below"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "Point", " ", "this", " ", "function", " ", "to", " ", "the", " ", 
       "directory", " ", "containing", " ", "the", " ", "Bertini", " ", 
       "execution", " ", "files", " ", "on", " ", "the", " ", "following", 
       " ", 
       RowBox[{"line", ".", "  ", "For"}], " ", "an", " ", "HPC", " ", 
       "execution"}], ",", " ", 
      RowBox[{
      "this", " ", "is", " ", "needed", " ", "to", " ", "locate", " ", "the", 
       " ", "parameter", " ", "homotopy", " ", "files"}]}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "Specify", " ", "the", " ", "OS", " ", "as", " ", "\"\<PC\>\"", " ", 
      "or", " ", "\"\<Mac\>\"", " ", "or", " ", "\"\<HPC\>\""}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OS", "=", "\"\<PC\>\""}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetDirectory", "[", 
      RowBox[{
       RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
       RowBox[{"ToString", "[", "\"\<BertiniFiles\>\"", "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"nF", "=", 
      RowBox[{"Length", "[", "F", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"fvars", "=", 
      RowBox[{"Flatten", "[", "vars", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"nvars", "=", 
      RowBox[{"Length", "[", "fvars", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"varsPresent", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"CoefficientRules", "[", 
          RowBox[{"F", ",", "fvars"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], ",", "1"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"varsLetter", "=", 
      RowBox[{"StringCount", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"StringDelete", "[", 
           RowBox[{"#", ",", "\"\<$\>\""}], "]"}], "&"}], "/@", 
         RowBox[{"(", 
          RowBox[{"ToString", "/@", "fvars"}], ")"}]}], ",", 
        RowBox[{"StartOfString", "~~", "LetterCharacter", "~~", 
         RowBox[{
         "EndOfString", "|", "LetterCharacter", "|", "DigitCharacter"}]}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{"Which", "[", 
        RowBox[{
         RowBox[{"OS", "\[Equal]", "\"\<PC\>\""}], ",", 
         RowBox[{"MemberQ", "[", 
          RowBox[{
           RowBox[{"FileExistsQ", "/@", 
            RowBox[{"{", 
             RowBox[{
             "\"\<bertini.exe\>\"", ",", "\"\<cyggcc_s-1.dll\>\"", ",", 
              "\"\<cyggmp-3.dll\>\"", ",", "\"\<cygmpfr-4.dll\>\"", ",", 
              "\"\<cygwin1.dll\>\""}], "}"}]}], ",", "False"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"OS", "\[Equal]", "\"\<Mac\>\""}], ",", 
         RowBox[{"MemberQ", "[", 
          RowBox[{
           RowBox[{"FileExistsQ", "/@", 
            RowBox[{"{", "\"\<bertini\>\"", "}"}]}], ",", "False"}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"OS", "\[Equal]", "\"\<HPC\>\""}], ",", "False", ",", 
         "\[IndentingNewLine]", "True", ",", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<Invalid OS specified\>\"", "]"}], ";", 
          RowBox[{"Abort", "[", "]"}], ";"}]}], "]"}], ",", 
       RowBox[{
        RowBox[{
        "Print", "[", 
         "\"\<The function is not pointed to a directory with the proper \
system files\>\"", "]"}], ";", 
        RowBox[{"Abort", "[", "]"}], ";"}], ",", "\[IndentingNewLine]", 
       RowBox[{"nF", ">", "nvars"}], ",", 
       RowBox[{
        RowBox[{
        "Print", "[", "\"\<You have more equations than variables\>\"", "]"}],
         ";", 
        RowBox[{"Abort", "[", "]"}], ";"}], ",", "\[IndentingNewLine]", 
       RowBox[{"nF", "<", "nvars"}], ",", 
       RowBox[{
        RowBox[{
        "Print", "[", "\"\<You have more variables than equations\>\"", "]"}],
         ";", 
        RowBox[{"Abort", "[", "]"}], ";"}], ",", "\[IndentingNewLine]", 
       RowBox[{"MemberQ", "[", 
        RowBox[{
         RowBox[{"Total", "[", "varsPresent", "]"}], ",", "0"}], "]"}], ",", 
       RowBox[{
        RowBox[{
        "Print", "[", 
         "\"\<You listed a variable that isn't included in the equations\>\"",
          "]"}], ";", 
        RowBox[{"Abort", "[", "]"}], ";"}], ",", "\[IndentingNewLine]", 
       RowBox[{"MemberQ", "[", 
        RowBox[{"varsLetter", ",", "0"}], "]"}], ",", 
       RowBox[{
        RowBox[{
        "Print", "[", "\"\<One of your variables is an invalid character\>\"",
          "]"}], ";", 
        RowBox[{"Abort", "[", "]"}], ";"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Depth", "[", "paramSubs", "]"}], ">", "1"}], "&&", 
        RowBox[{
         RowBox[{"FileExistsQ", "[", "\"\<start_parameters\>\"", "]"}], 
         "\[Equal]", "False"}]}], ",", 
       RowBox[{
        RowBox[{
        "Print", "[", 
         "\"\<The file start_parameters does not exist.  Cannot complete \
parameter homotopy.\>\"", "]"}], ";", 
        RowBox[{"Abort", "[", "]"}], ";"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Depth", "[", "paramSubs", "]"}], ">", "1"}], "&&", 
        RowBox[{
         RowBox[{"FileExistsQ", "[", "\"\<general_solutions\>\"", "]"}], 
         "\[Equal]", "False"}]}], ",", 
       RowBox[{
        RowBox[{
        "Print", "[", 
         "\"\<The file general_solutions does not exist.  Cannot complete \
parameter homotopy.\>\"", "]"}], ";", 
        RowBox[{"Abort", "[", "]"}], ";"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"config", "=", 
      RowBox[{"{", 
       RowBox[{"\"\<CONFIG\>\"", ",", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Depth", "[", "paramSubs", "]"}], ">", "1"}], ",", 
          "\"\<PARAMETERHOMOTOPY: 2;\>\"", ",", 
          "\"\<PARAMETERHOMOTOPY: 0;\>\""}], "]"}], ",", 
        "\[IndentingNewLine]", "\"\<SECURITYLEVEL: 0;\>\"", ",", 
        "\[IndentingNewLine]", "\"\<SECURITYMAXNORM: 1e20;\>\"", ",", 
        "\[IndentingNewLine]", "\"\<PathTruncationThreshold: 1e20;\>\"", ",", 
        "\[IndentingNewLine]", "\"\<MPTYPE: 0;\>\"", ",", 
        "\[IndentingNewLine]", "\"\<CONDNUMTHRESHOLD:1e20;\>\"", ",", 
        "\[IndentingNewLine]", "\"\<PrintPathProgress: 50;\>\"", ",", 
        "\[IndentingNewLine]", "\"\<END;\>\""}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"variableGroups", "=", 
      RowBox[{"{", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"\"\<variable_group \>\"", "<>", 
           RowBox[{"StringTake", "[", 
            RowBox[{
             RowBox[{"ToString", "[", "#", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", 
               RowBox[{"-", "2"}]}], "}"}]}], "]"}], "<>", "\"\<;\>\""}], 
          "&"}], ",", "vars", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Depth", "[", "vars", "]"}], "-", "2"}], "}"}]}], "]"}], 
       "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"variableGroups", "=", 
      RowBox[{"Flatten", "[", "variableGroups", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"function", "=", 
      RowBox[{"{", 
       RowBox[{"\"\<function \>\"", "<>", 
        RowBox[{"StringTake", "[", 
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"\"\<f\>\"", "<>", 
              RowBox[{"ToString", "[", "i", "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "nF"}], "}"}]}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", 
            RowBox[{"-", "2"}]}], "}"}]}], "]"}], "<>", "\"\<;\>\""}], 
       "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"parameter", "=", 
      RowBox[{"{", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Depth", "[", "paramSubs", "]"}], ">", "1"}], ",", 
         RowBox[{"\"\<parameter \>\"", "<>", 
          RowBox[{"StringTake", "[", 
           RowBox[{
            RowBox[{"ToString", "[", 
             RowBox[{"paramSubs", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", 
              RowBox[{"-", "2"}]}], "}"}]}], "]"}], "<>", "\"\<;\>\""}], ",", 
         "\"\<\>\""}], "]"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"equations", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"\"\<f\>\"", "<>", 
         RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\< = \>\"", "<>", 
         "\[IndentingNewLine]", 
         RowBox[{"ToString", "[", 
          RowBox[{"InputForm", "[", 
           RowBox[{
            RowBox[{"SetPrecision", "[", 
             RowBox[{
              RowBox[{"F", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "50"}], "]"}], ",", 
            RowBox[{"NumberMarks", "\[Rule]", "False"}]}], "]"}], "]"}], 
         "\[IndentingNewLine]", "<>", "\"\<;\>\""}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "nF"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"equations", "=", 
      RowBox[{"StringReplace", "[", 
       RowBox[{"equations", ",", 
        RowBox[{
         RowBox[{"\"\<*^\>\"", "~~", 
          RowBox[{"a", ":", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Shortest", "[", "___", "]"}], "~~", "NumberString"}], 
            ")"}]}]}], "\[RuleDelayed]", 
         RowBox[{"\"\<e\>\"", "<>", 
          RowBox[{"ToString", "[", "a", "]"}]}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"equations", "=", 
      RowBox[{"StringReplace", "[", 
       RowBox[{"equations", ",", 
        RowBox[{
         RowBox[{"Shortest", "[", 
          RowBox[{"(", 
           RowBox[{"\"\<SetAccuracy[0,\>\"", "~~", "__", "~~", "\"\<]\>\""}], 
           ")"}], "]"}], "\[Rule]", "\"\<0\>\""}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"inputBertini", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"StringDelete", "[", 
         RowBox[{"#", ",", "\"\<$\>\""}], "]"}], "&"}], "/@", 
       RowBox[{"Join", "[", 
        RowBox[{"config", ",", 
         RowBox[{"{", "\"\<INPUT\>\"", "}"}], ",", "variableGroups", ",", 
         "function", ",", "parameter", ",", "equations", ",", 
         RowBox[{"{", "\"\<END;\>\"", "}"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Goto", "[", "OS", "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"Label", "[", "\"\<PC\>\"", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"instance", "=", 
      RowBox[{"DateString", "[", 
       RowBox[{"{", 
        RowBox[{
        "\"\<instance\>\"", ",", "\"\<YearShort\>\"", ",", "\"\<\>\"", ",", 
         "\"\<Month\>\"", ",", "\"\<\>\"", ",", "\"\<Day\>\"", ",", 
         "\"\<-\>\"", ",", "\"\<Hour24\>\"", ",", "\"\<\>\"", ",", 
         "\"\<Minute\>\"", ",", "\"\<-\>\"", ",", "\"\<Second\>\"", ",", 
         "\"\<\>\"", ",", "\"\<Millisecond\>\"", ",", "\"\<\\\\\>\""}], "}"}],
        "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"CreateDirectory", "[", "instance", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"CopyFile", "[", 
      RowBox[{"\"\<bertini.exe\>\"", ",", 
       RowBox[{"instance", "<>", "\"\<bertini.exe\>\""}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"CopyFile", "[", 
      RowBox[{"\"\<cyggcc_s-1.dll\>\"", ",", 
       RowBox[{"instance", "<>", "\"\<cyggcc_s-1.dll\>\""}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"CopyFile", "[", 
      RowBox[{"\"\<cyggmp-3.dll\>\"", ",", 
       RowBox[{"instance", "<>", "\"\<cyggmp-3.dll\>\""}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"CopyFile", "[", 
      RowBox[{"\"\<cygmpfr-4.dll\>\"", ",", 
       RowBox[{"instance", "<>", "\"\<cygmpfr-4.dll\>\""}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"CopyFile", "[", 
      RowBox[{"\"\<cygwin1.dll\>\"", ",", 
       RowBox[{"instance", "<>", "\"\<cygwin1.dll\>\""}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{"instance", "<>", "\"\<input.txt\>\""}], ",", "inputBertini"}],
       "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"RenameFile", "[", 
      RowBox[{
       RowBox[{"instance", "<>", "\"\<input.txt\>\""}], ",", 
       RowBox[{"instance", "<>", "\"\<input\>\""}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Depth", "[", "paramSubs", "]"}], ">", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CopyFile", "[", 
         RowBox[{"\"\<start_parameters\>\"", ",", 
          RowBox[{"instance", "<>", "\"\<start_parameters\>\""}]}], "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"finalParameters", "=", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{
               RowBox[{"Re", "[", "#", "]"}], ",", "CForm"}], "]"}], "<>", 
             "\"\< \>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{
               RowBox[{"Im", "[", "#", "]"}], ",", "CForm"}], "]"}]}], "&"}], 
           ",", 
           RowBox[{"SetPrecision", "[", 
            RowBox[{
             RowBox[{"paramSubs", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", "50"}], "]"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"PrependTo", "[", 
         RowBox[{"finalParameters", ",", 
          RowBox[{"Length", "[", "paramSubs", "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Export", "[", 
         RowBox[{
          RowBox[{"instance", "<>", "\"\<final_parameters.txt\>\""}], ",", 
          "finalParameters"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"RenameFile", "[", 
         RowBox[{
          RowBox[{"instance", "<>", "\"\<final_parameters.txt\>\""}], ",", 
          RowBox[{"instance", "<>", "\"\<final_parameters\>\""}]}], "]"}]}]}],
       "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetDirectory", "[", 
      RowBox[{"\"\<.\\\\\>\"", "<>", "instance"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Depth", "[", "paramSubs", "]"}], ">", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
       "Run", "[", "\"\<bertini input ../general_solutions\>\"", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Run", "[", "\"\<bertini input\>\"", "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SetDirectory", "[", "\"\<..\\\\\>\"", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Goto", "[", "end", "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"Label", "[", "\"\<Mac\>\"", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"instance", "=", 
      RowBox[{"DateString", "[", 
       RowBox[{"{", 
        RowBox[{
        "\"\<instance\>\"", ",", "\"\<YearShort\>\"", ",", "\"\<\>\"", ",", 
         "\"\<Month\>\"", ",", "\"\<\>\"", ",", "\"\<Day\>\"", ",", 
         "\"\<-\>\"", ",", "\"\<Hour24\>\"", ",", "\"\<\>\"", ",", 
         "\"\<Minute\>\"", ",", "\"\<-\>\"", ",", "\"\<Second\>\"", ",", 
         "\"\<\>\"", ",", "\"\<Millisecond\>\"", ",", "\"\</\>\""}], "}"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"CreateDirectory", "[", "instance", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"CopyFile", "[", 
      RowBox[{"\"\<bertini\>\"", ",", 
       RowBox[{"instance", "<>", "\"\<bertini\>\""}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{"instance", "<>", "\"\<input.txt\>\""}], ",", "inputBertini"}],
       "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"RenameFile", "[", 
      RowBox[{
       RowBox[{"instance", "<>", "\"\<input.txt\>\""}], ",", 
       RowBox[{"instance", "<>", "\"\<input\>\""}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Depth", "[", "paramSubs", "]"}], ">", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CopyFile", "[", 
         RowBox[{"\"\<start_parameters\>\"", ",", 
          RowBox[{"instance", "<>", "\"\<start_parameters\>\""}]}], "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"finalParameters", "=", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{
               RowBox[{"Re", "[", "#", "]"}], ",", "CForm"}], "]"}], "<>", 
             "\"\< \>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{
               RowBox[{"Im", "[", "#", "]"}], ",", "CForm"}], "]"}]}], "&"}], 
           ",", 
           RowBox[{"SetPrecision", "[", 
            RowBox[{
             RowBox[{"paramSubs", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", "50"}], "]"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"PrependTo", "[", 
         RowBox[{"finalParameters", ",", 
          RowBox[{"Length", "[", "paramSubs", "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Export", "[", 
         RowBox[{
          RowBox[{"instance", "<>", "\"\<final_parameters.txt\>\""}], ",", 
          "finalParameters"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"RenameFile", "[", 
         RowBox[{
          RowBox[{"instance", "<>", "\"\<final_parameters.txt\>\""}], ",", 
          RowBox[{"instance", "<>", "\"\<final_parameters\>\""}]}], "]"}]}]}],
       "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetDirectory", "[", 
      RowBox[{"\"\<./\>\"", "<>", "instance"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Depth", "[", "paramSubs", "]"}], ">", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
       "Run", "[", 
        "\"\<PATH=/Users/markplecnik/Documents/mpich2-install/bin:$PATH; \
export PATH; mpiexec -n 12 ./bertini ./input ../general_solutions\>\"", "]"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{
       "Run", "[", 
        "\"\<PATH=/Users/markplecnik/Documents/mpich2-install/bin:$PATH; \
export PATH; mpiexec -n 12 ./bertini ./input\>\"", "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SetDirectory", "[", "\"\<../\>\"", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Goto", "[", "end", "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"Label", "[", "\"\<HPC\>\"", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"instance", "=", 
      RowBox[{"DateString", "[", 
       RowBox[{"{", 
        RowBox[{
        "\"\<instance\>\"", ",", "\"\<YearShort\>\"", ",", "\"\<\>\"", ",", 
         "\"\<Month\>\"", ",", "\"\<\>\"", ",", "\"\<Day\>\"", ",", 
         "\"\<-\>\"", ",", "\"\<Hour24\>\"", ",", "\"\<\>\"", ",", 
         "\"\<Minute\>\"", ",", "\"\<-\>\"", ",", "\"\<Second\>\"", ",", 
         "\"\<\>\"", ",", "\"\<Millisecond\>\"", ",", "\"\</\>\""}], "}"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"CreateDirectory", "[", "instance", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{"instance", "<>", "\"\<input.txt\>\""}], ",", "inputBertini"}],
       "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"RenameFile", "[", 
      RowBox[{
       RowBox[{"instance", "<>", "\"\<input.txt\>\""}], ",", 
       RowBox[{"instance", "<>", "\"\<input\>\""}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Depth", "[", "paramSubs", "]"}], ">", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CopyFile", "[", 
         RowBox[{"\"\<start_parameters\>\"", ",", 
          RowBox[{"instance", "<>", "\"\<start_parameters\>\""}]}], "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"finalParameters", "=", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{
               RowBox[{"Re", "[", "#", "]"}], ",", "CForm"}], "]"}], "<>", 
             "\"\< \>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{
               RowBox[{"Im", "[", "#", "]"}], ",", "CForm"}], "]"}]}], "&"}], 
           ",", 
           RowBox[{"SetPrecision", "[", 
            RowBox[{
             RowBox[{"paramSubs", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", "50"}], "]"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"PrependTo", "[", 
         RowBox[{"finalParameters", ",", 
          RowBox[{"Length", "[", "paramSubs", "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Export", "[", 
         RowBox[{
          RowBox[{"instance", "<>", "\"\<final_parameters.txt\>\""}], ",", 
          "finalParameters"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"RenameFile", "[", 
         RowBox[{
          RowBox[{"instance", "<>", "\"\<final_parameters.txt\>\""}], ",", 
          RowBox[{"instance", "<>", "\"\<final_parameters\>\""}]}], "]"}]}]}],
       "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetDirectory", "[", 
      RowBox[{"\"\<./\>\"", "<>", "instance"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"instnoslash", "=", 
      RowBox[{"StringTake", "[", 
       RowBox[{"instance", ",", " ", 
        RowBox[{"{", 
         RowBox[{"1", ",", " ", 
          RowBox[{"-", "2"}]}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"shellscript", "=", 
      RowBox[{"{", 
       RowBox[{"\"\<#!/bin/bash\>\"", ",", "\[IndentingNewLine]", 
        RowBox[{"\"\<#$ -N \>\"", "<>", "instnoslash"}], ",", 
        "\[IndentingNewLine]", "\"\<#$ -q free64\>\"", ",", 
        "\[IndentingNewLine]", "\"\<#$ -pe mpi-one-node 64\>\"", ",", 
        "\[IndentingNewLine]", "\"\<##$ -m beas\>\"", ",", 
        "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
        "\"\<module load openmpi-1.6.0/gcc-4.7.3\>\"", ",", 
        "\[IndentingNewLine]", "\"\<module load Bertini/1.4\>\"", ",", 
        "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Depth", "[", "paramSubs", "]"}], ">", "1"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
          "\"\<mpirun bertini input ../general_solutions > \>\"", "<>", 
           "instnoslash", "<>", "\"\<_out\>\""}], ",", "\[IndentingNewLine]", 
          RowBox[{
          "\"\<mpirun bertini input > \>\"", "<>", "instnoslash", "<>", 
           "\"\<_out\>\""}]}], "]"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{"instnoslash", "<>", "\"\<.txt\>\""}], ",", "shellscript"}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"RenameFile", "[", 
      RowBox[{
       RowBox[{"instnoslash", "<>", "\"\<.txt\>\""}], ",", 
       RowBox[{"instnoslash", "<>", "\"\<.sh\>\""}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Run", "[", 
      RowBox[{"\"\<qsub \>\"", "<>", "instnoslash", "<>", "\"\<.sh\>\""}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"FileExistsQ", "[", "\"\<finite_solutions\>\"", "]"}], 
        "\[Equal]", "False"}], ",", 
       RowBox[{"Pause", "[", "1", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetDirectory", "[", "\"\<../\>\"", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Goto", "[", "end", "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"Label", "[", "end", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"solns1", "=", 
      RowBox[{"Import", "[", 
       RowBox[{
        RowBox[{"instance", "<>", "\"\<nonsingular_solutions\>\""}], ",", 
        "\"\<Text\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"solns1", "=", 
        RowBox[{"Import", "[", 
         RowBox[{
          RowBox[{"instance", "<>", "\"\<finite_solutions\>\""}], ",", 
          "\"\<Text\>\""}], "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Quiet", "@", 
      RowBox[{"DeleteDirectory", "[", 
       RowBox[{"instance", ",", 
        RowBox[{"DeleteContents", "\[Rule]", " ", "True"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"solns2", "=", 
      RowBox[{"StringSplit", "[", "solns1", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"solns3", "=", 
      RowBox[{"ToExpression", "[", 
       RowBox[{"StringReplace", "[", 
        RowBox[{"solns2", ",", 
         RowBox[{"\"\<e\>\"", "\[Rule]", "\"\<*10^\>\""}]}], "]"}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"solns4", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"Rest", "[", "solns3", "]"}], ",", 
        RowBox[{"2", "*", "nF"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"solns5", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"#", ",", "2"}], "]"}], "&"}], "/@", "solns4"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"solns6", "=", 
      RowBox[{"Apply", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "+", 
          RowBox[{"#2", "*", "I"}]}], "&"}], ",", "solns5", ",", 
        RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"solns7", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"Thread", "[", 
         RowBox[{"fvars", "\[Rule]", "#"}], "]"}], "&"}], "/@", 
       "solns6"}]}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.826971749396822*^9, 3.826971831896801*^9}, {
   3.826973522939657*^9, 3.8269735233821774`*^9}, {3.827323594730801*^9, 
   3.827323613707602*^9}, {3.8273236681409564`*^9, 3.827323669067852*^9}, {
   3.8273237474284945`*^9, 3.827323819607422*^9}, {3.8273239692456594`*^9, 
   3.8273239711438313`*^9}, 3.8273243573520064`*^9, {3.827324392403702*^9, 
   3.827324479748355*^9}, 3.8273245379137745`*^9, {3.8273245836334286`*^9, 
   3.8273246575750265`*^9}, {3.8273247625033984`*^9, 3.827324803953826*^9}, {
   3.82732484903017*^9, 3.827324850528166*^9}, {3.8273250496735687`*^9, 
   3.8273250630622487`*^9}, {3.8273251186964226`*^9, 3.8273251535545855`*^9}, 
   3.827325194415311*^9, 3.827325368324198*^9, 3.827325582599326*^9, 
   3.8273260387010922`*^9, {3.8273267251632347`*^9, 3.8273267254113812`*^9}, 
   3.827326980236663*^9, {3.827327073443284*^9, 3.827327164408969*^9}, 
   3.827404219690919*^9, 3.8274042629974766`*^9, {3.827404578700965*^9, 
   3.827404586549448*^9}, 3.828066433521822*^9, {3.828066660589308*^9, 
   3.8280666702883368`*^9}, 3.828066911789133*^9, 3.828067053909873*^9, 
   3.8280673048139734`*^9, 3.8280673828840137`*^9, 3.828321908691702*^9, 
   3.8283220461246185`*^9, 3.828387401524789*^9, {3.828387819110676*^9, 
   3.828387834951371*^9}, 3.8283891194837213`*^9, {3.855330635558146*^9, 
   3.8553306381303005`*^9}, 3.8553307848690643`*^9, 3.8553308782468405`*^9, {
   3.85533093241147*^9, 3.8553309416704855`*^9}, {3.855330974858985*^9, 
   3.8553309771682587`*^9}, 3.8553310276450996`*^9, {3.8553310607859187`*^9, 
   3.8553310611964784`*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"325a3288-dad6-46a5-99f0-4b1115254a40"],

Cell["\<\
The following module solves the optimal synthesis of planar four-bar \
mechanism for function generation via parameter homotopy. \
\>", "Text",
 CellChangeTimes->{{3.8283682938703732`*^9, 3.828368377919958*^9}, {
  3.8283684227856226`*^9, 3.8283684284286213`*^9}, {3.8283684596845636`*^9, 
  3.828368605135398*^9}},ExpressionUUID->"235c0da4-3217-4165-9fc2-\
43f137e0d67d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fnGenSolve", "[", 
   RowBox[{"\[Mu]\[Psi]data_", ",", 
    RowBox[{"realTol_", ":", 
     SuperscriptBox["10", 
      RowBox[{"-", "6"}]]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "d", ",", "obj", ",", "dobj", ",", "ddobj", ",", "rm", ",", "s", ",", 
      "t", ",", "u", ",", "v", ",", "c1", ",", "c2", ",", "c3", ",", "c4", 
      ",", "c5", ",", "c6", ",", "c7", ",", "c8", ",", "c9", ",", "c10", ",", 
      "c11", ",", "c12", ",", "c13", ",", "c14", ",", "c15", ",", "c16", ",", 
      "c17", ",", "c18", ",", "c19", ",", "c20", ",", "c21", ",", "c22", ",", 
      "c23", ",", "c24", ",", "c25", ",", "c26", ",", "c27", ",", "c28", ",", 
      "c29", ",", "c30", ",", "c31", ",", "c32", ",", "c33", ",", "c34", ",", 
      "c35", ",", "c36", ",", "c37", ",", "c38", ",", "c39", ",", "c40", ",", 
      "paramSubs", ",", "nsol", ",", "nreals", ",", "nHess"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"d", "=", 
      RowBox[{"{", 
       RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"obj", "=", 
      RowBox[{
       RowBox[{"c40", " ", 
        SuperscriptBox["rm", "2"]}], "+", 
       RowBox[{"c37", " ", "rm", " ", "s"}], "+", 
       RowBox[{"c26", " ", 
        SuperscriptBox["s", "2"]}], "+", 
       RowBox[{"c34", " ", "rm", " ", "t"}], "+", 
       RowBox[{"c20", " ", "s", " ", "t"}], "+", 
       RowBox[{"c9", " ", 
        SuperscriptBox["t", "2"]}], "+", 
       RowBox[{"c33", " ", "rm", " ", "u"}], "+", 
       RowBox[{"c17", " ", "s", " ", "u"}], "+", 
       RowBox[{"c39", " ", "rm", " ", "s", " ", "u"}], "+", 
       RowBox[{"c29", " ", 
        SuperscriptBox["s", "2"], " ", "u"}], "+", 
       RowBox[{"c6", " ", "t", " ", "u"}], "+", 
       RowBox[{"c36", " ", "rm", " ", "t", " ", "u"}], "+", 
       RowBox[{"c23", " ", "s", " ", "t", " ", "u"}], "+", 
       RowBox[{"c12", " ", 
        SuperscriptBox["t", "2"], " ", "u"}], "+", 
       RowBox[{"c3", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"c19", " ", "s", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"c31", " ", 
        SuperscriptBox["s", "2"], " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"c8", " ", "t", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"c25", " ", "s", " ", "t", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"c14", " ", 
        SuperscriptBox["t", "2"], " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"c32", " ", "rm", " ", "v"}], "+", 
       RowBox[{"c15", " ", "s", " ", "v"}], "+", 
       RowBox[{"c38", " ", "rm", " ", "s", " ", "v"}], "+", 
       RowBox[{"c27", " ", 
        SuperscriptBox["s", "2"], " ", "v"}], "+", 
       RowBox[{"c4", " ", "t", " ", "v"}], "+", 
       RowBox[{"c35", " ", "rm", " ", "t", " ", "v"}], "+", 
       RowBox[{"c21", " ", "s", " ", "t", " ", "v"}], "+", 
       RowBox[{"c10", " ", 
        SuperscriptBox["t", "2"], " ", "v"}], "+", 
       RowBox[{"c2", " ", "u", " ", "v"}], "+", 
       RowBox[{"c18", " ", "s", " ", "u", " ", "v"}], "+", 
       RowBox[{"c30", " ", 
        SuperscriptBox["s", "2"], " ", "u", " ", "v"}], "+", 
       RowBox[{"c7", " ", "t", " ", "u", " ", "v"}], "+", 
       RowBox[{"c24", " ", "s", " ", "t", " ", "u", " ", "v"}], "+", 
       RowBox[{"c13", " ", 
        SuperscriptBox["t", "2"], " ", "u", " ", "v"}], "+", 
       RowBox[{"c1", " ", 
        SuperscriptBox["v", "2"]}], "+", 
       RowBox[{"c16", " ", "s", " ", 
        SuperscriptBox["v", "2"]}], "+", 
       RowBox[{"c28", " ", 
        SuperscriptBox["s", "2"], " ", 
        SuperscriptBox["v", "2"]}], "+", 
       RowBox[{"c5", " ", "t", " ", 
        SuperscriptBox["v", "2"]}], "+", 
       RowBox[{"c22", " ", "s", " ", "t", " ", 
        SuperscriptBox["v", "2"]}], "+", 
       RowBox[{"c11", " ", 
        SuperscriptBox["t", "2"], " ", 
        SuperscriptBox["v", "2"]}]}]}], ";", "\n", "    ", 
     RowBox[{"dobj", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"2", " ", "c40", " ", "rm"}], "+", 
         RowBox[{"c37", " ", "s"}], "+", 
         RowBox[{"c34", " ", "t"}], "+", 
         RowBox[{"c33", " ", "u"}], "+", 
         RowBox[{"c39", " ", "s", " ", "u"}], "+", 
         RowBox[{"c36", " ", "t", " ", "u"}], "+", 
         RowBox[{"c32", " ", "v"}], "+", 
         RowBox[{"c38", " ", "s", " ", "v"}], "+", 
         RowBox[{"c35", " ", "t", " ", "v"}]}], ",", 
        RowBox[{
         RowBox[{"c37", " ", "rm"}], "+", 
         RowBox[{"2", " ", "c26", " ", "s"}], "+", 
         RowBox[{"c20", " ", "t"}], "+", 
         RowBox[{"c17", " ", "u"}], "+", 
         RowBox[{"c39", " ", "rm", " ", "u"}], "+", 
         RowBox[{"2", " ", "c29", " ", "s", " ", "u"}], "+", 
         RowBox[{"c23", " ", "t", " ", "u"}], "+", 
         RowBox[{"c19", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"2", " ", "c31", " ", "s", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"c25", " ", "t", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"c15", " ", "v"}], "+", 
         RowBox[{"c38", " ", "rm", " ", "v"}], "+", 
         RowBox[{"2", " ", "c27", " ", "s", " ", "v"}], "+", 
         RowBox[{"c21", " ", "t", " ", "v"}], "+", 
         RowBox[{"c18", " ", "u", " ", "v"}], "+", 
         RowBox[{"2", " ", "c30", " ", "s", " ", "u", " ", "v"}], "+", 
         RowBox[{"c24", " ", "t", " ", "u", " ", "v"}], "+", 
         RowBox[{"c16", " ", 
          SuperscriptBox["v", "2"]}], "+", 
         RowBox[{"2", " ", "c28", " ", "s", " ", 
          SuperscriptBox["v", "2"]}], "+", 
         RowBox[{"c22", " ", "t", " ", 
          SuperscriptBox["v", "2"]}]}], ",", 
        RowBox[{
         RowBox[{"c34", " ", "rm"}], "+", 
         RowBox[{"c20", " ", "s"}], "+", 
         RowBox[{"2", " ", "c9", " ", "t"}], "+", 
         RowBox[{"c6", " ", "u"}], "+", 
         RowBox[{"c36", " ", "rm", " ", "u"}], "+", 
         RowBox[{"c23", " ", "s", " ", "u"}], "+", 
         RowBox[{"2", " ", "c12", " ", "t", " ", "u"}], "+", 
         RowBox[{"c8", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"c25", " ", "s", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"2", " ", "c14", " ", "t", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"c4", " ", "v"}], "+", 
         RowBox[{"c35", " ", "rm", " ", "v"}], "+", 
         RowBox[{"c21", " ", "s", " ", "v"}], "+", 
         RowBox[{"2", " ", "c10", " ", "t", " ", "v"}], "+", 
         RowBox[{"c7", " ", "u", " ", "v"}], "+", 
         RowBox[{"c24", " ", "s", " ", "u", " ", "v"}], "+", 
         RowBox[{"2", " ", "c13", " ", "t", " ", "u", " ", "v"}], "+", 
         RowBox[{"c5", " ", 
          SuperscriptBox["v", "2"]}], "+", 
         RowBox[{"c22", " ", "s", " ", 
          SuperscriptBox["v", "2"]}], "+", 
         RowBox[{"2", " ", "c11", " ", "t", " ", 
          SuperscriptBox["v", "2"]}]}], ",", 
        RowBox[{
         RowBox[{"c33", " ", "rm"}], "+", 
         RowBox[{"c17", " ", "s"}], "+", 
         RowBox[{"c39", " ", "rm", " ", "s"}], "+", 
         RowBox[{"c29", " ", 
          SuperscriptBox["s", "2"]}], "+", 
         RowBox[{"c6", " ", "t"}], "+", 
         RowBox[{"c36", " ", "rm", " ", "t"}], "+", 
         RowBox[{"c23", " ", "s", " ", "t"}], "+", 
         RowBox[{"c12", " ", 
          SuperscriptBox["t", "2"]}], "+", 
         RowBox[{"2", " ", "c3", " ", "u"}], "+", 
         RowBox[{"2", " ", "c19", " ", "s", " ", "u"}], "+", 
         RowBox[{"2", " ", "c31", " ", 
          SuperscriptBox["s", "2"], " ", "u"}], "+", 
         RowBox[{"2", " ", "c8", " ", "t", " ", "u"}], "+", 
         RowBox[{"2", " ", "c25", " ", "s", " ", "t", " ", "u"}], "+", 
         RowBox[{"2", " ", "c14", " ", 
          SuperscriptBox["t", "2"], " ", "u"}], "+", 
         RowBox[{"c2", " ", "v"}], "+", 
         RowBox[{"c18", " ", "s", " ", "v"}], "+", 
         RowBox[{"c30", " ", 
          SuperscriptBox["s", "2"], " ", "v"}], "+", 
         RowBox[{"c7", " ", "t", " ", "v"}], "+", 
         RowBox[{"c24", " ", "s", " ", "t", " ", "v"}], "+", 
         RowBox[{"c13", " ", 
          SuperscriptBox["t", "2"], " ", "v"}]}], ",", 
        RowBox[{
         RowBox[{"c32", " ", "rm"}], "+", 
         RowBox[{"c15", " ", "s"}], "+", 
         RowBox[{"c38", " ", "rm", " ", "s"}], "+", 
         RowBox[{"c27", " ", 
          SuperscriptBox["s", "2"]}], "+", 
         RowBox[{"c4", " ", "t"}], "+", 
         RowBox[{"c35", " ", "rm", " ", "t"}], "+", 
         RowBox[{"c21", " ", "s", " ", "t"}], "+", 
         RowBox[{"c10", " ", 
          SuperscriptBox["t", "2"]}], "+", 
         RowBox[{"c2", " ", "u"}], "+", 
         RowBox[{"c18", " ", "s", " ", "u"}], "+", 
         RowBox[{"c30", " ", 
          SuperscriptBox["s", "2"], " ", "u"}], "+", 
         RowBox[{"c7", " ", "t", " ", "u"}], "+", 
         RowBox[{"c24", " ", "s", " ", "t", " ", "u"}], "+", 
         RowBox[{"c13", " ", 
          SuperscriptBox["t", "2"], " ", "u"}], "+", 
         RowBox[{"2", " ", "c1", " ", "v"}], "+", 
         RowBox[{"2", " ", "c16", " ", "s", " ", "v"}], "+", 
         RowBox[{"2", " ", "c28", " ", 
          SuperscriptBox["s", "2"], " ", "v"}], "+", 
         RowBox[{"2", " ", "c5", " ", "t", " ", "v"}], "+", 
         RowBox[{"2", " ", "c22", " ", "s", " ", "t", " ", "v"}], "+", 
         RowBox[{"2", " ", "c11", " ", 
          SuperscriptBox["t", "2"], " ", "v"}]}]}], "}"}]}], ";", "\n", "   ", 
     RowBox[{"ddobj", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"2", " ", "c40"}], ",", 
          RowBox[{"c37", "+", 
           RowBox[{"c39", " ", "u"}], "+", 
           RowBox[{"c38", " ", "v"}]}], ",", 
          RowBox[{"c34", "+", 
           RowBox[{"c36", " ", "u"}], "+", 
           RowBox[{"c35", " ", "v"}]}], ",", 
          RowBox[{"c33", "+", 
           RowBox[{"c39", " ", "s"}], "+", 
           RowBox[{"c36", " ", "t"}]}], ",", 
          RowBox[{"c32", "+", 
           RowBox[{"c38", " ", "s"}], "+", 
           RowBox[{"c35", " ", "t"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"c37", "+", 
           RowBox[{"c39", " ", "u"}], "+", 
           RowBox[{"c38", " ", "v"}]}], ",", 
          RowBox[{
           RowBox[{"2", " ", "c26"}], "+", 
           RowBox[{"2", " ", "c29", " ", "u"}], "+", 
           RowBox[{"2", " ", "c31", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", "c27", " ", "v"}], "+", 
           RowBox[{"2", " ", "c30", " ", "u", " ", "v"}], "+", 
           RowBox[{"2", " ", "c28", " ", 
            SuperscriptBox["v", "2"]}]}], ",", 
          RowBox[{"c20", "+", 
           RowBox[{"c23", " ", "u"}], "+", 
           RowBox[{"c25", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"c21", " ", "v"}], "+", 
           RowBox[{"c24", " ", "u", " ", "v"}], "+", 
           RowBox[{"c22", " ", 
            SuperscriptBox["v", "2"]}]}], ",", 
          RowBox[{"c17", "+", 
           RowBox[{"c39", " ", "rm"}], "+", 
           RowBox[{"2", " ", "c29", " ", "s"}], "+", 
           RowBox[{"c23", " ", "t"}], "+", 
           RowBox[{"2", " ", "c19", " ", "u"}], "+", 
           RowBox[{"4", " ", "c31", " ", "s", " ", "u"}], "+", 
           RowBox[{"2", " ", "c25", " ", "t", " ", "u"}], "+", 
           RowBox[{"c18", " ", "v"}], "+", 
           RowBox[{"2", " ", "c30", " ", "s", " ", "v"}], "+", 
           RowBox[{"c24", " ", "t", " ", "v"}]}], ",", 
          RowBox[{"c15", "+", 
           RowBox[{"c38", " ", "rm"}], "+", 
           RowBox[{"2", " ", "c27", " ", "s"}], "+", 
           RowBox[{"c21", " ", "t"}], "+", 
           RowBox[{"c18", " ", "u"}], "+", 
           RowBox[{"2", " ", "c30", " ", "s", " ", "u"}], "+", 
           RowBox[{"c24", " ", "t", " ", "u"}], "+", 
           RowBox[{"2", " ", "c16", " ", "v"}], "+", 
           RowBox[{"4", " ", "c28", " ", "s", " ", "v"}], "+", 
           RowBox[{"2", " ", "c22", " ", "t", " ", "v"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"c34", "+", 
           RowBox[{"c36", " ", "u"}], "+", 
           RowBox[{"c35", " ", "v"}]}], ",", 
          RowBox[{"c20", "+", 
           RowBox[{"c23", " ", "u"}], "+", 
           RowBox[{"c25", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"c21", " ", "v"}], "+", 
           RowBox[{"c24", " ", "u", " ", "v"}], "+", 
           RowBox[{"c22", " ", 
            SuperscriptBox["v", "2"]}]}], ",", 
          RowBox[{
           RowBox[{"2", " ", "c9"}], "+", 
           RowBox[{"2", " ", "c12", " ", "u"}], "+", 
           RowBox[{"2", " ", "c14", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", "c10", " ", "v"}], "+", 
           RowBox[{"2", " ", "c13", " ", "u", " ", "v"}], "+", 
           RowBox[{"2", " ", "c11", " ", 
            SuperscriptBox["v", "2"]}]}], ",", 
          RowBox[{"c6", "+", 
           RowBox[{"c36", " ", "rm"}], "+", 
           RowBox[{"c23", " ", "s"}], "+", 
           RowBox[{"2", " ", "c12", " ", "t"}], "+", 
           RowBox[{"2", " ", "c8", " ", "u"}], "+", 
           RowBox[{"2", " ", "c25", " ", "s", " ", "u"}], "+", 
           RowBox[{"4", " ", "c14", " ", "t", " ", "u"}], "+", 
           RowBox[{"c7", " ", "v"}], "+", 
           RowBox[{"c24", " ", "s", " ", "v"}], "+", 
           RowBox[{"2", " ", "c13", " ", "t", " ", "v"}]}], ",", 
          RowBox[{"c4", "+", 
           RowBox[{"c35", " ", "rm"}], "+", 
           RowBox[{"c21", " ", "s"}], "+", 
           RowBox[{"2", " ", "c10", " ", "t"}], "+", 
           RowBox[{"c7", " ", "u"}], "+", 
           RowBox[{"c24", " ", "s", " ", "u"}], "+", 
           RowBox[{"2", " ", "c13", " ", "t", " ", "u"}], "+", 
           RowBox[{"2", " ", "c5", " ", "v"}], "+", 
           RowBox[{"2", " ", "c22", " ", "s", " ", "v"}], "+", 
           RowBox[{"4", " ", "c11", " ", "t", " ", "v"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"c33", "+", 
           RowBox[{"c39", " ", "s"}], "+", 
           RowBox[{"c36", " ", "t"}]}], ",", 
          RowBox[{"c17", "+", 
           RowBox[{"c39", " ", "rm"}], "+", 
           RowBox[{"2", " ", "c29", " ", "s"}], "+", 
           RowBox[{"c23", " ", "t"}], "+", 
           RowBox[{"2", " ", "c19", " ", "u"}], "+", 
           RowBox[{"4", " ", "c31", " ", "s", " ", "u"}], "+", 
           RowBox[{"2", " ", "c25", " ", "t", " ", "u"}], "+", 
           RowBox[{"c18", " ", "v"}], "+", 
           RowBox[{"2", " ", "c30", " ", "s", " ", "v"}], "+", 
           RowBox[{"c24", " ", "t", " ", "v"}]}], ",", 
          RowBox[{"c6", "+", 
           RowBox[{"c36", " ", "rm"}], "+", 
           RowBox[{"c23", " ", "s"}], "+", 
           RowBox[{"2", " ", "c12", " ", "t"}], "+", 
           RowBox[{"2", " ", "c8", " ", "u"}], "+", 
           RowBox[{"2", " ", "c25", " ", "s", " ", "u"}], "+", 
           RowBox[{"4", " ", "c14", " ", "t", " ", "u"}], "+", 
           RowBox[{"c7", " ", "v"}], "+", 
           RowBox[{"c24", " ", "s", " ", "v"}], "+", 
           RowBox[{"2", " ", "c13", " ", "t", " ", "v"}]}], ",", 
          RowBox[{
           RowBox[{"2", " ", "c3"}], "+", 
           RowBox[{"2", " ", "c19", " ", "s"}], "+", 
           RowBox[{"2", " ", "c31", " ", 
            SuperscriptBox["s", "2"]}], "+", 
           RowBox[{"2", " ", "c8", " ", "t"}], "+", 
           RowBox[{"2", " ", "c25", " ", "s", " ", "t"}], "+", 
           RowBox[{"2", " ", "c14", " ", 
            SuperscriptBox["t", "2"]}]}], ",", 
          RowBox[{"c2", "+", 
           RowBox[{"c18", " ", "s"}], "+", 
           RowBox[{"c30", " ", 
            SuperscriptBox["s", "2"]}], "+", 
           RowBox[{"c7", " ", "t"}], "+", 
           RowBox[{"c24", " ", "s", " ", "t"}], "+", 
           RowBox[{"c13", " ", 
            SuperscriptBox["t", "2"]}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"c32", "+", 
           RowBox[{"c38", " ", "s"}], "+", 
           RowBox[{"c35", " ", "t"}]}], ",", 
          RowBox[{"c15", "+", 
           RowBox[{"c38", " ", "rm"}], "+", 
           RowBox[{"2", " ", "c27", " ", "s"}], "+", 
           RowBox[{"c21", " ", "t"}], "+", 
           RowBox[{"c18", " ", "u"}], "+", 
           RowBox[{"2", " ", "c30", " ", "s", " ", "u"}], "+", 
           RowBox[{"c24", " ", "t", " ", "u"}], "+", 
           RowBox[{"2", " ", "c16", " ", "v"}], "+", 
           RowBox[{"4", " ", "c28", " ", "s", " ", "v"}], "+", 
           RowBox[{"2", " ", "c22", " ", "t", " ", "v"}]}], ",", 
          RowBox[{"c4", "+", 
           RowBox[{"c35", " ", "rm"}], "+", 
           RowBox[{"c21", " ", "s"}], "+", 
           RowBox[{"2", " ", "c10", " ", "t"}], "+", 
           RowBox[{"c7", " ", "u"}], "+", 
           RowBox[{"c24", " ", "s", " ", "u"}], "+", 
           RowBox[{"2", " ", "c13", " ", "t", " ", "u"}], "+", 
           RowBox[{"2", " ", "c5", " ", "v"}], "+", 
           RowBox[{"2", " ", "c22", " ", "s", " ", "v"}], "+", 
           RowBox[{"4", " ", "c11", " ", "t", " ", "v"}]}], ",", 
          RowBox[{"c2", "+", 
           RowBox[{"c18", " ", "s"}], "+", 
           RowBox[{"c30", " ", 
            SuperscriptBox["s", "2"]}], "+", 
           RowBox[{"c7", " ", "t"}], "+", 
           RowBox[{"c24", " ", "s", " ", "t"}], "+", 
           RowBox[{"c13", " ", 
            SuperscriptBox["t", "2"]}]}], ",", 
          RowBox[{
           RowBox[{"2", " ", "c1"}], "+", 
           RowBox[{"2", " ", "c16", " ", "s"}], "+", 
           RowBox[{"2", " ", "c28", " ", 
            SuperscriptBox["s", "2"]}], "+", 
           RowBox[{"2", " ", "c5", " ", "t"}], "+", 
           RowBox[{"2", " ", "c22", " ", "s", " ", "t"}], "+", 
           RowBox[{"2", " ", "c11", " ", 
            SuperscriptBox["t", "2"]}]}]}], "}"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"paramSubs", "=", 
      RowBox[{"Inner", "[", 
       RowBox[{"Rule", ",", 
        RowBox[{"{", 
         RowBox[{
         "c1", ",", "c2", ",", "c3", ",", "c4", ",", "c5", ",", "c6", ",", 
          "c7", ",", "c8", ",", "c9", ",", "c10", ",", "c11", ",", "c12", ",",
           "c13", ",", "c14", ",", "c15", ",", "c16", ",", "c17", ",", "c18", 
          ",", "c19", ",", "c20", ",", "c21", ",", "c22", ",", "c23", ",", 
          "c24", ",", "c25", ",", "c26", ",", "c27", ",", "c28", ",", "c29", 
          ",", "c30", ",", "c31", ",", "c32", ",", "c33", ",", "c34", ",", 
          "c35", ",", "c36", ",", "c37", ",", "c38", ",", "c39", ",", "c40"}],
          "}"}], ",", 
        RowBox[{"\[Mu]\[Psi]set", "[", "\[Mu]\[Psi]data", "]"}], ",", 
        "List"}], "]"}]}], ";", "\n", "     ", 
     RowBox[{"nsol", "=", 
      RowBox[{"BSolve", "[", 
       RowBox[{"dobj", ",", "d", ",", "paramSubs"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<Number of solutions found: \>\"", ",", 
       RowBox[{
        RowBox[{"Length", "[", "nsol", "]"}], "+", "1"}], ",", 
       "\"\</25\>\""}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"nreals", "=", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"Chop", "[", 
         RowBox[{
          RowBox[{"Select", "[", 
           RowBox[{"nsol", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Max", "[", 
               RowBox[{"Abs", "[", 
                RowBox[{"Im", "[", 
                 RowBox[{"Values", "[", "#", "]"}], "]"}], "]"}], "]"}], 
              "\[LessEqual]", " ", "realTol"}], " ", "&"}]}], "]"}], ",", 
          "realTol"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"rm", "\[Rule]", " ", "0"}], ",", 
           RowBox[{"s", "\[Rule]", " ", "0"}], ",", 
           RowBox[{"t", "\[Rule]", " ", "0"}], ",", 
           RowBox[{"u", "\[Rule]", " ", "0"}], ",", 
           RowBox[{"v", "\[Rule]", " ", "0"}]}], "}"}], "}"}]}], "]"}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<Number of real solutions: \>\"", ",", 
       RowBox[{"Length", "[", "nreals", "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"nHess", "=", 
      RowBox[{"ddobj", "/.", "paramSubs"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"d", "/.", "nreals"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Eigensystem", "[", 
          RowBox[{"nHess", "/.", "#"}], "]"}], "&"}], "/@", "nreals"}]}], 
      "}"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.826971749396822*^9, 3.826971831896801*^9}, {
   3.826973522939657*^9, 3.8269735233821774`*^9}, {3.827323594730801*^9, 
   3.827323613707602*^9}, {3.8273236681409564`*^9, 3.827323669067852*^9}, {
   3.8273237474284945`*^9, 3.827323819607422*^9}, {3.8273239692456594`*^9, 
   3.8273239711438313`*^9}, 3.8273243573520064`*^9, {3.827324392403702*^9, 
   3.827324479748355*^9}, 3.8273245379137745`*^9, {3.8273245836334286`*^9, 
   3.8273246575750265`*^9}, {3.8273247625033984`*^9, 3.827324803953826*^9}, {
   3.82732484903017*^9, 3.827324850528166*^9}, {3.8273250496735687`*^9, 
   3.8273250630622487`*^9}, {3.8273251186964226`*^9, 3.8273251535545855`*^9}, 
   3.827325194415311*^9, 3.827325368324198*^9, 3.827325582599326*^9, 
   3.8273260387010922`*^9, {3.827326091534787*^9, 3.827326094864216*^9}, {
   3.8283215682621694`*^9, 3.8283216439619966`*^9}, {3.8283216775542746`*^9, 
   3.828321677779956*^9}, {3.828321901474618*^9, 3.8283219148939075`*^9}, 
   3.828322054128033*^9, 3.828368533539321*^9, {3.828397639233016*^9, 
   3.8283976448875055`*^9}, {3.8376963243355775`*^9, 3.837696348109461*^9}, {
   3.8376964022771854`*^9, 3.837696411617146*^9}, {3.83769655041289*^9, 
   3.8376965645339785`*^9}, {3.8376966222188873`*^9, 
   3.8376966309710903`*^9}, {3.837696799394517*^9, 3.837696824005493*^9}, {
   3.8377744523287163`*^9, 3.8377744543894315`*^9}, {3.837774563543273*^9, 
   3.8377745777378893`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"12368e44-75e7-42d8-aff4-44da156b77e4"]
}, Closed]],

Cell[CellGroupData[{

Cell["Saddle-graph construction related modules,", "Chapter",
 CellChangeTimes->{{3.827593327630286*^9, 3.8275933408228884`*^9}, {
  3.85533265456001*^9, 
  3.855332682813342*^9}},ExpressionUUID->"99103943-23f1-40ea-8f60-\
0a6f019ca597"],

Cell["\<\
The following module (compiled version) returns the objective value at any \
given design point.\
\>", "Text",
 CellChangeTimes->{{3.8283702727057667`*^9, 3.8283703006167355`*^9}, {
  3.8284386142157335`*^9, 
  3.828438616505619*^9}},ExpressionUUID->"14618afb-9a9e-4632-b604-\
8ca6aa0b656f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"objF", "=", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Params", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"d", ",", "_Real", ",", "1"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}], "=", 
         "d"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           SuperscriptBox["v", "2"], ",", 
           RowBox[{"u", " ", "v"}], ",", 
           SuperscriptBox["u", "2"], ",", 
           RowBox[{"t", " ", "v"}], ",", 
           RowBox[{"t", " ", 
            SuperscriptBox["v", "2"]}], ",", 
           RowBox[{"t", " ", "u"}], ",", 
           RowBox[{"t", " ", "u", " ", "v"}], ",", 
           RowBox[{"t", " ", 
            SuperscriptBox["u", "2"]}], ",", 
           SuperscriptBox["t", "2"], ",", 
           RowBox[{
            SuperscriptBox["t", "2"], " ", "v"}], ",", 
           RowBox[{
            SuperscriptBox["t", "2"], " ", 
            SuperscriptBox["v", "2"]}], ",", 
           RowBox[{
            SuperscriptBox["t", "2"], " ", "u"}], ",", 
           RowBox[{
            SuperscriptBox["t", "2"], " ", "u", " ", "v"}], ",", 
           RowBox[{
            SuperscriptBox["t", "2"], " ", 
            SuperscriptBox["u", "2"]}], ",", 
           RowBox[{"s", " ", "v"}], ",", 
           RowBox[{"s", " ", 
            SuperscriptBox["v", "2"]}], ",", 
           RowBox[{"s", " ", "u"}], ",", 
           RowBox[{"s", " ", "u", " ", "v"}], ",", 
           RowBox[{"s", " ", 
            SuperscriptBox["u", "2"]}], ",", 
           RowBox[{"s", " ", "t"}], ",", 
           RowBox[{"s", " ", "t", " ", "v"}], ",", 
           RowBox[{"s", " ", "t", " ", 
            SuperscriptBox["v", "2"]}], ",", 
           RowBox[{"s", " ", "t", " ", "u"}], ",", 
           RowBox[{"s", " ", "t", " ", "u", " ", "v"}], ",", 
           RowBox[{"s", " ", "t", " ", 
            SuperscriptBox["u", "2"]}], ",", 
           SuperscriptBox["s", "2"], ",", 
           RowBox[{
            SuperscriptBox["s", "2"], " ", "v"}], ",", 
           RowBox[{
            SuperscriptBox["s", "2"], " ", 
            SuperscriptBox["v", "2"]}], ",", 
           RowBox[{
            SuperscriptBox["s", "2"], " ", "u"}], ",", 
           RowBox[{
            SuperscriptBox["s", "2"], " ", "u", " ", "v"}], ",", 
           RowBox[{
            SuperscriptBox["s", "2"], " ", 
            SuperscriptBox["u", "2"]}], ",", 
           RowBox[{"rm", " ", "v"}], ",", 
           RowBox[{"rm", " ", "u"}], ",", 
           RowBox[{"rm", " ", "t"}], ",", 
           RowBox[{"rm", " ", "t", " ", "v"}], ",", 
           RowBox[{"rm", " ", "t", " ", "u"}], ",", 
           RowBox[{"rm", " ", "s"}], ",", 
           RowBox[{"rm", " ", "s", " ", "v"}], ",", 
           RowBox[{"rm", " ", "s", " ", "u"}], ",", 
           SuperscriptBox["rm", "2"]}], "}"}], ".", "Params"}]}]}], 
      "\[IndentingNewLine]", "]"}], ",", 
     RowBox[{"CompilationOptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<InlineExternalDefinitions\>\"", "\[Rule]", "True"}], 
       "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.827591555069127*^9, 3.827591557471429*^9}, {
   3.827591654136261*^9, 3.827591689216162*^9}, {3.8275917571800847`*^9, 
   3.827591778408144*^9}, {3.827591930401635*^9, 3.8275919450055647`*^9}, {
   3.827591975630489*^9, 3.8275919810494614`*^9}, {3.82759670911722*^9, 
   3.8275967092412186`*^9}, {3.827857800029931*^9, 3.8278578007361565`*^9}, 
   3.8280639834131036`*^9, {3.8283219303082576`*^9, 3.8283219418123903`*^9}, 
   3.828368718101243*^9, {3.8283693075375566`*^9, 3.82836930899765*^9}, 
   3.8283700726124353`*^9, {3.8283702597753677`*^9, 3.8283702623121614`*^9}, {
   3.8283703280297403`*^9, 3.8283703377990255`*^9}, {3.828438604663237*^9, 
   3.8284386210312757`*^9}, {3.828438670323047*^9, 3.828438711970595*^9}, {
   3.828447276865554*^9, 3.8284473021771326`*^9}, {3.8284473356559277`*^9, 
   3.828447345007321*^9}, {3.8553972377719665`*^9, 3.855397239957406*^9}, 
   3.8553974971114674`*^9},
 CellLabel->"In[5]:=",ExpressionUUID->"d36edbc9-17a7-4a56-bf50-91f3069d65c4"],

Cell["\<\
The following module (compiled version) returns the gradient descent \
direction at any given design point.\
\>", "Text",
 CellChangeTimes->{{3.8283702727057667`*^9, 
  3.8283703006167355`*^9}},ExpressionUUID->"4d8c01fb-c257-48e2-82be-\
cfaa2f3dcd8f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"gradF", "=", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Params", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"q", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"d", ",", "_Real", ",", "1"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "rm", ",", "s", ",", "t", ",", "u", ",", "v", ",", "c1", ",", "c2", 
         ",", "c3", ",", "c4", ",", "c5", ",", "c6", ",", "c7", ",", "c8", 
         ",", "c9", ",", "c10", ",", "c11", ",", "c12", ",", "c13", ",", 
         "c14", ",", "c15", ",", "c16", ",", "c17", ",", "c18", ",", "c19", 
         ",", "c20", ",", "c21", ",", "c22", ",", "c23", ",", "c24", ",", 
         "c25", ",", "c26", ",", "c27", ",", "c28", ",", "c29", ",", "c30", 
         ",", "c31", ",", "c32", ",", "c33", ",", "c34", ",", "c35", ",", 
         "c36", ",", "c37", ",", "c38", ",", "c39", ",", "c40"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "c1", ",", "c2", ",", "c3", ",", "c4", ",", "c5", ",", "c6", ",", 
           "c7", ",", "c8", ",", "c9", ",", "c10", ",", "c11", ",", "c12", 
           ",", "c13", ",", "c14", ",", "c15", ",", "c16", ",", "c17", ",", 
           "c18", ",", "c19", ",", "c20", ",", "c21", ",", "c22", ",", "c23", 
           ",", "c24", ",", "c25", ",", "c26", ",", "c27", ",", "c28", ",", 
           "c29", ",", "c30", ",", "c31", ",", "c32", ",", "c33", ",", "c34", 
           ",", "c35", ",", "c36", ",", "c37", ",", "c38", ",", "c39", ",", 
           "c40"}], "}"}], "=", "Params"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}], "=", 
         "d"}], ";", "\[IndentingNewLine]", 
        RowBox[{"-", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"2", " ", "c40", " ", "rm"}], "+", 
            RowBox[{"c37", " ", "s"}], "+", 
            RowBox[{"c34", " ", "t"}], "+", 
            RowBox[{"c33", " ", "u"}], "+", 
            RowBox[{"c39", " ", "s", " ", "u"}], "+", 
            RowBox[{"c36", " ", "t", " ", "u"}], "+", 
            RowBox[{"c32", " ", "v"}], "+", 
            RowBox[{"c38", " ", "s", " ", "v"}], "+", 
            RowBox[{"c35", " ", "t", " ", "v"}]}], ",", 
           RowBox[{
            RowBox[{"c37", " ", "rm"}], "+", 
            RowBox[{"2", " ", "c26", " ", "s"}], "+", 
            RowBox[{"c20", " ", "t"}], "+", 
            RowBox[{"c17", " ", "u"}], "+", 
            RowBox[{"c39", " ", "rm", " ", "u"}], "+", 
            RowBox[{"2", " ", "c29", " ", "s", " ", "u"}], "+", 
            RowBox[{"c23", " ", "t", " ", "u"}], "+", 
            RowBox[{"c19", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"2", " ", "c31", " ", "s", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"c25", " ", "t", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"c15", " ", "v"}], "+", 
            RowBox[{"c38", " ", "rm", " ", "v"}], "+", 
            RowBox[{"2", " ", "c27", " ", "s", " ", "v"}], "+", 
            RowBox[{"c21", " ", "t", " ", "v"}], "+", 
            RowBox[{"c18", " ", "u", " ", "v"}], "+", 
            RowBox[{"2", " ", "c30", " ", "s", " ", "u", " ", "v"}], "+", 
            RowBox[{"c24", " ", "t", " ", "u", " ", "v"}], "+", 
            RowBox[{"c16", " ", 
             SuperscriptBox["v", "2"]}], "+", 
            RowBox[{"2", " ", "c28", " ", "s", " ", 
             SuperscriptBox["v", "2"]}], "+", 
            RowBox[{"c22", " ", "t", " ", 
             SuperscriptBox["v", "2"]}]}], ",", 
           RowBox[{
            RowBox[{"c34", " ", "rm"}], "+", 
            RowBox[{"c20", " ", "s"}], "+", 
            RowBox[{"2", " ", "c9", " ", "t"}], "+", 
            RowBox[{"c6", " ", "u"}], "+", 
            RowBox[{"c36", " ", "rm", " ", "u"}], "+", 
            RowBox[{"c23", " ", "s", " ", "u"}], "+", 
            RowBox[{"2", " ", "c12", " ", "t", " ", "u"}], "+", 
            RowBox[{"c8", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"c25", " ", "s", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"2", " ", "c14", " ", "t", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"c4", " ", "v"}], "+", 
            RowBox[{"c35", " ", "rm", " ", "v"}], "+", 
            RowBox[{"c21", " ", "s", " ", "v"}], "+", 
            RowBox[{"2", " ", "c10", " ", "t", " ", "v"}], "+", 
            RowBox[{"c7", " ", "u", " ", "v"}], "+", 
            RowBox[{"c24", " ", "s", " ", "u", " ", "v"}], "+", 
            RowBox[{"2", " ", "c13", " ", "t", " ", "u", " ", "v"}], "+", 
            RowBox[{"c5", " ", 
             SuperscriptBox["v", "2"]}], "+", 
            RowBox[{"c22", " ", "s", " ", 
             SuperscriptBox["v", "2"]}], "+", 
            RowBox[{"2", " ", "c11", " ", "t", " ", 
             SuperscriptBox["v", "2"]}]}], ",", 
           RowBox[{
            RowBox[{"c33", " ", "rm"}], "+", 
            RowBox[{"c17", " ", "s"}], "+", 
            RowBox[{"c39", " ", "rm", " ", "s"}], "+", 
            RowBox[{"c29", " ", 
             SuperscriptBox["s", "2"]}], "+", 
            RowBox[{"c6", " ", "t"}], "+", 
            RowBox[{"c36", " ", "rm", " ", "t"}], "+", 
            RowBox[{"c23", " ", "s", " ", "t"}], "+", 
            RowBox[{"c12", " ", 
             SuperscriptBox["t", "2"]}], "+", 
            RowBox[{"2", " ", "c3", " ", "u"}], "+", 
            RowBox[{"2", " ", "c19", " ", "s", " ", "u"}], "+", 
            RowBox[{"2", " ", "c31", " ", 
             SuperscriptBox["s", "2"], " ", "u"}], "+", 
            RowBox[{"2", " ", "c8", " ", "t", " ", "u"}], "+", 
            RowBox[{"2", " ", "c25", " ", "s", " ", "t", " ", "u"}], "+", 
            RowBox[{"2", " ", "c14", " ", 
             SuperscriptBox["t", "2"], " ", "u"}], "+", 
            RowBox[{"c2", " ", "v"}], "+", 
            RowBox[{"c18", " ", "s", " ", "v"}], "+", 
            RowBox[{"c30", " ", 
             SuperscriptBox["s", "2"], " ", "v"}], "+", 
            RowBox[{"c7", " ", "t", " ", "v"}], "+", 
            RowBox[{"c24", " ", "s", " ", "t", " ", "v"}], "+", 
            RowBox[{"c13", " ", 
             SuperscriptBox["t", "2"], " ", "v"}]}], ",", 
           RowBox[{
            RowBox[{"c32", " ", "rm"}], "+", 
            RowBox[{"c15", " ", "s"}], "+", 
            RowBox[{"c38", " ", "rm", " ", "s"}], "+", 
            RowBox[{"c27", " ", 
             SuperscriptBox["s", "2"]}], "+", 
            RowBox[{"c4", " ", "t"}], "+", 
            RowBox[{"c35", " ", "rm", " ", "t"}], "+", 
            RowBox[{"c21", " ", "s", " ", "t"}], "+", 
            RowBox[{"c10", " ", 
             SuperscriptBox["t", "2"]}], "+", 
            RowBox[{"c2", " ", "u"}], "+", 
            RowBox[{"c18", " ", "s", " ", "u"}], "+", 
            RowBox[{"c30", " ", 
             SuperscriptBox["s", "2"], " ", "u"}], "+", 
            RowBox[{"c7", " ", "t", " ", "u"}], "+", 
            RowBox[{"c24", " ", "s", " ", "t", " ", "u"}], "+", 
            RowBox[{"c13", " ", 
             SuperscriptBox["t", "2"], " ", "u"}], "+", 
            RowBox[{"2", " ", "c1", " ", "v"}], "+", 
            RowBox[{"2", " ", "c16", " ", "s", " ", "v"}], "+", 
            RowBox[{"2", " ", "c28", " ", 
             SuperscriptBox["s", "2"], " ", "v"}], "+", 
            RowBox[{"2", " ", "c5", " ", "t", " ", "v"}], "+", 
            RowBox[{"2", " ", "c22", " ", "s", " ", "t", " ", "v"}], "+", 
            RowBox[{"2", " ", "c11", " ", 
             SuperscriptBox["t", "2"], " ", "v"}]}]}], "}"}]}]}]}], 
      "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ",", 
     RowBox[{"CompilationOptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<InlineExternalDefinitions\>\"", "\[Rule]", "True"}], 
       "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"gradFHelper", "[", 
   RowBox[{"Params_", ",", 
    RowBox[{"q_", "?", "NumericQ"}], ",", 
    RowBox[{"d_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"VectorQ", "[", 
        RowBox[{"#", ",", "NumericQ"}], "]"}], "&"}], ")"}]}]}], "]"}], ":=", 
  RowBox[{"gradF", "[", 
   RowBox[{"Params", ",", "q", ",", "d"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.827591555069127*^9, 3.827591557471429*^9}, {
   3.827591654136261*^9, 3.827591689216162*^9}, {3.8275917571800847`*^9, 
   3.827591778408144*^9}, {3.827591930401635*^9, 3.8275919450055647`*^9}, {
   3.827591975630489*^9, 3.8275919810494614`*^9}, {3.82759670911722*^9, 
   3.8275967092412186`*^9}, {3.827857800029931*^9, 3.8278578007361565`*^9}, 
   3.8280639834131036`*^9, {3.8283219303082576`*^9, 3.8283219418123903`*^9}, 
   3.828368718101243*^9, {3.8283693075375566`*^9, 3.82836930899765*^9}, 
   3.8283700726124353`*^9, {3.8283702597753677`*^9, 3.8283702623121614`*^9}, {
   3.8283703280297403`*^9, 3.8283703377990255`*^9}, {3.855397246058662*^9, 
   3.855397249805395*^9}, {3.855397500924387*^9, 3.8553975011076064`*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"361c528a-fa78-4eae-a447-10adf2f2033c"],

Cell["\<\
The following module (uncompiled version) returns the gradient descent \
direction at any given design point.\
\>", "Text",
 CellChangeTimes->{{3.8283686303106747`*^9, 3.8283686735357184`*^9}, 
   3.828369215977583*^9, {3.828370303354953*^9, 
   3.828370308960043*^9}},ExpressionUUID->"fac5ee04-77e5-407d-afcd-\
1e3e702f42a6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"gradFun", "[", 
    RowBox[{"Params_", ",", "q_", ",", "d_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "rm", ",", "s", ",", "t", ",", "u", ",", "v", ",", "c1", ",", "c2", ",",
        "c3", ",", "c4", ",", "c5", ",", "c6", ",", "c7", ",", "c8", ",", 
       "c9", ",", "c10", ",", "c11", ",", "c12", ",", "c13", ",", "c14", ",", 
       "c15", ",", "c16", ",", "c17", ",", "c18", ",", "c19", ",", "c20", ",",
        "c21", ",", "c22", ",", "c23", ",", "c24", ",", "c25", ",", "c26", 
       ",", "c27", ",", "c28", ",", "c29", ",", "c30", ",", "c31", ",", "c32",
        ",", "c33", ",", "c34", ",", "c35", ",", "c36", ",", "c37", ",", 
       "c38", ",", "c39", ",", "c40"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "c1", ",", "c2", ",", "c3", ",", "c4", ",", "c5", ",", "c6", ",", 
         "c7", ",", "c8", ",", "c9", ",", "c10", ",", "c11", ",", "c12", ",", 
         "c13", ",", "c14", ",", "c15", ",", "c16", ",", "c17", ",", "c18", 
         ",", "c19", ",", "c20", ",", "c21", ",", "c22", ",", "c23", ",", 
         "c24", ",", "c25", ",", "c26", ",", "c27", ",", "c28", ",", "c29", 
         ",", "c30", ",", "c31", ",", "c32", ",", "c33", ",", "c34", ",", 
         "c35", ",", "c36", ",", "c37", ",", "c38", ",", "c39", ",", "c40"}], 
        "}"}], "=", "Params"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}], "=", 
       "d"}], ";", "\[IndentingNewLine]", 
      RowBox[{"-", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"2", " ", "c40", " ", "rm"}], "+", 
          RowBox[{"c37", " ", "s"}], "+", 
          RowBox[{"c34", " ", "t"}], "+", 
          RowBox[{"c33", " ", "u"}], "+", 
          RowBox[{"c39", " ", "s", " ", "u"}], "+", 
          RowBox[{"c36", " ", "t", " ", "u"}], "+", 
          RowBox[{"c32", " ", "v"}], "+", 
          RowBox[{"c38", " ", "s", " ", "v"}], "+", 
          RowBox[{"c35", " ", "t", " ", "v"}]}], ",", 
         RowBox[{
          RowBox[{"c37", " ", "rm"}], "+", 
          RowBox[{"2", " ", "c26", " ", "s"}], "+", 
          RowBox[{"c20", " ", "t"}], "+", 
          RowBox[{"c17", " ", "u"}], "+", 
          RowBox[{"c39", " ", "rm", " ", "u"}], "+", 
          RowBox[{"2", " ", "c29", " ", "s", " ", "u"}], "+", 
          RowBox[{"c23", " ", "t", " ", "u"}], "+", 
          RowBox[{"c19", " ", 
           SuperscriptBox["u", "2"]}], "+", 
          RowBox[{"2", " ", "c31", " ", "s", " ", 
           SuperscriptBox["u", "2"]}], "+", 
          RowBox[{"c25", " ", "t", " ", 
           SuperscriptBox["u", "2"]}], "+", 
          RowBox[{"c15", " ", "v"}], "+", 
          RowBox[{"c38", " ", "rm", " ", "v"}], "+", 
          RowBox[{"2", " ", "c27", " ", "s", " ", "v"}], "+", 
          RowBox[{"c21", " ", "t", " ", "v"}], "+", 
          RowBox[{"c18", " ", "u", " ", "v"}], "+", 
          RowBox[{"2", " ", "c30", " ", "s", " ", "u", " ", "v"}], "+", 
          RowBox[{"c24", " ", "t", " ", "u", " ", "v"}], "+", 
          RowBox[{"c16", " ", 
           SuperscriptBox["v", "2"]}], "+", 
          RowBox[{"2", " ", "c28", " ", "s", " ", 
           SuperscriptBox["v", "2"]}], "+", 
          RowBox[{"c22", " ", "t", " ", 
           SuperscriptBox["v", "2"]}]}], ",", 
         RowBox[{
          RowBox[{"c34", " ", "rm"}], "+", 
          RowBox[{"c20", " ", "s"}], "+", 
          RowBox[{"2", " ", "c9", " ", "t"}], "+", 
          RowBox[{"c6", " ", "u"}], "+", 
          RowBox[{"c36", " ", "rm", " ", "u"}], "+", 
          RowBox[{"c23", " ", "s", " ", "u"}], "+", 
          RowBox[{"2", " ", "c12", " ", "t", " ", "u"}], "+", 
          RowBox[{"c8", " ", 
           SuperscriptBox["u", "2"]}], "+", 
          RowBox[{"c25", " ", "s", " ", 
           SuperscriptBox["u", "2"]}], "+", 
          RowBox[{"2", " ", "c14", " ", "t", " ", 
           SuperscriptBox["u", "2"]}], "+", 
          RowBox[{"c4", " ", "v"}], "+", 
          RowBox[{"c35", " ", "rm", " ", "v"}], "+", 
          RowBox[{"c21", " ", "s", " ", "v"}], "+", 
          RowBox[{"2", " ", "c10", " ", "t", " ", "v"}], "+", 
          RowBox[{"c7", " ", "u", " ", "v"}], "+", 
          RowBox[{"c24", " ", "s", " ", "u", " ", "v"}], "+", 
          RowBox[{"2", " ", "c13", " ", "t", " ", "u", " ", "v"}], "+", 
          RowBox[{"c5", " ", 
           SuperscriptBox["v", "2"]}], "+", 
          RowBox[{"c22", " ", "s", " ", 
           SuperscriptBox["v", "2"]}], "+", 
          RowBox[{"2", " ", "c11", " ", "t", " ", 
           SuperscriptBox["v", "2"]}]}], ",", 
         RowBox[{
          RowBox[{"c33", " ", "rm"}], "+", 
          RowBox[{"c17", " ", "s"}], "+", 
          RowBox[{"c39", " ", "rm", " ", "s"}], "+", 
          RowBox[{"c29", " ", 
           SuperscriptBox["s", "2"]}], "+", 
          RowBox[{"c6", " ", "t"}], "+", 
          RowBox[{"c36", " ", "rm", " ", "t"}], "+", 
          RowBox[{"c23", " ", "s", " ", "t"}], "+", 
          RowBox[{"c12", " ", 
           SuperscriptBox["t", "2"]}], "+", 
          RowBox[{"2", " ", "c3", " ", "u"}], "+", 
          RowBox[{"2", " ", "c19", " ", "s", " ", "u"}], "+", 
          RowBox[{"2", " ", "c31", " ", 
           SuperscriptBox["s", "2"], " ", "u"}], "+", 
          RowBox[{"2", " ", "c8", " ", "t", " ", "u"}], "+", 
          RowBox[{"2", " ", "c25", " ", "s", " ", "t", " ", "u"}], "+", 
          RowBox[{"2", " ", "c14", " ", 
           SuperscriptBox["t", "2"], " ", "u"}], "+", 
          RowBox[{"c2", " ", "v"}], "+", 
          RowBox[{"c18", " ", "s", " ", "v"}], "+", 
          RowBox[{"c30", " ", 
           SuperscriptBox["s", "2"], " ", "v"}], "+", 
          RowBox[{"c7", " ", "t", " ", "v"}], "+", 
          RowBox[{"c24", " ", "s", " ", "t", " ", "v"}], "+", 
          RowBox[{"c13", " ", 
           SuperscriptBox["t", "2"], " ", "v"}]}], ",", 
         RowBox[{
          RowBox[{"c32", " ", "rm"}], "+", 
          RowBox[{"c15", " ", "s"}], "+", 
          RowBox[{"c38", " ", "rm", " ", "s"}], "+", 
          RowBox[{"c27", " ", 
           SuperscriptBox["s", "2"]}], "+", 
          RowBox[{"c4", " ", "t"}], "+", 
          RowBox[{"c35", " ", "rm", " ", "t"}], "+", 
          RowBox[{"c21", " ", "s", " ", "t"}], "+", 
          RowBox[{"c10", " ", 
           SuperscriptBox["t", "2"]}], "+", 
          RowBox[{"c2", " ", "u"}], "+", 
          RowBox[{"c18", " ", "s", " ", "u"}], "+", 
          RowBox[{"c30", " ", 
           SuperscriptBox["s", "2"], " ", "u"}], "+", 
          RowBox[{"c7", " ", "t", " ", "u"}], "+", 
          RowBox[{"c24", " ", "s", " ", "t", " ", "u"}], "+", 
          RowBox[{"c13", " ", 
           SuperscriptBox["t", "2"], " ", "u"}], "+", 
          RowBox[{"2", " ", "c1", " ", "v"}], "+", 
          RowBox[{"2", " ", "c16", " ", "s", " ", "v"}], "+", 
          RowBox[{"2", " ", "c28", " ", 
           SuperscriptBox["s", "2"], " ", "v"}], "+", 
          RowBox[{"2", " ", "c5", " ", "t", " ", "v"}], "+", 
          RowBox[{"2", " ", "c22", " ", "s", " ", "t", " ", "v"}], "+", 
          RowBox[{"2", " ", "c11", " ", 
           SuperscriptBox["t", "2"], " ", "v"}]}]}], "}"}]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.828059351027625*^9, 3.828059405865055*^9}, 
   3.8283219612188964`*^9, 3.8553972575488415`*^9},
 CellLabel->"In[8]:=",ExpressionUUID->"aec2eb4b-3001-4f1a-abb7-6394121e00bf"],

Cell["\<\
The following module (compiled version) returns the Hessian information at \
any given design point.\
\>", "Text",
 CellChangeTimes->{{3.8283702727057667`*^9, 3.8283703006167355`*^9}, {
  3.8407011308600993`*^9, 
  3.840701135062838*^9}},ExpressionUUID->"9f9839e8-505a-4e48-b437-\
01ccf7326a7b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"hessF", "=", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Params", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"d", ",", "_Real", ",", "1"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "rm", ",", "s", ",", "t", ",", "u", ",", "v", ",", "c1", ",", "c2", 
         ",", "c3", ",", "c4", ",", "c5", ",", "c6", ",", "c7", ",", "c8", 
         ",", "c9", ",", "c10", ",", "c11", ",", "c12", ",", "c13", ",", 
         "c14", ",", "c15", ",", "c16", ",", "c17", ",", "c18", ",", "c19", 
         ",", "c20", ",", "c21", ",", "c22", ",", "c23", ",", "c24", ",", 
         "c25", ",", "c26", ",", "c27", ",", "c28", ",", "c29", ",", "c30", 
         ",", "c31", ",", "c32", ",", "c33", ",", "c34", ",", "c35", ",", 
         "c36", ",", "c37", ",", "c38", ",", "c39", ",", "c40"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "c1", ",", "c2", ",", "c3", ",", "c4", ",", "c5", ",", "c6", ",", 
           "c7", ",", "c8", ",", "c9", ",", "c10", ",", "c11", ",", "c12", 
           ",", "c13", ",", "c14", ",", "c15", ",", "c16", ",", "c17", ",", 
           "c18", ",", "c19", ",", "c20", ",", "c21", ",", "c22", ",", "c23", 
           ",", "c24", ",", "c25", ",", "c26", ",", "c27", ",", "c28", ",", 
           "c29", ",", "c30", ",", "c31", ",", "c32", ",", "c33", ",", "c34", 
           ",", "c35", ",", "c36", ",", "c37", ",", "c38", ",", "c39", ",", 
           "c40"}], "}"}], "=", "Params"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}], "=", 
         "d"}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"2", " ", "c40"}], ",", 
            RowBox[{"c37", "+", 
             RowBox[{"c39", " ", "u"}], "+", 
             RowBox[{"c38", " ", "v"}]}], ",", 
            RowBox[{"c34", "+", 
             RowBox[{"c36", " ", "u"}], "+", 
             RowBox[{"c35", " ", "v"}]}], ",", 
            RowBox[{"c33", "+", 
             RowBox[{"c39", " ", "s"}], "+", 
             RowBox[{"c36", " ", "t"}]}], ",", 
            RowBox[{"c32", "+", 
             RowBox[{"c38", " ", "s"}], "+", 
             RowBox[{"c35", " ", "t"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"c37", "+", 
             RowBox[{"c39", " ", "u"}], "+", 
             RowBox[{"c38", " ", "v"}]}], ",", 
            RowBox[{
             RowBox[{"2", " ", "c26"}], "+", 
             RowBox[{"2", " ", "c29", " ", "u"}], "+", 
             RowBox[{"2", " ", "c31", " ", 
              SuperscriptBox["u", "2"]}], "+", 
             RowBox[{"2", " ", "c27", " ", "v"}], "+", 
             RowBox[{"2", " ", "c30", " ", "u", " ", "v"}], "+", 
             RowBox[{"2", " ", "c28", " ", 
              SuperscriptBox["v", "2"]}]}], ",", 
            RowBox[{"c20", "+", 
             RowBox[{"c23", " ", "u"}], "+", 
             RowBox[{"c25", " ", 
              SuperscriptBox["u", "2"]}], "+", 
             RowBox[{"c21", " ", "v"}], "+", 
             RowBox[{"c24", " ", "u", " ", "v"}], "+", 
             RowBox[{"c22", " ", 
              SuperscriptBox["v", "2"]}]}], ",", 
            RowBox[{"c17", "+", 
             RowBox[{"c39", " ", "rm"}], "+", 
             RowBox[{"2", " ", "c29", " ", "s"}], "+", 
             RowBox[{"c23", " ", "t"}], "+", 
             RowBox[{"2", " ", "c19", " ", "u"}], "+", 
             RowBox[{"4", " ", "c31", " ", "s", " ", "u"}], "+", 
             RowBox[{"2", " ", "c25", " ", "t", " ", "u"}], "+", 
             RowBox[{"c18", " ", "v"}], "+", 
             RowBox[{"2", " ", "c30", " ", "s", " ", "v"}], "+", 
             RowBox[{"c24", " ", "t", " ", "v"}]}], ",", 
            RowBox[{"c15", "+", 
             RowBox[{"c38", " ", "rm"}], "+", 
             RowBox[{"2", " ", "c27", " ", "s"}], "+", 
             RowBox[{"c21", " ", "t"}], "+", 
             RowBox[{"c18", " ", "u"}], "+", 
             RowBox[{"2", " ", "c30", " ", "s", " ", "u"}], "+", 
             RowBox[{"c24", " ", "t", " ", "u"}], "+", 
             RowBox[{"2", " ", "c16", " ", "v"}], "+", 
             RowBox[{"4", " ", "c28", " ", "s", " ", "v"}], "+", 
             RowBox[{"2", " ", "c22", " ", "t", " ", "v"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"c34", "+", 
             RowBox[{"c36", " ", "u"}], "+", 
             RowBox[{"c35", " ", "v"}]}], ",", 
            RowBox[{"c20", "+", 
             RowBox[{"c23", " ", "u"}], "+", 
             RowBox[{"c25", " ", 
              SuperscriptBox["u", "2"]}], "+", 
             RowBox[{"c21", " ", "v"}], "+", 
             RowBox[{"c24", " ", "u", " ", "v"}], "+", 
             RowBox[{"c22", " ", 
              SuperscriptBox["v", "2"]}]}], ",", 
            RowBox[{
             RowBox[{"2", " ", "c9"}], "+", 
             RowBox[{"2", " ", "c12", " ", "u"}], "+", 
             RowBox[{"2", " ", "c14", " ", 
              SuperscriptBox["u", "2"]}], "+", 
             RowBox[{"2", " ", "c10", " ", "v"}], "+", 
             RowBox[{"2", " ", "c13", " ", "u", " ", "v"}], "+", 
             RowBox[{"2", " ", "c11", " ", 
              SuperscriptBox["v", "2"]}]}], ",", 
            RowBox[{"c6", "+", 
             RowBox[{"c36", " ", "rm"}], "+", 
             RowBox[{"c23", " ", "s"}], "+", 
             RowBox[{"2", " ", "c12", " ", "t"}], "+", 
             RowBox[{"2", " ", "c8", " ", "u"}], "+", 
             RowBox[{"2", " ", "c25", " ", "s", " ", "u"}], "+", 
             RowBox[{"4", " ", "c14", " ", "t", " ", "u"}], "+", 
             RowBox[{"c7", " ", "v"}], "+", 
             RowBox[{"c24", " ", "s", " ", "v"}], "+", 
             RowBox[{"2", " ", "c13", " ", "t", " ", "v"}]}], ",", 
            RowBox[{"c4", "+", 
             RowBox[{"c35", " ", "rm"}], "+", 
             RowBox[{"c21", " ", "s"}], "+", 
             RowBox[{"2", " ", "c10", " ", "t"}], "+", 
             RowBox[{"c7", " ", "u"}], "+", 
             RowBox[{"c24", " ", "s", " ", "u"}], "+", 
             RowBox[{"2", " ", "c13", " ", "t", " ", "u"}], "+", 
             RowBox[{"2", " ", "c5", " ", "v"}], "+", 
             RowBox[{"2", " ", "c22", " ", "s", " ", "v"}], "+", 
             RowBox[{"4", " ", "c11", " ", "t", " ", "v"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"c33", "+", 
             RowBox[{"c39", " ", "s"}], "+", 
             RowBox[{"c36", " ", "t"}]}], ",", 
            RowBox[{"c17", "+", 
             RowBox[{"c39", " ", "rm"}], "+", 
             RowBox[{"2", " ", "c29", " ", "s"}], "+", 
             RowBox[{"c23", " ", "t"}], "+", 
             RowBox[{"2", " ", "c19", " ", "u"}], "+", 
             RowBox[{"4", " ", "c31", " ", "s", " ", "u"}], "+", 
             RowBox[{"2", " ", "c25", " ", "t", " ", "u"}], "+", 
             RowBox[{"c18", " ", "v"}], "+", 
             RowBox[{"2", " ", "c30", " ", "s", " ", "v"}], "+", 
             RowBox[{"c24", " ", "t", " ", "v"}]}], ",", 
            RowBox[{"c6", "+", 
             RowBox[{"c36", " ", "rm"}], "+", 
             RowBox[{"c23", " ", "s"}], "+", 
             RowBox[{"2", " ", "c12", " ", "t"}], "+", 
             RowBox[{"2", " ", "c8", " ", "u"}], "+", 
             RowBox[{"2", " ", "c25", " ", "s", " ", "u"}], "+", 
             RowBox[{"4", " ", "c14", " ", "t", " ", "u"}], "+", 
             RowBox[{"c7", " ", "v"}], "+", 
             RowBox[{"c24", " ", "s", " ", "v"}], "+", 
             RowBox[{"2", " ", "c13", " ", "t", " ", "v"}]}], ",", 
            RowBox[{
             RowBox[{"2", " ", "c3"}], "+", 
             RowBox[{"2", " ", "c19", " ", "s"}], "+", 
             RowBox[{"2", " ", "c31", " ", 
              SuperscriptBox["s", "2"]}], "+", 
             RowBox[{"2", " ", "c8", " ", "t"}], "+", 
             RowBox[{"2", " ", "c25", " ", "s", " ", "t"}], "+", 
             RowBox[{"2", " ", "c14", " ", 
              SuperscriptBox["t", "2"]}]}], ",", 
            RowBox[{"c2", "+", 
             RowBox[{"c18", " ", "s"}], "+", 
             RowBox[{"c30", " ", 
              SuperscriptBox["s", "2"]}], "+", 
             RowBox[{"c7", " ", "t"}], "+", 
             RowBox[{"c24", " ", "s", " ", "t"}], "+", 
             RowBox[{"c13", " ", 
              SuperscriptBox["t", "2"]}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"c32", "+", 
             RowBox[{"c38", " ", "s"}], "+", 
             RowBox[{"c35", " ", "t"}]}], ",", 
            RowBox[{"c15", "+", 
             RowBox[{"c38", " ", "rm"}], "+", 
             RowBox[{"2", " ", "c27", " ", "s"}], "+", 
             RowBox[{"c21", " ", "t"}], "+", 
             RowBox[{"c18", " ", "u"}], "+", 
             RowBox[{"2", " ", "c30", " ", "s", " ", "u"}], "+", 
             RowBox[{"c24", " ", "t", " ", "u"}], "+", 
             RowBox[{"2", " ", "c16", " ", "v"}], "+", 
             RowBox[{"4", " ", "c28", " ", "s", " ", "v"}], "+", 
             RowBox[{"2", " ", "c22", " ", "t", " ", "v"}]}], ",", 
            RowBox[{"c4", "+", 
             RowBox[{"c35", " ", "rm"}], "+", 
             RowBox[{"c21", " ", "s"}], "+", 
             RowBox[{"2", " ", "c10", " ", "t"}], "+", 
             RowBox[{"c7", " ", "u"}], "+", 
             RowBox[{"c24", " ", "s", " ", "u"}], "+", 
             RowBox[{"2", " ", "c13", " ", "t", " ", "u"}], "+", 
             RowBox[{"2", " ", "c5", " ", "v"}], "+", 
             RowBox[{"2", " ", "c22", " ", "s", " ", "v"}], "+", 
             RowBox[{"4", " ", "c11", " ", "t", " ", "v"}]}], ",", 
            RowBox[{"c2", "+", 
             RowBox[{"c18", " ", "s"}], "+", 
             RowBox[{"c30", " ", 
              SuperscriptBox["s", "2"]}], "+", 
             RowBox[{"c7", " ", "t"}], "+", 
             RowBox[{"c24", " ", "s", " ", "t"}], "+", 
             RowBox[{"c13", " ", 
              SuperscriptBox["t", "2"]}]}], ",", 
            RowBox[{
             RowBox[{"2", " ", "c1"}], "+", 
             RowBox[{"2", " ", "c16", " ", "s"}], "+", 
             RowBox[{"2", " ", "c28", " ", 
              SuperscriptBox["s", "2"]}], "+", 
             RowBox[{"2", " ", "c5", " ", "t"}], "+", 
             RowBox[{"2", " ", "c22", " ", "s", " ", "t"}], "+", 
             RowBox[{"2", " ", "c11", " ", 
              SuperscriptBox["t", "2"]}]}]}], "}"}]}], "}"}]}]}], 
      "\[IndentingNewLine]", "]"}], ",", 
     RowBox[{"CompilationOptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<InlineExternalDefinitions\>\"", "\[Rule]", "True"}], 
       "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"hessFHelper", "[", 
   RowBox[{"Params_", ",", 
    RowBox[{"d_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"VectorQ", "[", 
        RowBox[{"#", ",", "NumericQ"}], "]"}], "&"}], ")"}]}]}], "]"}], ":=", 
  RowBox[{"hessF", "[", 
   RowBox[{"Params", ",", "d"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.827591555069127*^9, 3.827591557471429*^9}, {
   3.827591654136261*^9, 3.827591689216162*^9}, {3.8275917571800847`*^9, 
   3.827591778408144*^9}, {3.827591930401635*^9, 3.8275919450055647`*^9}, {
   3.827591975630489*^9, 3.8275919810494614`*^9}, {3.82759670911722*^9, 
   3.8275967092412186`*^9}, {3.827857800029931*^9, 3.8278578007361565`*^9}, 
   3.8280639834131036`*^9, {3.8283219303082576`*^9, 3.8283219418123903`*^9}, 
   3.828368718101243*^9, {3.8283693075375566`*^9, 3.82836930899765*^9}, 
   3.8283700726124353`*^9, {3.8283702597753677`*^9, 3.8283702623121614`*^9}, {
   3.8283703280297403`*^9, 3.8283703377990255`*^9}, 3.84070106749806*^9, {
   3.840701112537197*^9, 3.840701151866989*^9}, 3.8553972728995905`*^9, 
   3.855397507015958*^9},
 CellLabel->"In[9]:=",ExpressionUUID->"357fdf3d-5d44-4b52-8cce-17af3b2d8827"],

Cell["\<\
The following modules recalibrate the output of the NDSolve to the \
interpolation range 0 to 1.\
\>", "Text",
 CellChangeTimes->{{3.8283686303106747`*^9, 3.8283686735357184`*^9}, 
   3.828369215977583*^9, {3.8283700909806585`*^9, 
   3.82837012896332*^9}},ExpressionUUID->"c7fccc7b-8eb4-4866-9073-\
720deadb3aaa"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"parameterizeCurve", "[", 
    RowBox[{"pts_List", ",", 
     RowBox[{"a", ":", 
      RowBox[{"(", 
       RowBox[{"_", "?", "NumericQ"}], ")"}], ":", 
      RowBox[{"1", "/", "2"}]}]}], "]"}], "/;", 
   RowBox[{"MatrixQ", "[", 
    RowBox[{"pts", ",", "NumericQ"}], "]"}]}], ":=", 
  RowBox[{"FoldList", "[", 
   RowBox[{"Plus", ",", "0", ",", 
    RowBox[{"Normalize", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Norm", "/@", 
         RowBox[{"Differences", "[", "pts", "]"}]}], ")"}], "^", "a"}], ",", 
      "Total"}], "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"interpolationFn", "[", "set_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"tvals", ",", "sset"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tvals", "=", 
      RowBox[{"parameterizeCurve", "[", 
       RowBox[{"set", ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"sset", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tvals", ",", "#"}], "}"}], "]"}], "&"}], "/@", 
       RowBox[{"Transpose", "[", "set", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Interpolation", "[", 
        RowBox[{"#", ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "3"}]}], "]"}], "&"}], "/@",
       "sset"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "Input",
 CellChangeTimes->{3.82838796736546*^9, 3.8283885757051697`*^9},
 CellLabel->"In[11]:=",ExpressionUUID->"30b5ca36-6abb-40d6-adf0-7c601c1cd34a"],

Cell["\<\
The following module combines the earlier modules in this section to solve \
the gradient-descent problem starting from the saddle points.\
\>", "Text",
 CellChangeTimes->{{3.8283686303106747`*^9, 3.8283686735357184`*^9}, 
   3.828369215977583*^9, {3.8283700909806585`*^9, 3.828370181335893*^9}, 
   3.8283746579006677`*^9},ExpressionUUID->"8fcb8903-0438-48eb-bee5-\
e224d4da0952"],

Cell[BoxData[
 RowBox[{
  RowBox[{"saddleAnalysis", "[", 
   RowBox[{"\[Mu]\[Psi]data_", ",", 
    RowBox[{"{", 
     RowBox[{"ndesigns_", ",", "neigen_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "Params", ",", "d", ",", "q", ",", "len", ",", "dim", ",", "IFnSet", ",",
       "j", ",", "negpos", ",", "h", ",", "dsol"}], "}"}], ",", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Params", "=", 
      RowBox[{"\[Mu]\[Psi]set", "[", "\[Mu]\[Psi]data", "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"len", ",", "dim"}], "}"}], "=", 
      RowBox[{"Dimensions", "[", "ndesigns", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"IFnSet", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"j", "=", "1"}], ",", 
       RowBox[{"j", "\[LessEqual]", " ", "len"}], ",", " ", 
       RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"negpos", "=", 
         RowBox[{"Ordering", "[", 
          RowBox[{
           RowBox[{"neigen", "[", 
            RowBox[{"[", 
             RowBox[{"j", ",", "1"}], "]"}], "]"}], ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"neigen", "[", 
            RowBox[{"[", 
             RowBox[{"j", ",", "1", ",", 
              RowBox[{"negpos", "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], ">", "0"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"IFnSet", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"IFnSet", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"ndesigns", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], "}"}], "}"}]}], "]"}]}], ";", 
           RowBox[{"Continue", "[", "]"}], ";"}], " ", ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"IFnSet", "=", 
              RowBox[{"Append", "[", 
               RowBox[{"IFnSet", ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"h", "=", 
                  RowBox[{"Max", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "/", "10"}], ")"}], 
                    RowBox[{"Abs", "[", 
                    RowBox[{"neigen", "[", 
                    RowBox[{"[", 
                    RowBox[{"j", ",", "1", ",", 
                    RowBox[{"negpos", "[", 
                    RowBox[{"[", "k", "]"}], "]"}]}], "]"}], "]"}], "]"}]}], 
                    ",", 
                    SuperscriptBox["10", 
                    RowBox[{"-", "4"}]]}], "]"}]}], " ", ";", 
                 RowBox[{"(*", 
                  RowBox[{
                  "The", " ", "scale", " ", "factor", " ", "and", " ", 
                   "limit", " ", "value", " ", "is", " ", "arbitrary", " ", 
                   "for", " ", "the", " ", "initial", " ", "step", " ", "and",
                    " ", "can", " ", "be", " ", "changed", " ", "if", " ", 
                   "necessary"}], "*)"}], "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{"Table", "[", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"dsol", "=", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"Values", "[", 
                    RowBox[{
                    RowBox[{"NDSolve", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"d", "'"}], "[", "q", "]"}], "\[Equal]", 
                    RowBox[{"gradFHelper", "[", 
                    RowBox[{"Params", ",", "q", ",", 
                    RowBox[{"d", "[", "q", "]"}]}], "]"}]}], 
                    RowBox[{"(*", 
                    RowBox[{
                    "Change", " ", "to", " ", "uncompiled", " ", "version", 
                    " ", "gradFun", " ", "if", " ", "necessary"}], "*)"}], 
                    ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"d", "[", "h", "]"}], ")"}], "\[Equal]", 
                    RowBox[{
                    RowBox[{"ndesigns", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "+", 
                    RowBox[{"hv", " ", 
                    RowBox[{"neigen", "[", 
                    RowBox[{"[", 
                    RowBox[{"j", ",", "2", ",", 
                    RowBox[{"negpos", "[", 
                    RowBox[{"[", "k", "]"}], "]"}]}], "]"}], "]"}]}]}]}], ",", 
                    RowBox[{"WhenEvent", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Max", "[", 
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{"d", "'"}], "[", "q", "]"}], "]"}], "]"}], 
                    "\[Equal]", 
                    SuperscriptBox["10", 
                    RowBox[{"-", "10"}]]}], 
                    RowBox[{"(*", 
                    RowBox[{
                    RowBox[{
                    "The", " ", "tolerance", " ", "for", " ", "zero"}], "-", 
                    RowBox[{
                    "gradient", " ", "check", " ", "can", " ", "be", " ", 
                    "changed", " ", "if", " ", "necessary"}]}], "*)"}], ",", 
                    "\"\<StopIntegration\>\""}], "]"}]}], "}"}], ",", "d", 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"q", ",", "h", ",", "\[Infinity]"}], "}"}]}], 
                    "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], ")"}], "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"interpolationFn", "[", 
                    RowBox[{"Join", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"ndesigns", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "}"}], ",", "dsol"}], 
                    "]"}], "]"}]}], "\[IndentingNewLine]", ",", 
                    RowBox[{"{", 
                    RowBox[{"hv", ",", 
                    RowBox[{"{", 
                    RowBox[{"h", ",", 
                    RowBox[{"-", "h"}]}], "}"}]}], "}"}]}], "]"}], "}"}]}]}], 
               "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
            ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", 
              RowBox[{"Length", "[", "negpos", "]"}]}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "]"}], ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], 
     ";", "\[IndentingNewLine]", "\[IndentingNewLine]", "IFnSet"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.828063274542655*^9, 3.828063394210853*^9}, {
   3.8280634273612347`*^9, 3.828063657547489*^9}, {3.8280638063103347`*^9, 
   3.8280638997477865`*^9}, {3.828064888095131*^9, 3.8280649247410727`*^9}, {
   3.8280652744201593`*^9, 3.828065325793738*^9}, 3.8280654823954926`*^9, 
   3.828065786188157*^9, {3.828098833184245*^9, 3.828098835336565*^9}, 
   3.828199407400939*^9, 3.8283219677864075`*^9, {3.8283687357002125`*^9, 
   3.8283687370759296`*^9}, {3.8283688147917786`*^9, 
   3.8283688333452673`*^9}, {3.8283689035123997`*^9, 
   3.8283689110591607`*^9}, {3.8283703738751135`*^9, 
   3.8283704625823736`*^9}, {3.828370512710164*^9, 3.828370513797963*^9}, 
   3.8283708513672056`*^9, {3.828370890665554*^9, 3.8283709548523235`*^9}, {
   3.8283709889126563`*^9, 3.8283710222979326`*^9}, {3.828371064089554*^9, 
   3.828371067580987*^9}, {3.8283711170577707`*^9, 3.8283711611670284`*^9}, {
   3.8283712149361463`*^9, 3.8283712792079763`*^9}, {3.828375218021721*^9, 
   3.828375294322234*^9}, {3.828375485271234*^9, 3.8283754883372726`*^9}, 
   3.8283872950620933`*^9, 3.8283879117914977`*^9, {3.828388080903722*^9, 
   3.8283880871107807`*^9}, {3.828388194016901*^9, 3.828388243315069*^9}, {
   3.8283883218411365`*^9, 3.8283883220892467`*^9}, 3.828388353935401*^9, {
   3.828388389507309*^9, 3.8283883926179237`*^9}, {3.828439630796896*^9, 
   3.8284396310738554`*^9}, {3.8284456823007574`*^9, 3.828445689157054*^9}, {
   3.828447141743311*^9, 3.828447175593808*^9}, {3.8376978180604115`*^9, 
   3.837697832178812*^9}, {3.837697889370723*^9, 3.837697931548764*^9}, {
   3.8376979994463463`*^9, 3.8376980236204214`*^9}, {3.8376980679263525`*^9, 
   3.837698080480528*^9}, {3.837698437733574*^9, 3.837698445100974*^9}, {
   3.837699104549387*^9, 3.8376991608036485`*^9}, {3.8376991999776897`*^9, 
   3.8376992008019156`*^9}, {3.8376995374198523`*^9, 
   3.8376995409936943`*^9}, {3.8376996114667573`*^9, 3.8376996347234197`*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"b273bea3-a5fe-4f18-90a4-af81d1da42a4"]
}, Closed]],

Cell[CellGroupData[{

Cell["Graphics modules,", "Chapter",
 CellChangeTimes->{{3.827365749139671*^9, 
  3.82736575620781*^9}},ExpressionUUID->"011f3f8c-31db-4c9f-9364-\
c517be417693"],

Cell[CellGroupData[{

Cell["Direct-kinematics plotter, ", "Section",
 CellChangeTimes->{{3.8553328319491806`*^9, 
  3.8553328520083704`*^9}},ExpressionUUID->"5e05e2bd-52e7-4a0c-9e3e-\
8d7c273126ad"],

Cell["\<\
The following module is used to solve the direct kinematics of the four-bar \
mechanism.\
\>", "Text",
 CellChangeTimes->{{3.828374676276722*^9, 
  3.828374697591051*^9}},ExpressionUUID->"e833c1d1-e96c-4080-bdbf-\
9528f06b07ac"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DKSol", "=", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"d", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Mu]j", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"br", ",", "_Integer"}], "}"}]}], "}"}], ",", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "rm", ",", "s", ",", "t", ",", "u", ",", "v", ",", "l1", ",", "l3", 
         ",", "\[Mu]0", ",", "\[Psi]0", ",", "A0", ",", "B0", ",", "C0", ",", 
         "D0", ",", "\[Alpha]", ",", "\[Beta]", ",", "\[Gamma]", ",", 
         "\[Psi]", ",", "\[CurlyPhi]", ",", "\[Lambda]"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}], "=", 
         "d"}], ";", 
        RowBox[{"l1", "=", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           SuperscriptBox["u", "2"], "+", 
           SuperscriptBox["v", "2"]}], "]"}]}], ";", 
        RowBox[{"l3", "=", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           SuperscriptBox["s", "2"], "+", 
           SuperscriptBox["t", "2"]}], "]"}]}], ";", 
        RowBox[{"\[Mu]0", "=", 
         RowBox[{"ArcTan", "[", 
          RowBox[{"u", ",", "v"}], "]"}]}], ";", 
        RowBox[{"\[Psi]0", "=", 
         RowBox[{"ArcTan", "[", 
          RowBox[{"s", ",", "t"}], "]"}]}], ";", 
        RowBox[{"A0", "=", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], ";", 
        RowBox[{"B0", "=", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Alpha]", "=", 
         RowBox[{"2", " ", "l3", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "l1"}], " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"\[Mu]0", "+", "\[Mu]j", "-", "\[Psi]0"}], "]"}]}], "+", 
            RowBox[{"Cos", "[", "\[Psi]0", "]"}]}], ")"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Beta]", "=", 
         RowBox[{
          RowBox[{"-", "2"}], " ", "l3", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"l1", " ", 
             RowBox[{"Sin", "[", 
              RowBox[{"\[Mu]0", "+", "\[Mu]j", "-", "\[Psi]0"}], "]"}]}], "+", 
            RowBox[{"Sin", "[", "\[Psi]0", "]"}]}], ")"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Gamma]", "=", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"(", 
           RowBox[{"rm", "+", 
            RowBox[{"l1", " ", 
             RowBox[{"Cos", "[", 
              RowBox[{"\[Mu]0", "+", "\[Mu]j"}], "]"}]}]}], ")"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[CurlyPhi]", "=", 
         RowBox[{"ArcCos", "[", 
          RowBox[{"-", 
           FractionBox["\[Gamma]", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["\[Alpha]", "2"], "+", 
              SuperscriptBox["\[Beta]", "2"]}]]]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Lambda]", "=", 
         RowBox[{"ArcTan", "[", 
          RowBox[{"\[Alpha]", ",", "\[Beta]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Psi]", "=", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[CurlyPhi]"}], "+", "\[Lambda]"}], ",", 
            RowBox[{"\[CurlyPhi]", "+", "\[Lambda]"}]}], "}"}], "[", 
          RowBox[{"[", "br", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"C0", "=", 
         RowBox[{"l1", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Cos", "[", 
             RowBox[{"\[Mu]j", "+", "\[Mu]0"}], "]"}], ",", 
            RowBox[{"Sin", "[", 
             RowBox[{"\[Mu]j", "+", "\[Mu]0"}], "]"}]}], "}"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"D0", "=", 
         RowBox[{"B0", "+", 
          RowBox[{"l3", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Cos", "[", 
              RowBox[{"\[Psi]", "+", "\[Psi]0"}], "]"}], ",", 
             RowBox[{"Sin", "[", 
              RowBox[{"\[Psi]", "+", "\[Psi]0"}], "]"}]}], "}"}]}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"\[Psi]", ",", 
            RowBox[{"2", "\[Pi]"}], ",", 
            RowBox[{"-", "\[Pi]"}]}], "]"}], ",", 
          RowBox[{"C0", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"C0", "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", 
          RowBox[{"D0", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"D0", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}], "\[IndentingNewLine]",
       "]"}], ",", 
     RowBox[{"CompilationOptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<InlineExternalDefinitions\>\"", "\[Rule]", "True"}], 
       "}"}]}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.8283725781835985`*^9, 3.8283727340254436`*^9}, {
   3.828372817945017*^9, 3.8283729159688387`*^9}, {3.828372959163458*^9, 
   3.828372994475213*^9}, {3.8283731893623257`*^9, 3.828373279289364*^9}, {
   3.8283735057461634`*^9, 3.82837356247393*^9}, {3.828373640738677*^9, 
   3.8283736619186583`*^9}, {3.8283736961846685`*^9, 3.828373708450447*^9}, {
   3.828373745123925*^9, 3.8283737884762764`*^9}, {3.8553971457178907`*^9, 
   3.8553971769981976`*^9}, 3.855397519617531*^9},
 CellLabel->"In[14]:=",ExpressionUUID->"6b981e7a-fe11-4ffe-b231-ad9e892256da"],

Cell["\<\
The following modules are used to create graphics of ground-pivot and moving \
pivot, respectively.\
\>", "Text",
 CellChangeTimes->{{3.828374717680337*^9, 3.828374753942231*^9}, {
  3.8283755098057036`*^9, 
  3.828375511621464*^9}},ExpressionUUID->"34dc7fc0-3d4f-4cde-be8a-\
03507d871a98"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"GPivot", "[", 
    RowBox[{"pt_", ",", 
     RowBox[{"sc_", ":", "1"}], ",", 
     RowBox[{"rot_", ":", "0"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", "l", ",", "h", ",", "t", ",", "g"}], "}"}], ",", 
     RowBox[{"(*", 
      RowBox[{"x", ",", 
       RowBox[{"y", "-", 
        RowBox[{"location", " ", "of", " ", "pivot"}]}]}], "*)"}], 
     RowBox[{"(*", 
      RowBox[{"sc", "-", 
       RowBox[{"optional", " ", "scale", " ", "factor"}]}], "*)"}], 
     RowBox[{"(*", 
      RowBox[{"rot", "-", 
       RowBox[{"optional", " ", "rotation"}]}], "*)"}], 
     RowBox[{
      RowBox[{"r", "=", 
       RowBox[{"1.5", "/", "2"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{"radius", " ", "of", " ", "pivot"}], "*)"}], 
      RowBox[{"l", "=", "3.4"}], ";", 
      RowBox[{"(*", 
       RowBox[{"length", " ", "of", " ", "base"}], "*)"}], 
      RowBox[{"h", "=", ".3"}], ";", 
      RowBox[{"(*", 
       RowBox[{"height", " ", "of", " ", "base"}], "*)"}], 
      RowBox[{"t", "=", 
       RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{"line", " ", "thickness"}], "*)"}], 
      RowBox[{"g", "=", 
       RowBox[{"{", 
        RowBox[{"t", ",", 
         RowBox[{"Circle", "[", 
          RowBox[{
           RowBox[{"pt", "+", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "2"}], "*", "r"}], ",", "0"}], "}"}]}], ",", "r", 
           ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{
              RowBox[{"-", "Pi"}], "/", "2"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Circle", "[", 
          RowBox[{
           RowBox[{"pt", "+", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"2", "*", "r"}], ",", "0"}], "}"}]}], ",", "r", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "Pi"}], "/", "2"}], ",", 
             RowBox[{"-", "Pi"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"EdgeForm", "[", "t", "]"}], ",", "White", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Disk", "[", 
            RowBox[{"pt", ",", "#"}], "]"}], "&"}], "/@", 
          RowBox[{"{", 
           RowBox[{"r", ",", 
            RowBox[{"r", "*", 
             RowBox[{"2", "/", "3"}]}]}], "}"}]}], ",", 
         RowBox[{"Rectangle", "[", 
          RowBox[{
           RowBox[{"pt", "+", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "l"}], "/", "2"}], ",", 
              RowBox[{
               RowBox[{"-", "r"}], "-", "h"}]}], "}"}]}], ",", 
           RowBox[{"pt", "+", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"l", "/", "2"}], ",", 
              RowBox[{"-", "r"}]}], "}"}]}], ",", 
           RowBox[{"RoundingRadius", "\[Rule]", ".005"}]}], "]"}]}], "}"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"Rotate", "[", 
       RowBox[{
        RowBox[{"Scale", "[", 
         RowBox[{"g", ",", "sc", ",", "pt"}], "]"}], ",", "rot", ",", "pt"}], 
       "]"}]}]}], "]"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MPivot", "[", 
   RowBox[{"pt_", ",", 
    RowBox[{"sc_", ":", "1"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"r", ",", "t", ",", "g"}], "}"}], ",", 
    RowBox[{
     RowBox[{"r", "=", 
      RowBox[{"1.2", "/", "2"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{"radius", " ", "of", " ", "pivot"}], "*)"}], 
     RowBox[{"t", "=", 
      RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{"line", " ", "thickness"}], "*)"}], 
     RowBox[{"g", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"EdgeForm", "[", "t", "]"}], ",", "White", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Disk", "[", 
           RowBox[{"pt", ",", "#"}], "]"}], "&"}], "/@", 
         RowBox[{"{", 
          RowBox[{"r", ",", 
           RowBox[{"r", "*", ".625"}]}], "}"}]}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Scale", "[", 
      RowBox[{"g", ",", "sc", ",", "pt"}], "]"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.824164843638115*^9, 3.8241648436510715`*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"79186b96-1a49-4101-95f6-cbb76a0b16d7"],

Cell["\<\
The following modules (archived) are related to the condition number of the \
Hessian matrix. \
\>", "Text",
 CellChangeTimes->{{3.85533275857174*^9, 3.8553327952540703`*^9}, 
   3.8553975329332633`*^9},ExpressionUUID->"921039ca-0063-4fca-89ca-\
b030d3a76087"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hessCond", "[", 
   RowBox[{"ndesign_", ",", "\[Mu]\[Psi]data_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"LUDecomposition", "[", 
    RowBox[{"hessFHelper", "[", 
     RowBox[{
      RowBox[{"\[Mu]\[Psi]set", "[", "\[Mu]\[Psi]data", "]"}], ",", 
      "ndesign"}], "]"}], "]"}], "[", 
   RowBox[{"[", "3", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.840705883328005*^9, 3.8407058863816724`*^9}, {
  3.8553312458945136`*^9, 3.855331250016*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"5bbd6d1c-dcdb-44cf-8ba5-2401ce353f8d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hessSingMax", "[", 
   RowBox[{"ndesign_", ",", "\[Mu]\[Psi]data_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Diagonal", "[", 
    RowBox[{
     RowBox[{"SingularValueDecomposition", "[", 
      RowBox[{"hessFHelper", "[", 
       RowBox[{
        RowBox[{"\[Mu]\[Psi]set", "[", "\[Mu]\[Psi]data", "]"}], ",", 
        "ndesign"}], "]"}], "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8407067262464137`*^9, 3.8407067690654964`*^9}, {
  3.8407068578423595`*^9, 3.8407068732487774`*^9}, {3.8553312577478247`*^9, 
  3.855331259657279*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"76743de6-1b34-4d9a-902d-f9521739b5cc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hessSingMin", "[", 
   RowBox[{"ndesign_", ",", "\[Mu]\[Psi]data_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Diagonal", "[", 
    RowBox[{
     RowBox[{"SingularValueDecomposition", "[", 
      RowBox[{"hessFHelper", "[", 
       RowBox[{
        RowBox[{"\[Mu]\[Psi]set", "[", "\[Mu]\[Psi]data", "]"}], ",", 
        "ndesign"}], "]"}], "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}], "]"}], "[", 
   RowBox[{"[", "5", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.840706937489615*^9, 3.840706945454368*^9}, {
  3.8553312722616224`*^9, 3.855331281094204*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"7847f882-1314-45b4-a35e-e5917a7fd337"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hessEigMax", "[", 
   RowBox[{"ndesign_", ",", "\[Mu]\[Psi]data_"}], "]"}], ":=", 
  RowBox[{"Max", "[", 
   RowBox[{"Eigenvalues", "[", 
    RowBox[{"hessFHelper", "[", 
     RowBox[{
      RowBox[{"\[Mu]\[Psi]set", "[", "\[Mu]\[Psi]data", "]"}], ",", 
      "ndesign"}], "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.84130756421004*^9, 3.8413075813496237`*^9}, {
  3.8553312864353437`*^9, 3.8553312951216345`*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"b5402cb3-ffa9-4446-bf32-284a2413158f"],

Cell["\<\
The following module is used to plot the configuration of the four-bar \
mechanism along with the generated function plot.\
\>", "Text",
 CellChangeTimes->{{3.8283747657610083`*^9, 
  3.82837481383871*^9}},ExpressionUUID->"81a6258a-a35e-42ca-8f8e-\
7287ebbf1b7a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Plotter", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rm_", ",", "s_", ",", "t_", ",", "u_", ",", "v_"}], "}"}], ",", 
    "\[Mu]j_", ",", "br_", ",", "\[Mu]\[Psi]data_", ",", 
    RowBox[{"{", 
     RowBox[{"\[CurlyPhi]_", ",", "xc_", ",", "yc_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"A0", "=", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], ",", 
      RowBox[{"B0", "=", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], ",", 
      RowBox[{"C0", "=", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], ",", 
      RowBox[{"D0", "=", " ", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], ",", "\[Psi]j", ",", "fg1", ",", 
      "range\[Mu]", ",", "range\[Psi]", ",", "ar", ",", "fg2", ",", "Params", 
      ",", "objval", ",", "gradval", ",", "fg3"}], "}"}], ",", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Psi]j", ",", 
        RowBox[{"C0", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{"C0", "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", 
        RowBox[{"D0", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{"D0", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "=", 
      RowBox[{"Quiet", "[", 
       RowBox[{"DKSol", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}], ",", 
         "\[Mu]j", ",", "br"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"fg1", "=", 
      RowBox[{"Show", "[", 
       RowBox[{
        RowBox[{"Graphics", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Thickness", "[", 
            RowBox[{"Scaled", "[", "0.0225", "]"}], "]"}], ",", 
           RowBox[{"Darker", "[", "Red", "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"A0", ",", "B0"}], "}"}], "]"}], ",", "Black", ",", 
           RowBox[{"Thickness", "[", 
            RowBox[{"Scaled", "[", "0.02", "]"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"A0", ",", "C0", ",", "D0", ",", "B0"}], "}"}], "]"}], 
           ",", 
           RowBox[{"GPivot", "[", 
            RowBox[{"A0", ",", "0.06"}], "]"}], ",", 
           RowBox[{"GPivot", "[", 
            RowBox[{"B0", ",", "0.06"}], "]"}], ",", 
           RowBox[{"MPivot", "[", 
            RowBox[{"C0", ",", "0.0675"}], "]"}], ",", 
           RowBox[{"MPivot", "[", 
            RowBox[{"D0", ",", "0.0675"}], "]"}]}], "}"}], "]"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"xc", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}], "+", 
            RowBox[{"\[CurlyPhi]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], ",", 
           RowBox[{
            RowBox[{"yc", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}], "+", 
            RowBox[{"\[CurlyPhi]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}]}], "}"}]}], ",", 
        RowBox[{"Frame", "\[Rule]", " ", "True"}], ",", 
        RowBox[{"LabelStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{
           RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
           RowBox[{"FontSize", "\[Rule]", "20"}], ",", "Black"}], "]"}]}], 
        ",", 
        RowBox[{"PlotLabel", "\[Rule]", 
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"Framed", "[", "\"\<Four-bar mechanism\>\"", "]"}], ",", 
           "24", ",", "Black", ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"Lighter", "[", 
             RowBox[{"RGBColor", "[", 
              RowBox[{
               RowBox[{"1", "/", "255"}], 
               RowBox[{"{", 
                RowBox[{"255", ",", "153", ",", "51"}], "}"}]}], "]"}], 
             "]"}]}]}], "]"}]}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<x (unit)\>\"", ",", "\"\<y (unit)\>\""}], "}"}]}], ",", 
        RowBox[{"GridLines", "\[Rule]", " ", "Automatic"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", " ", "500"}], ",", 
        RowBox[{"ImagePadding", "\[Rule]", " ", "All"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"range\[Mu]", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Min", "[", 
         RowBox[{"\[Mu]\[Psi]data", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}], ",", 
        RowBox[{"Max", "[", 
         RowBox[{"\[Mu]\[Psi]data", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"range\[Psi]", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Min", "[", 
         RowBox[{"\[Mu]\[Psi]data", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}], ",", 
        RowBox[{"Max", "[", 
         RowBox[{"\[Mu]\[Psi]data", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ar", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"range\[Psi]", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "-", 
         RowBox[{"range\[Psi]", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"range\[Mu]", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "-", 
         RowBox[{"range\[Mu]", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ")"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"fg2", "=", 
      RowBox[{"Show", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{"\[Mu]\[Psi]data", ",", 
            RowBox[{"PlotStyle", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"PointSize", "[", "0.02", "]"}], ",", " ", "Black"}], 
              "}"}]}], ",", 
            RowBox[{"Frame", "\[Rule]", " ", "True"}], ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{
               RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
               RowBox[{"FontSize", "\[Rule]", "24"}], ",", "Black"}], "]"}]}],
             ",", 
            RowBox[{"PlotLabel", "\[Rule]", 
             RowBox[{"Style", "[", 
              RowBox[{
               RowBox[{
               "Framed", "[", "\"\<Function desired vs. generated\>\"", "]"}],
                ",", "24", ",", "Black", ",", 
               RowBox[{"Background", "\[Rule]", 
                RowBox[{"Lighter", "[", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{
                   RowBox[{"1", "/", "255"}], 
                   RowBox[{"{", 
                    RowBox[{"255", ",", "153", ",", "51"}], "}"}]}], "]"}], 
                 "]"}]}]}], "]"}]}], ",", 
            RowBox[{"FrameLabel", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
              "\"\<Input \[Mu] (rad)\>\"", ",", 
               "\"\<Output \[Psi] (rad)\>\""}], "}"}]}], ",", 
            RowBox[{"PlotRange", "\[Rule]", " ", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"range\[Mu]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "-", 
                  RowBox[{"0.15", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"range\[Mu]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", 
                    RowBox[{"range\[Mu]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}]}]}], ",", 
                 RowBox[{
                  RowBox[{"range\[Mu]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "+", 
                  RowBox[{"0.15", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"range\[Mu]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", 
                    RowBox[{"range\[Mu]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}]}]}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"range\[Psi]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "-", 
                  RowBox[{"0.15", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"range\[Psi]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", 
                    RowBox[{"range\[Psi]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}]}]}], ",", 
                 RowBox[{
                  RowBox[{"range\[Psi]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "+", 
                  RowBox[{"0.15", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"range\[Psi]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", 
                    RowBox[{"range\[Psi]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}]}]}]}], "}"}]}], 
              "}"}]}], ",", 
            RowBox[{"AspectRatio", "\[Rule]", " ", "ar"}], ",", 
            RowBox[{"GridLines", "\[Rule]", " ", "Automatic"}]}], "]"}], ",", 
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"DKSol", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}],
                ",", "\[Mu]", ",", "br"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Mu]", ",", 
              RowBox[{"\[Mu]\[Psi]data", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"\[Mu]\[Psi]data", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{"Blue", ",", 
               RowBox[{"AbsoluteThickness", "[", "4", "]"}], ",", 
               RowBox[{"Opacity", "[", "0.6", "]"}]}], "]"}]}], ",", 
            RowBox[{"PlotRange", "\[Rule]", " ", "All"}]}], "]"}], ",", 
          RowBox[{"Graphics", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Darker", "[", "Red", "]"}], ",", 
             RowBox[{"PointSize", "[", "0.03", "]"}], ",", 
             RowBox[{"Point", "[", 
              RowBox[{"{", 
               RowBox[{"\[Mu]j", ",", "\[Psi]j"}], "}"}], "]"}]}], "}"}], 
           "]"}]}], "}"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", " ", "500"}], ",", 
        RowBox[{"ImagePadding", "\[Rule]", " ", "All"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Params", "=", 
      RowBox[{"\[Mu]\[Psi]set", "[", "\[Mu]\[Psi]data", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"objval", "=", 
      RowBox[{"ScientificForm", "[", 
       RowBox[{
        RowBox[{"objF", "[", 
         RowBox[{"Params", ",", 
          RowBox[{"{", 
           RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}]}], 
         "]"}], ",", "3"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"gradval", "=", 
      RowBox[{"ScientificForm", "[", 
       RowBox[{
        RowBox[{"Max", "[", 
         RowBox[{"Abs", "[", 
          RowBox[{"gradFHelper", "[", 
           RowBox[{"Params", ",", "0", ",", 
            RowBox[{"{", 
             RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}]}], 
           "]"}], "]"}], "]"}], ",", "3"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"fg3", "=", 
      RowBox[{"Grid", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Obj. value\>\"", ",", "24"}], "]"}], ",", 
            RowBox[{"Style", "[", 
             RowBox[{"objval", ",", "24"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<Gradient \!\(\*SubscriptBox[\(L\), \(\[Infinity]\)]\) \
norm\>\"", ",", "24"}], "]"}], ",", 
            RowBox[{"Style", "[", 
             RowBox[{"gradval", ",", "24"}], "]"}]}], "}"}]}], "}"}], ",", 
        RowBox[{"Dividers", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"False", ",", "All"}], "}"}]}], ",", 
        RowBox[{"Background", "\[Rule]", " ", 
         RowBox[{"Lighter", "[", 
          RowBox[{"Gray", ",", "0.6"}], "]"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Column", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Row", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"fg1", ",", "fg2"}], "}"}], ",", "\"\<     \>\""}], "]"}],
          ",", "fg3"}], "}"}], ",", 
       RowBox[{"Alignment", "\[Rule]", " ", "Center"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.8273738927936764`*^9, 3.8273739760299096`*^9}, {
   3.8273740687671137`*^9, 3.827374097004367*^9}, {3.8273741282509985`*^9, 
   3.827374141153784*^9}, {3.8273743629075623`*^9, 3.8273744246177797`*^9}, {
   3.8273748544607334`*^9, 3.8273748681089916`*^9}, {3.827375059113102*^9, 
   3.8273750894167385`*^9}, {3.8273751427192497`*^9, 3.827375158749957*^9}, {
   3.8273752177479553`*^9, 3.8273752346186223`*^9}, {3.8273753067507772`*^9, 
   3.8273753559178305`*^9}, {3.8273756084971905`*^9, 
   3.8273756254421268`*^9}, {3.827375695160424*^9, 3.8273756955457726`*^9}, {
   3.827375935594575*^9, 3.827376037502409*^9}, 3.827376097009632*^9, {
   3.8273761358335395`*^9, 3.8273762805844584`*^9}, {3.8273763511424737`*^9, 
   3.8273763548404393`*^9}, {3.8273763937343235`*^9, 3.82737639423722*^9}, {
   3.8273764400343804`*^9, 3.8273764978057265`*^9}, {3.827376853596767*^9, 
   3.8273770370617523`*^9}, {3.8273772533529687`*^9, 3.827377265050684*^9}, 
   3.827377337220194*^9, {3.8273775589330053`*^9, 3.8273775685141134`*^9}, {
   3.827377620158334*^9, 3.827377627595456*^9}, {3.8273776590043125`*^9, 
   3.82737767201129*^9}, {3.827378316518313*^9, 3.827378325337389*^9}, {
   3.8273785097638483`*^9, 3.827378510704806*^9}, {3.827379283570999*^9, 
   3.827379310527672*^9}, {3.8273793450753756`*^9, 3.8273794445595655`*^9}, {
   3.8273795017191668`*^9, 3.8273795092514095`*^9}, {3.827379541123621*^9, 
   3.827379544803423*^9}, {3.827379603281799*^9, 3.827379627340695*^9}, {
   3.8273796906735353`*^9, 3.82737971804807*^9}, {3.8273801861160727`*^9, 
   3.827380278658374*^9}, {3.8273803108018947`*^9, 3.8273803222478456`*^9}, {
   3.8273808637748156`*^9, 3.827380870460575*^9}, {3.827380907445607*^9, 
   3.8273809141482673`*^9}, {3.827411292617546*^9, 3.827411406128183*^9}, {
   3.8274179932595015`*^9, 3.827418003411432*^9}, {3.827422683338315*^9, 
   3.827422692892761*^9}, {3.8281959425562873`*^9, 3.8281959731346674`*^9}, {
   3.828285197326238*^9, 3.828285217646686*^9}, {3.828317358098154*^9, 
   3.828317392124699*^9}, 3.82831742404025*^9, {3.8283174836315603`*^9, 
   3.828317487982047*^9}, 3.828317521629397*^9, {3.828317564905623*^9, 
   3.828317572819885*^9}, {3.8283176530372667`*^9, 3.8283177033100247`*^9}, {
   3.82831773857238*^9, 3.828317740523875*^9}, {3.8283177851669436`*^9, 
   3.8283177967226562`*^9}, {3.828317838411257*^9, 3.8283178520216284`*^9}, {
   3.8283179845716996`*^9, 3.8283179953331733`*^9}, {3.828318078331085*^9, 
   3.828318117150732*^9}, {3.828318164704564*^9, 3.828318171227944*^9}, {
   3.8283182184670076`*^9, 3.828318228928816*^9}, {3.828318346318122*^9, 
   3.828318351608906*^9}, {3.8283184665472393`*^9, 3.82831848101363*^9}, {
   3.8283185189652977`*^9, 3.828318519343275*^9}, {3.828318582641528*^9, 
   3.8283185867978287`*^9}, {3.8283186428996553`*^9, 3.828318654991687*^9}, {
   3.8283186881544933`*^9, 3.8283186882408695`*^9}, 3.8283188410802093`*^9, {
   3.8283188826048727`*^9, 3.8283189049015417`*^9}, {3.8283190680678177`*^9, 
   3.828319073944594*^9}, {3.828319116079465*^9, 3.8283191180062904`*^9}, {
   3.8283192153997545`*^9, 3.828319308640539*^9}, {3.8283193849950194`*^9, 
   3.8283194028293667`*^9}, {3.828319443950143*^9, 3.82831946481851*^9}, {
   3.828319925147503*^9, 3.828320065270408*^9}, {3.8283201007526016`*^9, 
   3.8283201036102157`*^9}, {3.82832020152948*^9, 3.8283202255011024`*^9}, {
   3.828320329448701*^9, 3.828320332740529*^9}, {3.8283203700543137`*^9, 
   3.8283203748282824`*^9}, {3.8283206448827767`*^9, 3.828320658530199*^9}, {
   3.828320711962123*^9, 3.8283207429854107`*^9}, {3.828320874690604*^9, 
   3.828320880981717*^9}, {3.828320924951073*^9, 3.828320945116345*^9}, {
   3.8283210037986717`*^9, 3.8283210629927697`*^9}, {3.828321103691003*^9, 
   3.82832116897496*^9}, {3.8283212937822123`*^9, 3.8283213238938675`*^9}, {
   3.8283214141758213`*^9, 3.828321415632143*^9}, {3.828321990190079*^9, 
   3.82832201465233*^9}, {3.8283224246307135`*^9, 3.828322455754784*^9}, {
   3.8283229310615606`*^9, 3.8283229329626894`*^9}, {3.8283229951380615`*^9, 
   3.828322997596115*^9}, {3.82832306640055*^9, 3.8283231330989447`*^9}, {
   3.8283232603235292`*^9, 3.8283232640661154`*^9}, {3.828323350976202*^9, 
   3.8283233519137316`*^9}, {3.8283258275708647`*^9, 
   3.8283258358221903`*^9}, {3.8283258952396307`*^9, 
   3.8283259223683543`*^9}, {3.8283259697739077`*^9, 
   3.8283260165186577`*^9}, {3.8283262632574644`*^9, 
   3.8283263220974545`*^9}, {3.8283263731086454`*^9, 
   3.8283263907604494`*^9}, {3.828326425377146*^9, 3.8283264605063925`*^9}, {
   3.8283265132516413`*^9, 3.828326545405806*^9}, {3.82832658635598*^9, 
   3.828326593592351*^9}, {3.8283266602668657`*^9, 3.8283266653052664`*^9}, {
   3.8283268105461307`*^9, 3.8283268143059406`*^9}, {3.8283270990393143`*^9, 
   3.8283272179560394`*^9}, {3.828327286739512*^9, 3.8283273237732306`*^9}, {
   3.828327414011693*^9, 3.828327416513901*^9}, {3.8283275333331757`*^9, 
   3.8283275339018087`*^9}, {3.8283275705218983`*^9, 3.828327581705743*^9}, 
   3.8283277764038415`*^9, {3.828327807608636*^9, 3.8283278092188873`*^9}, {
   3.8283278450773697`*^9, 3.8283279967025995`*^9}, {3.8283280532459483`*^9, 
   3.828328057456399*^9}, {3.8283280959427385`*^9, 3.8283281259438953`*^9}, {
   3.828328189030698*^9, 3.8283281964386206`*^9}, 3.828328261474009*^9, {
   3.828328314365557*^9, 3.8283283246017294`*^9}, {3.828328527437698*^9, 
   3.8283285341829367`*^9}, {3.8283285768900704`*^9, 3.828328598599165*^9}, {
   3.8283286868211184`*^9, 3.828328704803662*^9}, {3.8283287962578773`*^9, 
   3.828328804819564*^9}, {3.82832885254832*^9, 3.8283288559101334`*^9}, {
   3.8283290975981236`*^9, 3.8283291323011217`*^9}, {3.828329165026599*^9, 
   3.828329174003543*^9}, {3.8283292343641467`*^9, 3.8283292402675023`*^9}, 
   3.8283295757076073`*^9, {3.8283301263462167`*^9, 3.828330142947116*^9}, {
   3.828330195030443*^9, 3.828330237595038*^9}, {3.82833038889217*^9, 
   3.8283303900669603`*^9}, {3.8283723772623615`*^9, 3.82837238801442*^9}, {
   3.8283724661675515`*^9, 3.8283724747228317`*^9}, {3.8283738423972096`*^9, 
   3.8283738429876437`*^9}, {3.828373873104534*^9, 3.828374093941723*^9}, {
   3.8283741410820627`*^9, 3.8283741431800117`*^9}, 3.828374264716569*^9, {
   3.8283743986042385`*^9, 3.828374418038988*^9}, 3.828374821939537*^9, {
   3.828376992400103*^9, 3.8283769964878016`*^9}, {3.828386975678707*^9, 
   3.8283869809774523`*^9}, {3.8283870232779503`*^9, 3.828387028864297*^9}, 
   3.828387068266493*^9, {3.8283898306968193`*^9, 3.82838995143032*^9}, {
   3.828390087104215*^9, 3.828390117197706*^9}, {3.828390174485031*^9, 
   3.828390177564966*^9}, {3.828390269917301*^9, 3.828390392666791*^9}, {
   3.8283904328767233`*^9, 3.828390453170432*^9}, {3.8284383215878553`*^9, 
   3.8284385564427896`*^9}, {3.828438731194534*^9, 3.8284387461266537`*^9}, {
   3.82843882002664*^9, 3.8284388298345394`*^9}, {3.828438864790536*^9, 
   3.828438868738594*^9}, 3.828438942694604*^9, {3.8284427502984796`*^9, 
   3.8284427506046457`*^9}, {3.8284428119093266`*^9, 3.828442833743039*^9}, {
   3.828442915113229*^9, 3.828442942132292*^9}, {3.8284457739782295`*^9, 
   3.8284457857220955`*^9}, {3.8392353059330235`*^9, 3.839235312459691*^9}, {
   3.840705827917267*^9, 3.8407058671514206`*^9}, 3.8407067088331385`*^9, {
   3.84070678017901*^9, 3.8407068067782526`*^9}, {3.8407069535669756`*^9, 
   3.840706960351899*^9}, 3.841128580442876*^9, {3.8436667827674656`*^9, 
   3.843666786200655*^9}, {3.8442840845314007`*^9, 3.8442841027332926`*^9}, {
   3.844284200178501*^9, 3.8442842329455156`*^9}, 3.844285684202526*^9, {
   3.8442857157611*^9, 3.8442857267374825`*^9}, 3.844285871774398*^9, {
   3.8442886697749405`*^9, 3.8442887304697227`*^9}, {3.844288809584917*^9, 
   3.8442889682157097`*^9}, 3.844289004769021*^9, {3.8442890497724*^9, 
   3.8442890966298113`*^9}, {3.8442891348428288`*^9, 
   3.8442891709159036`*^9}, {3.8442963912350864`*^9, 3.844296395288767*^9}, {
   3.844297394865572*^9, 3.84429740360355*^9}, {3.84429748665407*^9, 
   3.844297486971167*^9}, {3.8442975675238543`*^9, 3.844297568877567*^9}, {
   3.8443024413849983`*^9, 3.844302445036483*^9}, {3.845677391091704*^9, 
   3.845677411572171*^9}, {3.84571937169429*^9, 3.845719416141921*^9}, {
   3.8457194591207447`*^9, 3.845719499819716*^9}, {3.8553319341474*^9, 
   3.855331936284103*^9}, {3.8553320006795425`*^9, 3.855332099278735*^9}, 
   3.855332805938936*^9, {3.855333836759903*^9, 3.8553338388901367`*^9}, {
   3.8553340017811365`*^9, 3.855334021593992*^9}, {3.8557628861937637`*^9, 
   3.8557628870075035`*^9}, 3.855765474597582*^9, {3.8558607448934917`*^9, 
   3.855860746448782*^9}, {3.8558608741568108`*^9, 3.855860932608477*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"c749f56d-6974-45da-9d0b-9e63b6f9ea30"],

Cell["\<\
The following module is used to print the desired design with the coordinates \
of all the pivots labelled.\
\>", "Text",
 CellChangeTimes->{{3.8283747657610083`*^9, 
  3.8283748506726503`*^9}},ExpressionUUID->"de8f7891-3182-4f8a-9729-\
f70ccd21664d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"exportDesign", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rm_", ",", "s_", ",", "t_", ",", "u_", ",", "v_"}], "}"}], ",", 
    "\[Mu]j_", ",", "br_", ",", 
    RowBox[{"{", 
     RowBox[{"\[CurlyPhi]_", ",", "xc_", ",", "yc_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"A0", "=", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], ",", 
      RowBox[{"B0", "=", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], ",", 
      RowBox[{"C0", "=", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], ",", 
      RowBox[{"D0", "=", " ", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], ",", "\[Psi]j", ",", "fg"}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Psi]j", ",", 
        RowBox[{"C0", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{"C0", "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", 
        RowBox[{"D0", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{"D0", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "=", 
      RowBox[{"DKSol", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}], ",", 
        "\[Mu]j", ",", "br"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"fg", "=", 
      RowBox[{"Show", "[", 
       RowBox[{
        RowBox[{"Graphics", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Thickness", "[", 
            RowBox[{"Scaled", "[", "0.0175", "]"}], "]"}], ",", 
           RowBox[{"Darker", "[", "Red", "]"}], ",", 
           RowBox[{"Opacity", "[", "0.75", "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"A0", ",", "B0"}], "}"}], "]"}], ",", "Black", ",", 
           RowBox[{"Thickness", "[", 
            RowBox[{"Scaled", "[", "0.015", "]"}], "]"}], ",", 
           RowBox[{"Opacity", "[", "0.75", "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"A0", ",", "C0", ",", "D0", ",", "B0"}], "}"}], "]"}], 
           ",", "Black", ",", 
           RowBox[{"GPivot", "[", 
            RowBox[{"A0", ",", "0.04"}], "]"}], ",", 
           RowBox[{"GPivot", "[", 
            RowBox[{"B0", ",", "0.04"}], "]"}], ",", 
           RowBox[{"MPivot", "[", 
            RowBox[{"C0", ",", "0.0525"}], "]"}], ",", 
           RowBox[{"MPivot", "[", 
            RowBox[{"D0", ",", "0.0525"}], "]"}], ",", 
           RowBox[{"Opacity", "[", "1", "]"}], ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Text", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                 RowBox[{"ToString", "[", 
                  RowBox[{"SetPrecision", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"A0", ",", "C0", ",", "D0", ",", "B0"}], "}"}], 
                    "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", "3"}], "]"}], "]"}], 
                 ",", "Medium", ",", "Bold", ",", "Purple"}], "]"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"A0", ",", "C0", ",", "D0", ",", "B0"}], "}"}], "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "+", 
                RowBox[{"0.15", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Normalize", "[", 
                    RowBox[{"A0", "-", "C0"}], "]"}], ",", 
                    RowBox[{"Normalize", "[", 
                    RowBox[{
                    RowBox[{"Normalize", "[", 
                    RowBox[{"C0", "-", "A0"}], "]"}], "+", 
                    RowBox[{"Normalize", "[", 
                    RowBox[{"C0", "-", "D0"}], "]"}]}], "]"}], ",", 
                    RowBox[{"Normalize", "[", 
                    RowBox[{
                    RowBox[{"Normalize", "[", 
                    RowBox[{"D0", "-", "B0"}], "]"}], "+", 
                    RowBox[{"Normalize", "[", 
                    RowBox[{"D0", "-", "C0"}], "]"}]}], "]"}], ",", 
                    RowBox[{"Normalize", "[", 
                    RowBox[{"B0", "-", "D0"}], "]"}]}], "}"}], "[", 
                   RowBox[{"[", "i", "]"}], "]"}], ")"}]}]}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "4"}], "}"}]}], "]"}]}], "}"}], "]"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"xc", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}], "+", 
            RowBox[{"\[CurlyPhi]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], ",", 
           RowBox[{
            RowBox[{"yc", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}], "+", 
            RowBox[{"\[CurlyPhi]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}]}], "}"}]}], ",", 
        RowBox[{"Frame", "\[Rule]", " ", "True"}], ",", 
        RowBox[{"LabelStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{
           RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
           RowBox[{"FontSize", "\[Rule]", "12"}], ",", "Black"}], "]"}]}], 
        ",", 
        RowBox[{"PlotLabel", "\[Rule]", 
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"Framed", "[", "\"\<Selected design\>\"", "]"}], ",", "14",
            ",", "Black", ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"Lighter", "[", 
             RowBox[{"RGBColor", "[", 
              RowBox[{
               RowBox[{"1", "/", "255"}], 
               RowBox[{"{", 
                RowBox[{"255", ",", "153", ",", "51"}], "}"}]}], "]"}], 
             "]"}]}]}], "]"}]}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<x (unit)\>\"", ",", "\"\<y (unit)\>\""}], "}"}]}], ",", 
        RowBox[{"GridLines", "\[Rule]", " ", "Automatic"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", " ", "300"}], ",", 
        RowBox[{"ImagePadding", "\[Rule]", " ", "All"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"CellPrint", "[", "fg", "]"}], ";"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.8273738927936764`*^9, 3.8273739760299096`*^9}, {
   3.8273740687671137`*^9, 3.827374097004367*^9}, {3.8273741282509985`*^9, 
   3.827374141153784*^9}, {3.8273743629075623`*^9, 3.8273744246177797`*^9}, {
   3.8273748544607334`*^9, 3.8273748681089916`*^9}, {3.827375059113102*^9, 
   3.8273750894167385`*^9}, {3.8273751427192497`*^9, 3.827375158749957*^9}, {
   3.8273752177479553`*^9, 3.8273752346186223`*^9}, {3.8273753067507772`*^9, 
   3.8273753559178305`*^9}, {3.8273756084971905`*^9, 
   3.8273756254421268`*^9}, {3.827375695160424*^9, 3.8273756955457726`*^9}, {
   3.827375935594575*^9, 3.827376037502409*^9}, 3.827376097009632*^9, {
   3.8273761358335395`*^9, 3.8273762805844584`*^9}, {3.8273763511424737`*^9, 
   3.8273763548404393`*^9}, {3.8273763937343235`*^9, 3.82737639423722*^9}, {
   3.8273764400343804`*^9, 3.8273764978057265`*^9}, {3.827376853596767*^9, 
   3.8273770370617523`*^9}, {3.8273772533529687`*^9, 3.827377265050684*^9}, 
   3.827377337220194*^9, {3.8273775589330053`*^9, 3.8273775685141134`*^9}, {
   3.827377620158334*^9, 3.827377627595456*^9}, {3.8273776590043125`*^9, 
   3.82737767201129*^9}, {3.827378316518313*^9, 3.827378325337389*^9}, {
   3.8273785097638483`*^9, 3.827378510704806*^9}, {3.827379283570999*^9, 
   3.827379310527672*^9}, {3.8273793450753756`*^9, 3.8273794445595655`*^9}, {
   3.8273795017191668`*^9, 3.8273795092514095`*^9}, {3.827379541123621*^9, 
   3.827379544803423*^9}, {3.827379603281799*^9, 3.827379627340695*^9}, {
   3.8273796906735353`*^9, 3.82737971804807*^9}, {3.8273801861160727`*^9, 
   3.827380278658374*^9}, {3.8273803108018947`*^9, 3.8273803222478456`*^9}, {
   3.8273808637748156`*^9, 3.827380870460575*^9}, {3.827380907445607*^9, 
   3.8273809141482673`*^9}, {3.827411292617546*^9, 3.827411406128183*^9}, {
   3.8274179932595015`*^9, 3.827418003411432*^9}, {3.827422683338315*^9, 
   3.827422692892761*^9}, {3.8281959425562873`*^9, 3.8281959731346674`*^9}, {
   3.828285197326238*^9, 3.828285217646686*^9}, {3.828317358098154*^9, 
   3.828317392124699*^9}, 3.82831742404025*^9, {3.8283174836315603`*^9, 
   3.828317487982047*^9}, 3.828317521629397*^9, {3.828317564905623*^9, 
   3.828317572819885*^9}, {3.8283176530372667`*^9, 3.8283177033100247`*^9}, {
   3.82831773857238*^9, 3.828317740523875*^9}, {3.8283177851669436`*^9, 
   3.8283177967226562`*^9}, {3.828317838411257*^9, 3.8283178520216284`*^9}, {
   3.8283179845716996`*^9, 3.8283179953331733`*^9}, {3.828318078331085*^9, 
   3.828318117150732*^9}, {3.828318164704564*^9, 3.828318171227944*^9}, {
   3.8283182184670076`*^9, 3.828318228928816*^9}, {3.828318346318122*^9, 
   3.828318351608906*^9}, {3.8283184665472393`*^9, 3.82831848101363*^9}, {
   3.8283185189652977`*^9, 3.828318519343275*^9}, {3.828318582641528*^9, 
   3.8283185867978287`*^9}, {3.8283186428996553`*^9, 3.828318654991687*^9}, {
   3.8283186881544933`*^9, 3.8283186882408695`*^9}, 3.8283188410802093`*^9, {
   3.8283188826048727`*^9, 3.8283189049015417`*^9}, {3.8283190680678177`*^9, 
   3.828319073944594*^9}, {3.828319116079465*^9, 3.8283191180062904`*^9}, {
   3.8283192153997545`*^9, 3.828319308640539*^9}, {3.8283193849950194`*^9, 
   3.8283194028293667`*^9}, {3.828319443950143*^9, 3.82831946481851*^9}, {
   3.828319925147503*^9, 3.828320065270408*^9}, {3.8283201007526016`*^9, 
   3.8283201036102157`*^9}, {3.82832020152948*^9, 3.8283202255011024`*^9}, {
   3.828320329448701*^9, 3.828320332740529*^9}, {3.8283203700543137`*^9, 
   3.8283203748282824`*^9}, {3.8283206448827767`*^9, 3.828320658530199*^9}, {
   3.828320711962123*^9, 3.8283207429854107`*^9}, {3.828320874690604*^9, 
   3.828320880981717*^9}, {3.828320924951073*^9, 3.828320945116345*^9}, {
   3.8283210037986717`*^9, 3.8283210629927697`*^9}, {3.828321103691003*^9, 
   3.82832116897496*^9}, {3.8283212937822123`*^9, 3.8283213238938675`*^9}, {
   3.8283214141758213`*^9, 3.828321415632143*^9}, {3.828321990190079*^9, 
   3.82832201465233*^9}, {3.8283224246307135`*^9, 3.828322455754784*^9}, {
   3.8283229310615606`*^9, 3.8283229329626894`*^9}, {3.8283229951380615`*^9, 
   3.828322997596115*^9}, {3.82832306640055*^9, 3.8283231330989447`*^9}, {
   3.8283232603235292`*^9, 3.8283232640661154`*^9}, {3.828323350976202*^9, 
   3.8283233519137316`*^9}, {3.8283258275708647`*^9, 
   3.8283258358221903`*^9}, {3.8283258952396307`*^9, 
   3.8283259223683543`*^9}, {3.8283259697739077`*^9, 
   3.8283260165186577`*^9}, {3.8283262632574644`*^9, 
   3.8283263220974545`*^9}, {3.8283263731086454`*^9, 
   3.8283263907604494`*^9}, {3.828326425377146*^9, 3.8283264605063925`*^9}, {
   3.8283265132516413`*^9, 3.828326545405806*^9}, {3.82832658635598*^9, 
   3.828326593592351*^9}, {3.8283266602668657`*^9, 3.8283266653052664`*^9}, {
   3.8283268105461307`*^9, 3.8283268143059406`*^9}, {3.8283270990393143`*^9, 
   3.8283272179560394`*^9}, {3.828327286739512*^9, 3.8283273237732306`*^9}, {
   3.828327414011693*^9, 3.828327416513901*^9}, {3.8283275333331757`*^9, 
   3.8283275339018087`*^9}, {3.8283275705218983`*^9, 3.828327581705743*^9}, 
   3.8283277764038415`*^9, {3.828327807608636*^9, 3.8283278092188873`*^9}, {
   3.8283278450773697`*^9, 3.8283279967025995`*^9}, {3.8283280532459483`*^9, 
   3.828328057456399*^9}, {3.8283280959427385`*^9, 3.8283281259438953`*^9}, {
   3.828328189030698*^9, 3.8283281964386206`*^9}, 3.828328261474009*^9, {
   3.828328314365557*^9, 3.8283283246017294`*^9}, {3.828328527437698*^9, 
   3.8283285341829367`*^9}, {3.8283285768900704`*^9, 3.828328598599165*^9}, {
   3.8283286868211184`*^9, 3.828328704803662*^9}, {3.8283287962578773`*^9, 
   3.828328804819564*^9}, {3.82832885254832*^9, 3.8283288559101334`*^9}, {
   3.8283290975981236`*^9, 3.8283291323011217`*^9}, {3.828329165026599*^9, 
   3.828329174003543*^9}, {3.8283292343641467`*^9, 3.8283292402675023`*^9}, 
   3.8283295757076073`*^9, {3.8283301263462167`*^9, 3.828330142947116*^9}, {
   3.828330195030443*^9, 3.828330237595038*^9}, {3.82833038889217*^9, 
   3.8283303900669603`*^9}, {3.8283723772623615`*^9, 3.82837238801442*^9}, {
   3.8283724661675515`*^9, 3.8283724747228317`*^9}, {3.8283738423972096`*^9, 
   3.8283738429876437`*^9}, {3.828373873104534*^9, 3.828374093941723*^9}, {
   3.8283741410820627`*^9, 3.8283741431800117`*^9}, 3.828374264716569*^9, {
   3.8283743986042385`*^9, 3.828374418038988*^9}, 3.828374821939537*^9, {
   3.8283751365776625`*^9, 3.82837513720856*^9}, {3.82837538117721*^9, 
   3.8283754045037785`*^9}, {3.828375575985109*^9, 3.8283756114278812`*^9}, 
   3.828375864578467*^9, 3.828375939898037*^9, {3.8283761160151296`*^9, 
   3.828376118302128*^9}, 3.828376334711871*^9, 3.8283901082954507`*^9},
 CellLabel->"In[22]:=",ExpressionUUID->"0233a10c-dd8c-4a7f-b97f-a1d0cda2dcdc"]
}, Closed]],

Cell[CellGroupData[{

Cell["Auxiliary considerations,", "Section",
 CellChangeTimes->{{3.83926856871553*^9, 3.8392685939519787`*^9}, {
  3.8553317894276485`*^9, 3.8553317904376183`*^9}, {3.855335477114256*^9, 
  3.8553354821111484`*^9}},ExpressionUUID->"1cd405a8-5614-4138-b154-\
14ec8879ad21"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fbobj", "=", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"d", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Mu]\[Psi]data", ",", "_Real", ",", "2"}], "}"}]}], "}"}], 
     ",", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"objF", "[", 
        RowBox[{
         RowBox[{"\[Mu]\[Psi]set", "[", "\[Mu]\[Psi]data", "]"}], ",", "d"}], 
        "]"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.841089099565384*^9, 3.8410891055885134`*^9}, {
   3.8410891553904147`*^9, 3.8410891583070917`*^9}, {3.841089212236718*^9, 
   3.841089219547532*^9}, {3.8553314342956667`*^9, 3.855331438527002*^9}, {
   3.855395674998135*^9, 3.8553957349779744`*^9}, {3.855397316540831*^9, 
   3.8553973195102925`*^9}, 3.85539743476799*^9},
 CellLabel->"In[23]:=",ExpressionUUID->"1d87d45d-e21f-47c6-bb1d-8ff5ff0a5667"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Objgraph", "[", 
   RowBox[{
   "verticesList_", ",", "saList_", ",", "dList_", ",", "IFnSet_", ",", 
    "\[Mu]\[Psi]data_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"qmax", ",", "sVec", ",", "brcount", ",", "p", ",", "q"}], "}"}],
     ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"qmax", "=", 
      RowBox[{"Max", "[", 
       RowBox[{"Flatten", "[", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"fbobj", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"#", "[", "0", "]"}], "&"}], "/@", 
              RowBox[{"IFnSet", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"saList", "[", 
                   RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "j", ",", 
                 "k"}], "]"}], "]"}]}], ",", "\[Mu]\[Psi]data"}], "]"}], 
           ")"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", "saList", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"saList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", 
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"saList", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", 
              RowBox[{"[", "j", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"ParametricPlot", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"sVec", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"1", "/", "8"}], ")"}], 
               RowBox[{
                RowBox[{"dList", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", 
                RowBox[{"[", "k", "]"}], "]"}], 
               RowBox[{
                RowBox[{"RotationMatrix", "[", 
                 RowBox[{
                  RowBox[{"-", "\[Pi]"}], "/", "2"}], "]"}], ".", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"verticesList", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "]"}], "-", 
                  RowBox[{"verticesList", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                 ")"}]}]}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"sVec", "+", 
                 RowBox[{"verticesList", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                ")"}], 
               RowBox[{"(", 
                RowBox[{"1", "-", "t"}], ")"}]}], "+", 
              RowBox[{"t", " ", 
               RowBox[{"(", 
                RowBox[{"sVec", "+", 
                 RowBox[{"verticesList", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "]"}]}], 
                ")"}]}]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"ColorFunction", "\[Rule]", " ", 
             RowBox[{"Function", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"x", ",", "y", ",", "t"}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"q", "=", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"fbobj", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"#", "[", "t", "]"}], "&"}], "/@", 
                    RowBox[{"IFnSet", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "j", ",", 
                    "k"}], "]"}], "]"}]}], ",", "\[Mu]\[Psi]data"}], "]"}], 
                    ")"}], "/", 
                   RowBox[{"(", "qmax", ")"}]}], ")"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"RGBColor", "@", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"q", 
                    RowBox[{"{", 
                    RowBox[{"0.95", ",", "0.26", ",", "0.26"}], "}"}]}], "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "-", "q"}], ")"}], 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0.75", ",", "0.1"}], "}"}]}]}], 
                  ")"}]}]}]}], "]"}]}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", " ", 
             RowBox[{"Thickness", "[", "0.015", "]"}]}], ",", 
            RowBox[{"PlotLabel", "\[Rule]", "\"\<ObjectiveBasedIndex\>\""}], 
            " ", ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{
               RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
               RowBox[{"FontSize", "\[Rule]", "16"}], ",", "Black"}], "]"}]}],
             ",", 
            RowBox[{"PlotPoints", "\[Rule]", " ", "40"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", "saList", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"saList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", 
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"saList", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", 
              RowBox[{"[", "j", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], "]"}], 
       ",", 
       RowBox[{"Axes", "\[Rule]", " ", "False"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", " ", "All"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", " ", "1"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", " ", "400"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.841089231814159*^9, 3.841089232609198*^9}, {
   3.8410892680811653`*^9, 3.8410893299125447`*^9}, {3.841089744980545*^9, 
   3.8410897908797665`*^9}, {3.841089994264949*^9, 3.841089995652326*^9}, {
   3.8410900323071375`*^9, 3.8410900364074707`*^9}, {3.841090142868117*^9, 
   3.8410901480208797`*^9}, {3.8410902047398586`*^9, 3.841090205040851*^9}, 
   3.8442833887871017`*^9, 3.8442900224339685`*^9, 3.8442905034131355`*^9, {
   3.844767929839446*^9, 3.844767931278738*^9}, {3.844769856288351*^9, 
   3.844769859127376*^9}, {3.844772196356539*^9, 3.8447722008884645`*^9}, {
   3.8553960527338963`*^9, 3.8553960599657445`*^9}, 3.8553961812366915`*^9, 
   3.855397743450823*^9, {3.855837556284461*^9, 3.8558375598953905`*^9}, {
   3.8558381965586505`*^9, 3.855838421425169*^9}, {3.8558386377489543`*^9, 
   3.85583864421078*^9}, 3.8558387681060333`*^9, {3.855838856067485*^9, 
   3.8558388785340567`*^9}, 3.8558389693256035`*^9, {3.855839025452482*^9, 
   3.85583903952172*^9}, {3.8558390921073956`*^9, 3.855839104654515*^9}, {
   3.8558391664822693`*^9, 3.855839167868357*^9}, {3.8558392256566753`*^9, 
   3.855839230340294*^9}},
 CellLabel->"In[24]:=",ExpressionUUID->"490ddcd5-d8c8-4412-8c32-60d687a6314a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BrIden", "=", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"d", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Mu]\[Psi]set", ",", "_Real", ",", "2"}], "}"}]}], "}"}], 
     ",", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "rm", ",", "s", ",", "t", ",", "u", ",", "v", ",", "\[Mu]j", ",", 
         "l1", ",", "l3", ",", "\[Mu]0", ",", "\[Psi]0", ",", "\[Alpha]", ",",
          "\[Beta]", ",", "\[Gamma]", ",", "\[Psi]e", ",", "\[CurlyPhi]", ",",
          "\[Lambda]", ",", "\[Epsilon]"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[Epsilon]", "=", "2.5"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}], "=", 
         "d"}], ";", 
        RowBox[{"l1", "=", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           SuperscriptBox["u", "2"], "+", 
           SuperscriptBox["v", "2"]}], "]"}]}], ";", 
        RowBox[{"l3", "=", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           SuperscriptBox["s", "2"], "+", 
           SuperscriptBox["t", "2"]}], "]"}]}], ";", 
        RowBox[{"\[Mu]0", "=", 
         RowBox[{"ArcTan", "[", 
          RowBox[{"u", ",", "v"}], "]"}]}], ";", 
        RowBox[{"\[Psi]0", "=", 
         RowBox[{"ArcTan", "[", 
          RowBox[{"s", ",", "t"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Mu]j", "=", 
            RowBox[{
             RowBox[{"\[Mu]\[Psi]set", "[", 
              RowBox[{"[", "j", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"\[Alpha]", "=", " ", 
            RowBox[{"l3", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "l1"}], " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Mu]0", "+", "\[Mu]j", "-", "\[Psi]0"}], "]"}]}], 
               "+", 
               RowBox[{"Cos", "[", "\[Psi]0", "]"}]}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"\[Beta]", "=", 
            RowBox[{
             RowBox[{"-", " ", "l3"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"l1", " ", 
                RowBox[{"Sin", "[", 
                 RowBox[{"\[Mu]0", "+", "\[Mu]j", "-", "\[Psi]0"}], "]"}]}], 
               "+", 
               RowBox[{"Sin", "[", "\[Psi]0", "]"}]}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"\[Gamma]", "=", 
            RowBox[{"-", " ", 
             RowBox[{"(", 
              RowBox[{"rm", "+", 
               RowBox[{"l1", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Mu]0", "+", "\[Mu]j"}], "]"}]}]}], ")"}]}]}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"\[CurlyPhi]", "=", 
            RowBox[{"ArcCos", "[", 
             RowBox[{"-", 
              FractionBox["\[Gamma]", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["\[Alpha]", "2"], "+", 
                 SuperscriptBox["\[Beta]", "2"]}]]]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"\[Lambda]", "=", 
            RowBox[{"ArcTan", "[", 
             RowBox[{"\[Alpha]", ",", "\[Beta]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"\[Psi]e", "=", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"Mod", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "\[CurlyPhi]"}], "+", "\[Lambda]"}], ",", 
                   RowBox[{"\[CurlyPhi]", "+", "\[Lambda]"}]}], "}"}], "-", 
                 RowBox[{
                  RowBox[{"\[Mu]\[Psi]set", "[", 
                   RowBox[{"[", "j", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                RowBox[{"2", "\[Pi]"}], ",", 
                RowBox[{"-", "\[Pi]"}]}], "]"}], "]"}], 
             RowBox[{"180", "/", "\[Pi]"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Psi]e", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "<", "\[Epsilon]"}], ",", "1", 
             ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"\[Psi]e", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "<", "\[Epsilon]"}], ",", 
               "2"}], "]"}], ",", "Null"}], "]"}]}], "\[IndentingNewLine]", 
          ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "2", ",", 
            RowBox[{"Length", "[", "\[Mu]\[Psi]set", "]"}]}], "}"}]}], 
         "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.8553955286878386`*^9, 3.855395551969384*^9}, 
   3.855831031458397*^9, {3.8558451291937*^9, 3.8558451302652264`*^9}, 
   3.855847265784023*^9, 3.8558473434203367`*^9, 3.8559293946918936`*^9, 
   3.855929426936657*^9, {3.855930487834957*^9, 3.855930488625643*^9}},
 CellLabel->"In[25]:=",ExpressionUUID->"868017dd-0ddc-4676-aa1e-3f10f4445fef"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fbbrpercent", "[", 
    RowBox[{"ndesign_", ",", "\[Mu]\[Psi]data_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "brdata", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"brdata", "=", 
       RowBox[{"Chop", "[", 
        RowBox[{
         RowBox[{"BrIden", "[", 
          RowBox[{"ndesign", ",", "\[Mu]\[Psi]data"}], "]"}], ",", 
         SuperscriptBox["10", 
          RowBox[{"-", "6"}]]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Flatten", "[", 
           RowBox[{"Position", "[", 
            RowBox[{"brdata", ",", "#"}], "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"Count", "[", 
            RowBox[{"brdata", ",", "#"}], "]"}], "/", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Length", "[", "\[Mu]\[Psi]data", "]"}], "-", "1"}], 
            ")"}]}]}], "}"}], "&"}], "/@", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.839224424320673*^9, 3.839224502433516*^9}, {
  3.8392249013231783`*^9, 3.8392249424195976`*^9}, {3.839224978807487*^9, 
  3.8392249829487257`*^9}, {3.839231468006855*^9, 3.8392314681435957`*^9}, {
  3.839231684851433*^9, 3.8392317275367928`*^9}, {3.8447733147565465`*^9, 
  3.844773344495102*^9}, {3.8447737520781918`*^9, 3.844773752436376*^9}, {
  3.8559294399701843`*^9, 3.8559294464958467`*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"41f3bc72-ddb9-4259-805c-35e6e3cbe5b4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BrPercentgraph", "[", 
   RowBox[{
   "verticesList_", ",", "saList_", ",", "dList_", ",", "IFnSet_", ",", 
    "\[Mu]\[Psi]data_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"sVec", ",", "brcount", ",", "q"}], "}"}], ",", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", 
     RowBox[{
      RowBox[{"Flatten", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
         "ParametricPlot", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"sVec", "=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1", "/", "8"}], ")"}], 
              RowBox[{
               RowBox[{"dList", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "k", "]"}], "]"}], 
              RowBox[{
               RowBox[{"RotationMatrix", "[", 
                RowBox[{
                 RowBox[{"-", "\[Pi]"}], "/", "2"}], "]"}], ".", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"verticesList", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "]"}], "-", 
                 RowBox[{"verticesList", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                ")"}]}]}]}], ";", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"sVec", "+", 
                RowBox[{"verticesList", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
               ")"}], 
              RowBox[{"(", 
               RowBox[{"1", "-", "t"}], ")"}]}], "+", 
             RowBox[{"t", " ", 
              RowBox[{"(", 
               RowBox[{"sVec", "+", 
                RowBox[{"verticesList", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "]"}]}], 
               ")"}]}]}]}], ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"ColorFunction", "\[Rule]", " ", 
            RowBox[{"Function", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"x", ",", "y", ",", "t"}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"brcount", "=", 
                RowBox[{"fbbrpercent", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"#", "[", "t", "]"}], "&"}], "/@", 
                   RowBox[{"IFnSet", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "j", ",", 
                    "k"}], "]"}], "]"}]}], ",", "\[Mu]\[Psi]data"}], "]"}]}], 
               ";", "\[IndentingNewLine]", 
               RowBox[{"q", "=", 
                RowBox[{"1", "-", 
                 RowBox[{"Max", "[", 
                  RowBox[{"brcount", "[", 
                   RowBox[{"[", 
                    RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"RGBColor", "@", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"q", 
                   RowBox[{"{", 
                    RowBox[{"0.95", ",", "0.26", ",", "0.26"}], "}"}]}], "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"1", "-", "q"}], ")"}], 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0.75", ",", "0.1"}], "}"}]}]}], 
                 ")"}]}]}]}], "]"}]}], ",", 
           RowBox[{"PlotStyle", "\[Rule]", " ", 
            RowBox[{"Thickness", "[", "0.015", "]"}]}], ",", 
           RowBox[{"PlotLabel", "\[Rule]", "\"\<BranchDefectIndex\>\""}], " ",
            ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
            RowBox[{"Directive", "[", 
             RowBox[{
              RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
              RowBox[{"FontSize", "\[Rule]", "16"}], ",", "Black"}], "]"}]}], 
           ",", 
           RowBox[{"PlotPoints", "\[Rule]", " ", "40"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"Length", "[", "saList", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"Length", "[", 
            RowBox[{"saList", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", 
           RowBox[{"Length", "[", 
            RowBox[{
             RowBox[{"saList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "j", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], "]"}], 
      ",", 
      RowBox[{"Axes", "\[Rule]", " ", "False"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", " ", "All"}], ",", 
      RowBox[{"AspectRatio", "\[Rule]", " ", "1"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", " ", "400"}]}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.8392321421184673`*^9, 3.839232201805267*^9}, {
   3.839232233173311*^9, 3.8392322414665356`*^9}, {3.8392322908425975`*^9, 
   3.8392324116990066`*^9}, {3.839232522618564*^9, 3.8392325227525177`*^9}, {
   3.839232680254117*^9, 3.8392327045249047`*^9}, {3.83923273597913*^9, 
   3.839232738252926*^9}, {3.839233085071087*^9, 3.839233086122445*^9}, 
   3.83923792309466*^9, 3.8392387179258447`*^9, 3.8392387724796257`*^9, 
   3.839238830556204*^9, {3.839238901162663*^9, 3.8392389042603116`*^9}, {
   3.8392391633381596`*^9, 3.8392391921201344`*^9}, {3.839239227955724*^9, 
   3.8392392602499804`*^9}, {3.8392398164901943`*^9, 3.8392398191014457`*^9}, 
   3.844283174605979*^9, 3.844283255326038*^9, 3.844290003314061*^9, 
   3.844290488183818*^9, 3.855396101662642*^9, 3.855396183843474*^9, 
   3.855397747938771*^9, {3.855837564774232*^9, 3.8558375689388576`*^9}, {
   3.855839333453844*^9, 3.855839352282672*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"4fca05fc-bab8-4019-aa2c-5f7e75cb9df3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BrIden1", "=", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"d", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Mu]\[Psi]set", ",", "_Real", ",", "2"}], "}"}]}], "}"}], 
     ",", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "rm", ",", "s", ",", "t", ",", "u", ",", "v", ",", "\[Mu]j", ",", 
         "l1", ",", "l3", ",", "\[Mu]0", ",", "\[Psi]0", ",", "\[Alpha]", ",",
          "\[Beta]", ",", "\[Gamma]", ",", "\[Psi]e", ",", "\[CurlyPhi]", ",",
          "\[Lambda]", ",", "\[Epsilon]"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[Epsilon]", "=", "2.5"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}], "=", 
         "d"}], ";", 
        RowBox[{"l1", "=", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           SuperscriptBox["u", "2"], "+", 
           SuperscriptBox["v", "2"]}], "]"}]}], ";", 
        RowBox[{"l3", "=", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           SuperscriptBox["s", "2"], "+", 
           SuperscriptBox["t", "2"]}], "]"}]}], ";", 
        RowBox[{"\[Mu]0", "=", 
         RowBox[{"ArcTan", "[", 
          RowBox[{"u", ",", "v"}], "]"}]}], ";", 
        RowBox[{"\[Psi]0", "=", 
         RowBox[{"ArcTan", "[", 
          RowBox[{"s", ",", "t"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Mu]j", "=", 
            RowBox[{
             RowBox[{"\[Mu]\[Psi]set", "[", 
              RowBox[{"[", "j", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"\[Alpha]", "=", " ", 
            RowBox[{"l3", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "l1"}], " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Mu]0", "+", "\[Mu]j", "-", "\[Psi]0"}], "]"}]}], 
               "+", 
               RowBox[{"Cos", "[", "\[Psi]0", "]"}]}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"\[Beta]", "=", 
            RowBox[{
             RowBox[{"-", " ", "l3"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"l1", " ", 
                RowBox[{"Sin", "[", 
                 RowBox[{"\[Mu]0", "+", "\[Mu]j", "-", "\[Psi]0"}], "]"}]}], 
               "+", 
               RowBox[{"Sin", "[", "\[Psi]0", "]"}]}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"\[Gamma]", "=", 
            RowBox[{"-", " ", 
             RowBox[{"(", 
              RowBox[{"rm", "+", 
               RowBox[{"l1", " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"\[Mu]0", "+", "\[Mu]j"}], "]"}]}]}], ")"}]}]}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"\[CurlyPhi]", "=", 
            RowBox[{"ArcCos", "[", 
             RowBox[{"-", 
              FractionBox["\[Gamma]", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["\[Alpha]", "2"], "+", 
                 SuperscriptBox["\[Beta]", "2"]}]]]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"\[Lambda]", "=", 
            RowBox[{"ArcTan", "[", 
             RowBox[{"\[Alpha]", ",", "\[Beta]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"\[Psi]e", "=", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"Mod", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "\[CurlyPhi]"}], "+", "\[Lambda]"}], ",", 
                   RowBox[{"\[CurlyPhi]", "+", "\[Lambda]"}]}], "}"}], "-", 
                 RowBox[{
                  RowBox[{"\[Mu]\[Psi]set", "[", 
                   RowBox[{"[", "j", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                RowBox[{"2", "\[Pi]"}], ",", 
                RowBox[{"-", "\[Pi]"}]}], "]"}], "]"}], 
             RowBox[{"180", "/", "\[Pi]"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Psi]e", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "<", "\[Epsilon]"}], ",", "1", 
             ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"\[Psi]e", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "<", "\[Epsilon]"}], ",", 
               "2"}], "]"}], ",", "Null"}], "]"}]}], "\[IndentingNewLine]", 
          ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "2", ",", 
            RowBox[{"Length", "[", "\[Mu]\[Psi]set", "]"}]}], "}"}]}], 
         "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.8553955286878386`*^9, 3.855395551969384*^9}, 
   3.855831031458397*^9, {3.8558451291937*^9, 3.8558451302652264`*^9}, 
   3.8558472010169964`*^9, 3.8559300853683753`*^9, {3.8559302962353396`*^9, 
   3.855930297759383*^9}},
 CellLabel->"In[28]:=",ExpressionUUID->"f889b159-75c2-4e5f-8fc0-b388129b3b00"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fbtrangle", "[", 
    RowBox[{"ndesign_", ",", "\[Mu]\[Psi]data_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "brdata", ",", "brcount", ",", "br", ",", "\[Mu]\[Psi]data1", ",", 
       "c0x", ",", "c0y", ",", "d0x", ",", "d0y"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"brdata", "=", 
       RowBox[{"Chop", "[", 
        RowBox[{
         RowBox[{"BrIden1", "[", 
          RowBox[{"ndesign", ",", "\[Mu]\[Psi]data"}], "]"}], ",", 
         SuperscriptBox["10", 
          RowBox[{"-", "6"}]]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"brcount", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"Position", "[", 
             RowBox[{"brdata", ",", "#"}], "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"Count", "[", 
             RowBox[{"brdata", ",", "#"}], "]"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Length", "[", "\[Mu]\[Psi]data", "]"}], "-", "1"}], 
             ")"}]}]}], "}"}], "&"}], "/@", 
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"br", "=", 
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{
          RowBox[{"brcount", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
          RowBox[{"Max", "[", 
           RowBox[{"brcount", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Mu]\[Psi]data1", "=", 
       RowBox[{"\[Mu]\[Psi]data", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"brcount", "[", 
           RowBox[{"[", "br", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "\[Mu]\[Psi]data1", "]"}], "\[NotEqual]", 
         "0"}], ",", 
        RowBox[{"(*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Length", "[", "\[Mu]\[Psi]data1", "]"}], "/", 
           RowBox[{"Length", "[", "\[Mu]\[Psi]data", "]"}]}], ")"}], "*)"}], 
        RowBox[{"Min", "[", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"c0x", ",", "c0y", ",", "d0x", ",", "d0y"}], "}"}], "=", 
             RowBox[{"Chop", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"DKSol", "[", 
                 RowBox[{"ndesign", ",", 
                  RowBox[{
                   RowBox[{"\[Mu]\[Psi]data1", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", "br"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"2", ";;", 
                  RowBox[{"-", "1"}]}], "]"}], "]"}], ",", 
               SuperscriptBox["10", 
                RowBox[{"-", "6"}]]}], "]"}]}], ";", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"Chop", "[", 
             RowBox[{
              RowBox[{"Sqrt", "[", 
               RowBox[{"1", "-", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Normalize", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"d0x", ",", "d0y"}], "}"}], "-", 
                    RowBox[{"{", 
                    RowBox[{"c0x", ",", "c0y"}], "}"}]}], "]"}], ".", 
                   RowBox[{"Normalize", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"d0x", ",", "d0y"}], "}"}], "-", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}]}], "]"}]}], ")"}], "2"]}], 
               "]"}], ",", 
              SuperscriptBox["10", 
               RowBox[{"-", "6"}]]}], "]"}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", 
             RowBox[{"Length", "[", "\[Mu]\[Psi]data1", "]"}]}], "}"}]}], 
          "]"}], "]"}], ",", "0"}], "]"}]}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.839253973405836*^9, 3.8392539757309017`*^9}, {
   3.839258164429823*^9, 3.8392581830611105`*^9}, {3.8392588491378517`*^9, 
   3.839258914213969*^9}, {3.8392593346384764`*^9, 3.839259379630742*^9}, {
   3.8392663007641554`*^9, 3.8392663575078306`*^9}, {3.839266416876464*^9, 
   3.8392664379375143`*^9}, {3.8392672929616528`*^9, 3.83926748365088*^9}, {
   3.8392678545546255`*^9, 3.839267858649333*^9}, {3.839267922637364*^9, 
   3.839267941531927*^9}, {3.8392681029577293`*^9, 3.8392681185429797`*^9}, {
   3.839317314481903*^9, 3.839317320407316*^9}, {3.839317429572981*^9, 
   3.839317439575323*^9}, {3.8393175446665916`*^9, 3.8393175520258865`*^9}, 
   3.8553353281453047`*^9, 3.855335384206648*^9, 3.8557895286435747`*^9, 
   3.8558292634048767`*^9, 3.855831139124677*^9, 3.8558472067826085`*^9},
 CellLabel->"In[29]:=",ExpressionUUID->"913807e6-e711-4688-9762-722341c95005"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TrAnglegraph", "[", 
   RowBox[{
   "verticesList_", ",", "saList_", ",", "dList_", ",", "IFnSet_", ",", 
    "\[Mu]\[Psi]data_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"qlist", ",", "sVec", ",", "brcount", ",", "q"}], "}"}], ",", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"qlist", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"fbtrangle", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"#", "[", "t", "]"}], "&"}], "/@", 
            RowBox[{"IFnSet", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{
                RowBox[{"saList", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "j", ",", "k"}], 
              "]"}], "]"}]}], ",", "\[Mu]\[Psi]data"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"Length", "[", "saList", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"Length", "[", 
            RowBox[{"saList", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", 
           RowBox[{"Length", "[", 
            RowBox[{
             RowBox[{"saList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "j", "]"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "0", ",", "1", ",", "0.025"}], "}"}]}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ParametricPlot", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"sVec", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"1", "/", "8"}], ")"}], 
               RowBox[{
                RowBox[{"dList", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", 
                RowBox[{"[", "k", "]"}], "]"}], 
               RowBox[{
                RowBox[{"RotationMatrix", "[", 
                 RowBox[{
                  RowBox[{"-", "\[Pi]"}], "/", "2"}], "]"}], ".", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"verticesList", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "]"}], "-", 
                  RowBox[{"verticesList", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                 ")"}]}]}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"sVec", "+", 
                 RowBox[{"verticesList", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                ")"}], 
               RowBox[{"(", 
                RowBox[{"1", "-", "t"}], ")"}]}], "+", 
              RowBox[{"t", " ", 
               RowBox[{"(", 
                RowBox[{"sVec", "+", 
                 RowBox[{"verticesList", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "]"}]}], 
                ")"}]}]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"ColorFunction", "\[Rule]", " ", 
             RowBox[{"Function", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"x", ",", "y", ",", "t"}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"q", "=", 
                 RowBox[{"1", "-", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"fbtrangle", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"#", "[", "t", "]"}], "&"}], "/@", 
                    RowBox[{"IFnSet", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "j", ",", 
                    "k"}], "]"}], "]"}]}], ",", "\[Mu]\[Psi]data"}], "]"}], 
                    "-", 
                    RowBox[{"Min", "[", "qlist", "]"}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Max", "[", "qlist", "]"}], "-", 
                    RowBox[{"Min", "[", "qlist", "]"}]}], ")"}]}], ")"}]}]}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"RGBColor", "@", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"q", 
                    RowBox[{"{", 
                    RowBox[{"0.95", ",", "0.26", ",", "0.26"}], "}"}]}], "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "-", "q"}], ")"}], 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0.75", ",", "0.1"}], "}"}]}]}], 
                  ")"}]}]}]}], "]"}]}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", " ", 
             RowBox[{"Thickness", "[", "0.015", "]"}]}], ",", 
            RowBox[{
            "PlotLabel", "\[Rule]", "\"\<TransmissionAngleIndex\>\""}], " ", 
            ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{
               RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
               RowBox[{"FontSize", "\[Rule]", "16"}], ",", "Black"}], "]"}]}],
             ",", 
            RowBox[{"PlotPoints", "\[Rule]", " ", "40"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", "saList", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"saList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", 
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"saList", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", 
              RowBox[{"[", "j", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], "]"}], 
       ",", 
       RowBox[{"Axes", "\[Rule]", " ", "False"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", " ", "All"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", " ", "1"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", " ", "400"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.839253931434913*^9, 3.8392539361951303`*^9}, {
   3.8392539916433105`*^9, 3.839254017638483*^9}, {3.8392675148076487`*^9, 
   3.8392675442147512`*^9}, {3.839267629294548*^9, 3.8392676293884044`*^9}, 
   3.8392676782060103`*^9, {3.839267840477273*^9, 3.839267842151763*^9}, {
   3.8392688172420387`*^9, 3.839268817543516*^9}, {3.8392813172583323`*^9, 
   3.8392813182270203`*^9}, {3.839281436353706*^9, 3.8392814636620617`*^9}, {
   3.839281599112365*^9, 3.8392815994228587`*^9}, {3.8394939514353237`*^9, 
   3.8394939523767524`*^9}, 3.8442832760529895`*^9, 3.844290013046694*^9, 
   3.8442904951611958`*^9, {3.855335867390317*^9, 3.855335881320617*^9}, {
   3.855336224991414*^9, 3.855336225593023*^9}, 3.8553961072181025`*^9, 
   3.8553961863858395`*^9, 3.8553977520018473`*^9, {3.855837574723098*^9, 
   3.8558375760996156`*^9}, {3.855839365943905*^9, 3.8558393932249155`*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"fc0916d9-b244-4b84-9de4-2bf5d28fd577"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fbpd", "[", 
    RowBox[{"ndesign_", ",", "\[Mu]\[Psi]data_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"indices", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "3"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "4"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "4"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"3", ",", "4"}], "}"}]}], "}"}]}], ",", "range\[Mu]", ",", 
       "brcount", ",", "br", ",", "pvts", ",", "v", ",", "\[Mu]", ",", 
       "maxDist", ",", "\[Epsilon]"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"\[Epsilon]", "=", "2.5"}], ";", "\[IndentingNewLine]", 
      RowBox[{"range\[Mu]", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Min", "[", 
          RowBox[{"\[Mu]\[Psi]data", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}], ",", 
         RowBox[{"Max", "[", 
          RowBox[{"\[Mu]\[Psi]data", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"brcount", "=", 
       RowBox[{"fbbrpercent", "[", 
        RowBox[{"ndesign", ",", "\[Mu]\[Psi]data"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"br", "=", 
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{
          RowBox[{"brcount", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
          RowBox[{"Max", "[", 
           RowBox[{"brcount", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"maxDist", "=", 
       RowBox[{"Max", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"pvts", "=", 
            RowBox[{"DKSol", "[", 
             RowBox[{"ndesign", ",", "\[Mu]", ",", "br"}], "]"}]}], ";", 
           RowBox[{"v", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"pvts", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], ",", 
                RowBox[{"pvts", "[", 
                 RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"pvts", "[", 
                 RowBox[{"[", "4", "]"}], "]"}], ",", 
                RowBox[{"pvts", "[", 
                 RowBox[{"[", "5", "]"}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0"}], "}"}]}], "}"}]}], ";", 
           RowBox[{"Max", "[", 
            RowBox[{"Chop", "[", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Max", "[", 
                   RowBox[{"Abs", "[", 
                    RowBox[{"Im", "[", 
                    RowBox[{"Flatten", "[", "v", "]"}], "]"}], "]"}], "]"}], 
                  "<", 
                  SuperscriptBox["10", 
                   RowBox[{"-", "6"}]]}], ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"v", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], "-", 
                    RowBox[{"v", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}]}], ")"}], 
                  ".", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"v", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], "-", 
                    RowBox[{"v", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "]"}]}], ")"}]}], 
                 ",", "1"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "indices"}], "}"}]}], "]"}], "]"}], "]"}]}],
           ",", 
          RowBox[{"{", 
           RowBox[{"\[Mu]", ",", 
            RowBox[{"range\[Mu]", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"range\[Mu]", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{"\[Epsilon]", " ", 
             RowBox[{"\[Pi]", "/", "180"}]}]}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Sqrt", "[", "maxDist", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.8389831904290295`*^9, 3.8389831913797207`*^9}, {
  3.838984184558483*^9, 3.838984184700742*^9}, {3.83906819401334*^9, 
  3.83906821138745*^9}, {3.8390682444862137`*^9, 3.839068266312893*^9}, {
  3.8390683095749655`*^9, 3.839068323174353*^9}, {3.839068422778631*^9, 
  3.8390684402705297`*^9}, {3.8390751526857233`*^9, 3.839075155608567*^9}, {
  3.8394915894371123`*^9, 3.8394916331903715`*^9}, {3.8553357538902783`*^9, 
  3.8553357906953487`*^9}, {3.8554081657239165`*^9, 3.8553964051854916`*^9}, {
  3.855824234714676*^9, 3.855824239783392*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"798a6ed4-d803-420b-8f78-c2da8b0b7a5e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PDgraph", "[", 
   RowBox[{
   "verticesList_", ",", "saList_", ",", "dList_", ",", "IFnSet_", ",", 
    "\[Mu]\[Psi]data_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"qlist", ",", "sVec", ",", "q"}], "}"}], ",", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"qlist", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"fbpd", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"#", "[", "t", "]"}], "&"}], "/@", 
            RowBox[{"IFnSet", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{
                RowBox[{"saList", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "j", ",", "k"}], 
              "]"}], "]"}]}], ",", "\[Mu]\[Psi]data"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"Length", "[", "saList", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"Length", "[", 
            RowBox[{"saList", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", 
           RowBox[{"Length", "[", 
            RowBox[{
             RowBox[{"saList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "j", "]"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "0", ",", "1", ",", "0.025"}], "}"}]}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"ParametricPlot", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"sVec", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"1", "/", "8"}], ")"}], 
               RowBox[{
                RowBox[{"dList", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", 
                RowBox[{"[", "k", "]"}], "]"}], 
               RowBox[{
                RowBox[{"RotationMatrix", "[", 
                 RowBox[{
                  RowBox[{"-", "\[Pi]"}], "/", "2"}], "]"}], ".", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"verticesList", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "]"}], "-", 
                  RowBox[{"verticesList", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                 ")"}]}]}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"sVec", "+", 
                 RowBox[{"verticesList", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                ")"}], 
               RowBox[{"(", 
                RowBox[{"1", "-", "t"}], ")"}]}], "+", 
              RowBox[{"t", " ", 
               RowBox[{"(", 
                RowBox[{"sVec", "+", 
                 RowBox[{"verticesList", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "]"}]}], 
                ")"}]}]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"ColorFunction", "\[Rule]", " ", 
             RowBox[{"Function", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"x", ",", "y", ",", "t"}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"q", "=", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"fbpd", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"#", "[", "t", "]"}], "&"}], "/@", 
                    RowBox[{"IFnSet", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "j", ",", 
                    "k"}], "]"}], "]"}]}], ",", "\[Mu]\[Psi]data"}], "]"}], 
                    "-", 
                    RowBox[{"Min", "[", "qlist", "]"}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Max", "[", "qlist", "]"}], "-", 
                    RowBox[{"Min", "[", "qlist", "]"}]}], ")"}]}], ")"}]}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"RGBColor", "@", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"q", 
                    RowBox[{"{", 
                    RowBox[{"0.95", ",", "0.26", ",", "0.26"}], "}"}]}], "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "-", "q"}], ")"}], 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0.75", ",", "0.1"}], "}"}]}]}], 
                  ")"}]}]}]}], "]"}]}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", " ", 
             RowBox[{"Thickness", "[", "0.015", "]"}]}], ",", 
            RowBox[{"PlotLabel", "\[Rule]", "\"\<PolygonDiagonalIndex\>\""}], 
            " ", ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{
               RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
               RowBox[{"FontSize", "\[Rule]", "16"}], ",", "Black"}], "]"}]}],
             ",", 
            RowBox[{"PlotPoints", "\[Rule]", "40"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", "saList", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"saList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", 
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"saList", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", 
              RowBox[{"[", "j", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], "]"}], 
       ",", 
       RowBox[{"Axes", "\[Rule]", " ", "False"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", " ", "All"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", " ", "1"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", " ", "400"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.83907517907823*^9, 3.839075244400502*^9}, {
   3.8390753023775625`*^9, 3.8390753928971186`*^9}, {3.8392226131426287`*^9, 
   3.8392226135379815`*^9}, 3.8392227135458584`*^9, {3.8392315465344687`*^9, 
   3.839231546784645*^9}, {3.839237894160692*^9, 3.8392379116812444`*^9}, {
   3.8392386907508163`*^9, 3.839238697078699*^9}, 3.8392387819231043`*^9, 
   3.839238821509905*^9, 3.839238915507142*^9, 3.839239309989403*^9, {
   3.8394939554922304`*^9, 3.839493956345589*^9}, 3.844283265655566*^9, 
   3.8442900090131516`*^9, 3.8442904909854965`*^9, 3.855335884524808*^9, {
   3.8553362074028645`*^9, 3.85533620794292*^9}, 3.855396111035387*^9, 
   3.8553961884397125`*^9, 3.8553977544985633`*^9, {3.8558375805302534`*^9, 
   3.855837581866076*^9}, {3.8558393999903145`*^9, 3.8558394122321377`*^9}},
 CellLabel->"In[32]:=",ExpressionUUID->"d402e15b-36a0-4939-9448-76414884e720"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fbmaxlen", "=", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"d", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "rm", ",", "s", ",", "t", ",", "u", ",", "v", ",", "l1s", ",", "l2s", 
         ",", "l3s"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}], "=", 
         "d"}], ";", 
        RowBox[{"l1s", "=", 
         RowBox[{
          SuperscriptBox["u", "2"], "+", 
          SuperscriptBox["v", "2"]}]}], ";", 
        RowBox[{"l3s", "=", 
         RowBox[{
          SuperscriptBox["s", "2"], "+", 
          SuperscriptBox["t", "2"]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"l2s", "=", 
         RowBox[{"1", "+", 
          RowBox[{"2", " ", "rm"}], "+", "l3s", "+", "l1s"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"Max", "[", 
          RowBox[{"{", 
           RowBox[{"1", ",", "l1s", ",", "l2s", ",", "l3s"}], "}"}], "]"}], 
         "]"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.8554075317996387`*^9, 3.855407646632371*^9}, {
   3.8554076909045324`*^9, 3.8554077099338665`*^9}, {3.855407743962391*^9, 
   3.8554078035121617`*^9}, 3.8554079241663656`*^9},
 CellLabel->"In[33]:=",ExpressionUUID->"93b03d8c-3ad4-4cb8-9013-375fdbff6299"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MaxLengraph", "[", 
   RowBox[{
   "verticesList_", ",", "saList_", ",", "dList_", ",", "IFnSet_", ",", 
    "\[Mu]\[Psi]data_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"qlist", ",", "sVec", ",", "q"}], "}"}], ",", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"qlist", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"fbmaxlen", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", "t", "]"}], "&"}], "/@", 
           RowBox[{"IFnSet", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{
               RowBox[{"saList", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "j", ",", "k"}], 
             "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"Length", "[", "saList", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"Length", "[", 
            RowBox[{"saList", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", 
           RowBox[{"Length", "[", 
            RowBox[{
             RowBox[{"saList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "j", "]"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "0", ",", "1", ",", "0.025"}], "}"}]}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
          "ParametricPlot", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"sVec", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"1", "/", "8"}], ")"}], 
               RowBox[{
                RowBox[{"dList", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", 
                RowBox[{"[", "k", "]"}], "]"}], 
               RowBox[{
                RowBox[{"RotationMatrix", "[", 
                 RowBox[{
                  RowBox[{"-", "\[Pi]"}], "/", "2"}], "]"}], ".", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"verticesList", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "]"}], "-", 
                  RowBox[{"verticesList", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                 ")"}]}]}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"sVec", "+", 
                 RowBox[{"verticesList", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                ")"}], 
               RowBox[{"(", 
                RowBox[{"1", "-", "t"}], ")"}]}], "+", 
              RowBox[{"t", " ", 
               RowBox[{"(", 
                RowBox[{"sVec", "+", 
                 RowBox[{"verticesList", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "]"}]}], 
                ")"}]}]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"ColorFunction", "\[Rule]", " ", 
             RowBox[{"Function", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"x", ",", "y", ",", "t"}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"q", "=", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"fbmaxlen", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"#", "[", "t", "]"}], "&"}], "/@", 
                    RowBox[{"IFnSet", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "j", ",", 
                    "k"}], "]"}], "]"}]}], "]"}], "-", 
                    RowBox[{"Min", "[", "qlist", "]"}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Max", "[", "qlist", "]"}], "-", 
                    RowBox[{"Min", "[", "qlist", "]"}]}], ")"}]}], ")"}]}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"RGBColor", "@", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"q", 
                    RowBox[{"{", 
                    RowBox[{"0.95", ",", "0.26", ",", "0.26"}], "}"}]}], "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "-", "q"}], ")"}], 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0.75", ",", "0.1"}], "}"}]}]}], 
                  ")"}]}]}]}], "]"}]}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", " ", 
             RowBox[{"Thickness", "[", "0.015", "]"}]}], ",", 
            RowBox[{"PlotLabel", "\[Rule]", "\"\<MaximumLengthIndex\>\""}], 
            " ", ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{
               RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
               RowBox[{"FontSize", "\[Rule]", "16"}], ",", "Black"}], "]"}]}],
             ",", 
            RowBox[{"PlotPoints", "\[Rule]", "40"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", "saList", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"saList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", 
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"saList", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", 
              RowBox[{"[", "j", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], "]"}], 
       ",", 
       RowBox[{"Axes", "\[Rule]", " ", "False"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", " ", "All"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", " ", "1"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", " ", "400"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.839075466354025*^9, 3.8390755225345964`*^9}, {
   3.839222635329756*^9, 3.83922263547307*^9}, 3.839222716413653*^9, {
   3.8392315408707175`*^9, 3.8392315412577105`*^9}, 3.8392379179482317`*^9, 
   3.839238712808029*^9, 3.839238778952013*^9, {3.8392388105966797`*^9, 
   3.8392388130462723`*^9}, 3.839238912045474*^9, 3.8392393040516763`*^9, {
   3.839239496072771*^9, 3.8392395078703423`*^9}, {3.839239572713463*^9, 
   3.8392395733488865`*^9}, {3.839493962463908*^9, 3.8394939632545834`*^9}, {
   3.844283153298107*^9, 3.844283161479335*^9}, 3.844283251558428*^9, 
   3.8442899952866726`*^9, 3.844290484194163*^9, {3.855407928627925*^9, 
   3.8553961140947304`*^9}, 3.855396190441915*^9, 3.855397756415002*^9, {
   3.8558375860252066`*^9, 3.85583758950933*^9}, {3.855839417232169*^9, 
   3.85583946227524*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"b8b9c0eb-f395-42ec-bb6b-ac6eaaa90016"],

Cell[BoxData[
 RowBox[{
  RowBox[{"pdesign", "[", 
   RowBox[{"ndesign_", ",", "pertdat_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"r", ",", "s", ",", "t", ",", "u", ",", "v", ",", "rm"}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}], "=", 
      "ndesign"}], ";", "\[IndentingNewLine]", 
     RowBox[{"r", "=", 
      RowBox[{
       SqrtBox[
        RowBox[{"1", "+", 
         RowBox[{"2", " ", "rm"}], "+", 
         SuperscriptBox["s", "2"], "+", 
         SuperscriptBox["t", "2"], "+", 
         SuperscriptBox["u", "2"], "+", 
         SuperscriptBox["v", "2"]}]], "+", 
       RowBox[{"RandomVariate", "[", 
        RowBox[{"NormalDistribution", "[", 
         RowBox[{"0", ",", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"1.6129", " ", 
            SuperscriptBox["10", 
             RowBox[{"-", "8"}]]}], "]"}]}], "]"}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"s", ",", "t"}], "}"}], "=", 
      RowBox[{
       RowBox[{"ndesign", "[", 
        RowBox[{"[", 
         RowBox[{"2", ";;", "3"}], "]"}], "]"}], "+", 
       RowBox[{"pertdat", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"u", ",", "v"}], "}"}], "=", 
      RowBox[{
       RowBox[{"ndesign", "[", 
        RowBox[{"[", 
         RowBox[{"4", ";;", "5"}], "]"}], "]"}], "+", 
       RowBox[{"pertdat", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"rm", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "/", "2"}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["r", "2"], "-", 
         SuperscriptBox["s", "2"], "-", 
         SuperscriptBox["t", "2"], "-", 
         SuperscriptBox["u", "2"], "-", 
         SuperscriptBox["v", "2"]}], ")"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"rm", ",", "s", ",", "t", ",", "u", ",", "v"}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.8444703214469395`*^9, 3.844470353024739*^9}, {
   3.8444715144240475`*^9, 3.8444715195502777`*^9}, 3.8444731911600122`*^9, {
   3.8444733798184376`*^9, 3.8444734366495867`*^9}, {3.844473491351814*^9, 
   3.8444735443299685`*^9}, {3.844473617602533*^9, 3.844473623374642*^9}, {
   3.844473666518255*^9, 3.8444736962449665`*^9}, {3.8444738526816263`*^9, 
   3.8444738587167664`*^9}, {3.8444745932472954`*^9, 
   3.8444746457649007`*^9}, {3.8444747061766405`*^9, 3.84447475766286*^9}, {
   3.844775718012598*^9, 3.844775732313374*^9}, 3.8447758530178843`*^9},
 CellLabel->"In[35]:=",ExpressionUUID->"ac336509-1bbc-4c59-b01d-7c16450f63c8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SIndex", "[", 
   RowBox[{"ndesign_", ",", "\[Mu]\[Psi]data_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"nParams", ",", "N1", ",", "pertset", ",", "obj0"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"nParams", "=", 
      RowBox[{"\[Mu]\[Psi]set", "[", "\[Mu]\[Psi]data", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"N1", "=", "100"}], ";", "\[IndentingNewLine]", 
     RowBox[{"pertset", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"#", ",", "2"}], "]"}], "&"}], "/@", 
       RowBox[{"RandomVariate", "[", 
        RowBox[{
         RowBox[{"MultinormalDistribution", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{"0", ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "4"}], "}"}]}], "]"}], ",", 
           RowBox[{"1.6129", " ", 
            SuperscriptBox["10", 
             RowBox[{"-", "8"}]], 
            RowBox[{"IdentityMatrix", "[", "4", "]"}]}]}], "]"}], ",", "N1"}],
         "]"}]}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"obj0", "=", 
      RowBox[{"objF", "[", 
       RowBox[{"nParams", ",", "ndesign"}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Mean", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Abs", "[", 
          RowBox[{"(", 
           RowBox[{"obj0", "-", "#"}], ")"}], "]"}], "&"}], "/@", " ", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"objF", "[", 
           RowBox[{"nParams", ",", 
            RowBox[{"pdesign", "[", 
             RowBox[{"ndesign", ",", 
              RowBox[{"pertset", "[", 
               RowBox[{"[", "j", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "N1"}], "}"}]}], "]"}]}], "]"}], "/", 
      "obj0"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.844495718630657*^9, 3.844495859296561*^9}, {
   3.8444959434893417`*^9, 3.8444959582071695`*^9}, {3.844495991142147*^9, 
   3.844496017673731*^9}, {3.8444962437244177`*^9, 3.8444963272990923`*^9}, 
   3.855331692708637*^9, 3.8553335499086094`*^9, {3.8553358946210785`*^9, 
   3.8553358956318564`*^9}, 3.855396497389211*^9, {3.8559288250059824`*^9, 
   3.855928825439742*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"740a0822-bae3-4c7d-9a7b-d09ff8454c78"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sensitivitygraph", "[", 
   RowBox[{
   "verticesList_", ",", "saList_", ",", "dList_", ",", "IFnSet_", ",", 
    "\[Mu]\[Psi]data_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "qlist", ",", "qmin", ",", "qmax", ",", "sVec", ",", "brcount", ",", "p",
       ",", "q"}], "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"qlist", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"SIndex", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"#", "[", "t", "]"}], "&"}], "/@", 
            RowBox[{"IFnSet", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{
                RowBox[{"saList", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "j", ",", "k"}], 
              "]"}], "]"}]}], ",", "\[Mu]\[Psi]data"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"Length", "[", "saList", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"Length", "[", 
            RowBox[{"saList", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", 
           RowBox[{"Length", "[", 
            RowBox[{
             RowBox[{"saList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "j", "]"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "0", ",", "1", ",", "0.025"}], "}"}]}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"qmin", ",", "qmax"}], "}"}], "=", 
      RowBox[{"Quantile", "[", 
       RowBox[{"qlist", ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0.95"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
          "ParametricPlot", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"sVec", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"1", "/", "8"}], ")"}], 
               RowBox[{
                RowBox[{"dList", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", 
                RowBox[{"[", "k", "]"}], "]"}], 
               RowBox[{
                RowBox[{"RotationMatrix", "[", 
                 RowBox[{
                  RowBox[{"-", "\[Pi]"}], "/", "2"}], "]"}], ".", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"verticesList", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "]"}], "-", 
                  RowBox[{"verticesList", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                 ")"}]}]}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"sVec", "+", 
                 RowBox[{"verticesList", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                ")"}], 
               RowBox[{"(", 
                RowBox[{"1", "-", "t"}], ")"}]}], "+", 
              RowBox[{"t", " ", 
               RowBox[{"(", 
                RowBox[{"sVec", "+", 
                 RowBox[{"verticesList", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], "]"}]}], 
                ")"}]}]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"ColorFunction", "\[Rule]", " ", 
             RowBox[{"Function", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"x", ",", "y", ",", "t"}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"p", "=", 
                 RowBox[{"SIndex", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"#", "[", "t", "]"}], "&"}], "/@", 
                    RowBox[{"IFnSet", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"saList", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "j", ",", 
                    "k"}], "]"}], "]"}]}], ",", "\[Mu]\[Psi]data"}], "]"}]}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"p", "=", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"p", "<", "qmin"}], ",", "qmin", ",", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"p", ">", "qmax"}], ",", "qmax", ",", "p"}], 
                    "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"q", "=", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"p", "-", "qmin"}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"qmax", "-", "qmin"}], ")"}]}], ")"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"RGBColor", "@", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"q", 
                    RowBox[{"{", 
                    RowBox[{"0.95", ",", "0.26", ",", "0.26"}], "}"}]}], "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "-", "q"}], ")"}], 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0.75", ",", "0.1"}], "}"}]}]}], 
                  ")"}]}]}]}], "]"}]}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", " ", 
             RowBox[{"Thickness", "[", "0.015", "]"}]}], ",", 
            RowBox[{"PlotLabel", "\[Rule]", "\"\<SensitivityIndex\>\""}], " ",
             ",", 
            RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{
               RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
               RowBox[{"FontSize", "\[Rule]", "16"}], ",", "Black"}], "]"}]}],
             ",", 
            RowBox[{"PlotPoints", "\[Rule]", " ", "40"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", "saList", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"saList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", 
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"saList", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", 
              RowBox[{"[", "j", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], "]"}], 
       ",", 
       RowBox[{"Axes", "\[Rule]", " ", "False"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", " ", "All"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", " ", "1"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", " ", "400"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.8444971656975403`*^9, 3.844497183124895*^9}, {
   3.844497223263502*^9, 3.8444972675745754`*^9}, {3.8444978341714087`*^9, 
   3.84449783466584*^9}, {3.844765230618519*^9, 3.8447652308518023`*^9}, 
   3.8447758765685744`*^9, 3.8447771282238765`*^9, {3.8447814792768955`*^9, 
   3.8447814836907654`*^9}, 3.8450344104204197`*^9, {3.8553314097550287`*^9, 
   3.8553314134567327`*^9}, 3.8553335385439324`*^9, 3.8553354143817043`*^9, {
   3.855336235096064*^9, 3.855336235523569*^9}, 3.8553961198372164`*^9, 
   3.8553961940596933`*^9, 3.855397790089918*^9, {3.8558375939447746`*^9, 
   3.8558375958298235`*^9}, {3.8558394736951303`*^9, 3.8558394882859783`*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"ed0c5d64-401e-4fdd-b50c-d2d00615ecd9"]
}, Closed]],

Cell[CellGroupData[{

Cell["Design interface,", "Section",
 CellChangeTimes->{{3.839268630908456*^9, 3.839268650138199*^9}, {
  3.8553354695271025`*^9, 
  3.855335484320492*^9}},ExpressionUUID->"18855450-8db6-43bd-af54-\
100bcb063cdf"],

Cell["\<\
The following module creates the GUI for the designer to explore. It uses all \
the graphics modules from earlier and Mathematica\[CloseCurlyQuote]s Graph \
functionality.\
\>", "Text",
 CellChangeTimes->{{3.8283747657610083`*^9, 
  3.8283749181023755`*^9}},ExpressionUUID->"992e824f-87eb-48a8-a90c-\
a0b4b6a7d873"],

Cell[BoxData[
 RowBox[{
  RowBox[{"graphFnGen", "[", 
   RowBox[{
   "\[Mu]\[Psi]data_", ",", "ndesigns_", ",", "neigen_", ",", "IFnSet_"}], 
   "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "ind", ",", "ind1", ",", "ind0", ",", "saList", ",", "dList", ",", 
      "erList", ",", "saListU", ",", "layoutOS", ",", "edgesG", ",", "sVec", 
      ",", "verticesList", ",", "time", ",", "overlayObj", ",", "overlayPD", 
      ",", "overlayMaxLen", ",", "overlayBrPercent", ",", "overlayTrAngle", 
      ",", "overlaySensitivity", ",", "overlayStError", ",", "jn", ",", 
      "brcount", ",", "edgeButton", ",", "cpos", ",", "ePart", ",", "dset", 
      ",", "q", ",", "p"}], "}"}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ind", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"neigen", "[", 
            RowBox[{"[", 
             RowBox[{"j", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"#", "<", " ", "0"}], " ", "&"}]}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", 
          RowBox[{"Length", "[", "ndesigns", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"LocalQ", "[", "pos_", "]"}], ":=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ind", "[", 
          RowBox[{"[", "pos", "]"}], "]"}], "\[Equal]", "0"}], ",", "True", 
        ",", "False"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"SaddleQ", "[", "pos_", "]"}], ":=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ind", "[", 
          RowBox[{"[", "pos", "]"}], "]"}], "\[NotEqual]", " ", "0"}], ",", 
        "True", ",", "False"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"GlobalQ", "[", "pos_", "]"}], ":=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"pos", "\[Equal]", 
         RowBox[{"Length", "[", "ndesigns", "]"}]}], ",", "True", ",", 
        "False"}], "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"ind0", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Position", "[", 
        RowBox[{"ind", ",", 
         RowBox[{"_", "?", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"#", "\[Equal]", "0"}], " ", "&"}], ")"}]}]}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ind1", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Position", "[", 
        RowBox[{"ind", ",", 
         RowBox[{"_", "?", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"#", ">", "0"}], " ", "&"}], ")"}]}]}], "]"}], "]"}]}], 
     ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"saList", "=", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"erList", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"Norm", "[", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"#", "[", "1", "]"}], "&"}], "/@", 
                 RowBox[{"IFnSet", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"ind1", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", "j", ",", "k"}], 
                   "]"}], "]"}]}], ")"}], "-", "#"}], ")"}], "]"}], " ", 
            "&"}], "/@", 
           RowBox[{"(", 
            RowBox[{"IFnSet", "[", 
             RowBox[{"[", 
              RowBox[{"ind0", ",", "1", ",", "1"}], "]"}], "]"}], ")"}]}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Min", "[", "erList", "]"}], "\[LessEqual]", " ", 
            SuperscriptBox["10", 
             RowBox[{"-", "3"}]]}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ind1", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", " ", 
             RowBox[{"ind0", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"Position", "[", 
                 RowBox[{"erList", ",", 
                  RowBox[{"Min", "[", "erList", "]"}]}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
            "}"}]}], "]"}]}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "The", " ", "error", " ", "tolerance", " ", "for", " ", 
          "identifying", " ", "the", " ", "minimum", " ", "associated", " ", 
          "with", " ", "a", " ", "saddle", " ", "point", " ", "can", " ", 
          "be", " ", "changed", " ", "if", " ", "necessary"}], "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "ind1", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", 
          RowBox[{"Length", "[", 
           RowBox[{"IFnSet", "[", 
            RowBox[{"[", 
             RowBox[{"ind1", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "]"}]}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "1", ",", 
          RowBox[{"Length", "[", 
           RowBox[{"IFnSet", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"ind1", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "j"}], "]"}], "]"}], 
           "]"}]}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"dList", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "]"}], "]"}], 
           "\[NotEqual]", " ", 
           RowBox[{"#", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}], "]"}], "&"}], "/@", "saList"}]}],
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"saListU", "=", 
      RowBox[{"Flatten", "[", "saList", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"layoutOS", "=", 
      RowBox[{"Graph", "[", 
       RowBox[{"saListU", ",", 
        RowBox[{"EdgeWeight", "\[Rule]", 
         RowBox[{"ConstantArray", "[", 
          RowBox[{"1", ",", 
           RowBox[{"Length", "[", "saListU", "]"}]}], "]"}]}], ",", " ", 
        RowBox[{"VertexLabels", "\[Rule]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"i", "\[Rule]", 
            RowBox[{"\"\<\[NumberSign]\>\"", "<>", 
             RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<(\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"ind", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "]"}], "<>", "\"\<)\>\""}]}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"Length", "[", "ndesigns", "]"}]}], "}"}]}], "]"}]}], 
        ",", 
        RowBox[{"GraphLayout", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
           "\"\<VertexLayout\>\"", "\[Rule]", "\"\<TutteEmbedding\>\""}], ",", 
           RowBox[{"\"\<EdgeLayout\>\"", "\[Rule]", "\"\<StraightLine\>\""}], 
           ",", 
           RowBox[{
           "\"\<PackingLayout\>\"", "\[Rule]", " ", 
            "\"\<ClosestPacking\>\""}]}], "}"}]}], ",", 
        RowBox[{"VertexShapeFunction", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"_", "?", "LocalQ"}], "\[Rule]", "\"\<Star\>\""}], ",", 
           RowBox[{
            RowBox[{"_", "?", "SaddleQ"}], "\[Rule]", "\"\<Triangle\>\""}]}], 
          "}"}]}], ",", 
        RowBox[{"VertexSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Scaled\>\"", ",", "0.04"}], "}"}]}], ",", 
        RowBox[{"VertexStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"_", "?", "LocalQ"}], "\[Rule]", "Black"}], ",", 
           RowBox[{
            RowBox[{"_", "?", "SaddleQ"}], "\[Rule]", "Magenta"}], ",", 
           RowBox[{
            RowBox[{"_", "?", " ", "GlobalQ"}], "\[Rule]", 
            RowBox[{"Darker", "[", "Yellow", "]"}]}]}], "}"}]}], ",", 
        RowBox[{"EdgeStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{
           RowBox[{"Thickness", "[", "0.012", "]"}], ",", 
           RowBox[{"Darker", "[", "Blue", "]"}], ",", 
           RowBox[{"Opacity", "[", "1", "]"}]}], "]"}]}], ",", 
        RowBox[{"VertexLabelStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"Black", ",", "12"}], "]"}]}], ",", 
        RowBox[{"EdgeShapeFunction", "\[Rule]", 
         RowBox[{"GraphElementData", "[", 
          RowBox[{"{", 
           RowBox[{"\"\<FilledArrow\>\"", ",", 
            RowBox[{"\"\<ArrowSize\>\"", "\[Rule]", ".075"}]}], "}"}], 
          "]"}]}]}], "]"}]}], ";", "\n", "     ", 
     RowBox[{"edgesG", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"#", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"#", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "&"}], "/@", 
       "saListU"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"verticesList", "=", 
      RowBox[{
       RowBox[{"GraphEmbedding", "[", "layoutOS", "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"Ordering", "[", 
         RowBox[{"VertexList", "[", "layoutOS", "]"}], "]"}], "]"}], "]"}]}], 
     ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"{", 
         RowBox[{"verticesList", ",", "saList"}], "}"}], "]"}], ";"}], "*)"}],
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"time", ",", "overlayObj"}], "}"}], "=", 
      RowBox[{"AbsoluteTiming", "[", 
       RowBox[{"Objgraph", "[", 
        RowBox[{
        "verticesList", ",", "saList", ",", "dList", ",", "IFnSet", ",", 
         "\[Mu]\[Psi]data"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", "time", "]"}], ";"}], "*)"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"time", ",", "overlayBrPercent"}], "}"}], "=", 
      RowBox[{"AbsoluteTiming", "[", 
       RowBox[{"BrPercentgraph", "[", 
        RowBox[{
        "verticesList", ",", "saList", ",", "dList", ",", "IFnSet", ",", 
         "\[Mu]\[Psi]data"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", "time", "]"}], ";"}], "*)"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"time", ",", "overlayTrAngle"}], "}"}], "=", 
      RowBox[{"AbsoluteTiming", "[", 
       RowBox[{"TrAnglegraph", "[", 
        RowBox[{
        "verticesList", ",", "saList", ",", "dList", ",", "IFnSet", ",", 
         "\[Mu]\[Psi]data"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", "time", "]"}], ";"}], "*)"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"time", ",", "overlayPD"}], "}"}], "=", 
      RowBox[{"AbsoluteTiming", "[", 
       RowBox[{"PDgraph", "[", 
        RowBox[{
        "verticesList", ",", "saList", ",", "dList", ",", "IFnSet", ",", 
         "\[Mu]\[Psi]data"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", "time", "]"}], ";"}], "*)"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"time", ",", "overlayMaxLen"}], "}"}], "=", 
      RowBox[{"AbsoluteTiming", "[", 
       RowBox[{"MaxLengraph", "[", 
        RowBox[{
        "verticesList", ",", "saList", ",", "dList", ",", "IFnSet", ",", 
         "\[Mu]\[Psi]data"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", "time", "]"}], ";"}], "*)"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"time", ",", "overlaySensitivity"}], "}"}], "=", 
      RowBox[{"AbsoluteTiming", "[", 
       RowBox[{"Sensitivitygraph", "[", 
        RowBox[{
        "verticesList", ",", "saList", ",", "dList", ",", "IFnSet", ",", 
         "\[Mu]\[Psi]data"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", "time", "]"}], ";"}], "*)"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"jn", "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Dynamic", "[", "\[IndentingNewLine]", 
      RowBox[{
      "Manipulate", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"edgeButton", "=", 
          RowBox[{"Graphics", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"EdgeForm", "[", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Thickness", "[", 
                  RowBox[{"Scaled", "[", "0.005", "]"}], "]"}], ",", 
                 RowBox[{"Darker", "[", "Blue", "]"}]}], "}"}], "]"}], ",", 
              RowBox[{"FaceForm", "[", 
               RowBox[{"Lighter", "[", "Blue", "]"}], "]"}], ",", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"Disk", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"1", "/", "2"}], ")"}], " ", 
                   RowBox[{"Total", "[", 
                    RowBox[{"verticesList", "[", 
                    RowBox[{"[", 
                    RowBox[{"edgesG", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "]"}]}], 
                  " ", ",", 
                  RowBox[{"Scaled", "[", "0.03", "]"}]}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"k", ",", 
                  RowBox[{"Length", "[", "edgesG", "]"}]}], "}"}]}], "]"}]}], 
             "}"}], ",", 
            RowBox[{"Epilog", "\[Rule]", " ", 
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"With", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"j", "=", "k"}], "}"}], ",", 
                 RowBox[{"Inset", "[", 
                  RowBox[{
                   RowBox[{"Dynamic", "@", 
                    RowBox[{"Button", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"ToString", "[", 
                    RowBox[{"edgesG", "[", 
                    RowBox[{"[", 
                    RowBox[{"j", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
                    "\"\<-\>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"edgesG", "[", 
                    RowBox[{"[", 
                    RowBox[{"j", ",", "2"}], "]"}], "]"}], "]"}]}], ",", "8", 
                    ",", "Bold", ",", "Yellow"}], "]"}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"jn", "=", "j"}], ";"}], "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
                    RowBox[{"Appearance", "\[Rule]", " ", "None"}]}], "]"}]}],
                    ",", 
                   RowBox[{"Total", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "/", "2"}], ")"}], 
                    RowBox[{"verticesList", "[", 
                    RowBox[{"[", 
                    RowBox[{"edgesG", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "]"}], "]"}]}], "]"}]}], 
                  "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"k", ",", 
                 RowBox[{"Length", "[", "edgesG", "]"}]}], "}"}]}], "]"}]}]}],
            "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"ePart", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"IFnSet", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"ind1", "[", 
                RowBox[{"[", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", "3", "]"}], "]"}]}], "]"}], "]"}], "&"}], "/@", 
           RowBox[{"Position", "[", 
            RowBox[{"saList", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"edgesG", "[", 
                RowBox[{"[", 
                 RowBox[{"jn", ",", "1"}], "]"}], "]"}], "\[Rule]", " ", 
               RowBox[{"edgesG", "[", 
                RowBox[{"[", 
                 RowBox[{"jn", ",", " ", "2"}], "]"}], "]"}]}], "}"}]}], 
            "]"}]}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"dset", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", "t", "]"}], "&"}], "/@", 
           RowBox[{"ePart", "[", 
            RowBox[{"[", "p", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"sVec", "=", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "/", "8"}], ")"}], 
           RowBox[{"(", 
            RowBox[{"p", "-", "1"}], ")"}], 
           RowBox[{
            RowBox[{"RotationMatrix", "[", 
             RowBox[{
              RowBox[{"-", "\[Pi]"}], "/", "2"}], "]"}], ".", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"verticesList", "[", 
               RowBox[{"[", 
                RowBox[{"edgesG", "[", 
                 RowBox[{"[", 
                  RowBox[{"jn", ",", "2"}], "]"}], "]"}], "]"}], "]"}], "-", 
              RowBox[{"verticesList", "[", 
               RowBox[{"[", 
                RowBox[{"edgesG", "[", 
                 RowBox[{"[", 
                  RowBox[{"jn", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
             ")"}]}]}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"cpos", "=", 
          RowBox[{"Graphics", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"RGBColor", "[", 
              RowBox[{
               RowBox[{"1", "/", "255"}], ",", 
               RowBox[{"38", "/", "255"}], ",", 
               RowBox[{"230", "/", "255"}]}], "]"}], ",", 
             RowBox[{"Disk", "[", 
              RowBox[{
               RowBox[{"sVec", "+", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", "-", "t"}], ")"}], 
                 RowBox[{"(", 
                  RowBox[{"verticesList", "[", 
                   RowBox[{"[", 
                    RowBox[{"edgesG", "[", 
                    RowBox[{"[", 
                    RowBox[{"jn", ",", "1"}], "]"}], "]"}], "]"}], "]"}], 
                  ")"}]}], "+", 
                RowBox[{"t", 
                 RowBox[{"(", 
                  RowBox[{"verticesList", "[", 
                   RowBox[{"[", 
                    RowBox[{"edgesG", "[", 
                    RowBox[{"[", 
                    RowBox[{"jn", ",", "2"}], "]"}], "]"}], "]"}], "]"}], 
                  ")"}]}]}], ",", 
               RowBox[{"Scaled", "[", "0.02", "]"}]}], "]"}]}], "}"}], 
           "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"brcount", "=", 
          RowBox[{"Quiet", "[", 
           RowBox[{"fbbrpercent", "[", 
            RowBox[{"dset", ",", "\[Mu]\[Psi]data"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"br", "=", 
            RowBox[{
             RowBox[{"Position", "[", 
              RowBox[{
               RowBox[{"brcount", "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
               RowBox[{"Max", "[", 
                RowBox[{"brcount", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";"}], "*)"}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"Column", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Row", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Show", "[", 
                RowBox[{"edgeButton", ",", 
                 RowBox[{"Graphics", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    RowBox[{"255", "/", "255"}], ",", 
                    RowBox[{"42", "/", "255"}], ",", 
                    RowBox[{"0", "/", "255"}]}], "]"}], ",", 
                    RowBox[{"Disk", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1", "-", "t"}], ")"}], 
                    RowBox[{"verticesList", "[", 
                    RowBox[{"[", 
                    RowBox[{"edgesG", "[", 
                    RowBox[{"[", 
                    RowBox[{"jn", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                    "+", 
                    RowBox[{"t", 
                    RowBox[{"(", 
                    RowBox[{"verticesList", "[", 
                    RowBox[{"[", 
                    RowBox[{"edgesG", "[", 
                    RowBox[{"[", 
                    RowBox[{"jn", ",", "2"}], "]"}], "]"}], "]"}], "]"}], 
                    ")"}]}]}], ",", 
                    RowBox[{"Scaled", "[", "0.03", "]"}]}], "]"}]}], "}"}], 
                  "]"}], ",", "layoutOS", ",", 
                 RowBox[{"AspectRatio", "\[Rule]", " ", "1"}], ",", 
                 RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], ",", 
               RowBox[{"Show", "[", 
                RowBox[{"overlayObj", ",", "cpos", ",", 
                 RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
               RowBox[{"Show", "[", 
                RowBox[{"overlayBrPercent", ",", "cpos", ",", 
                 RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
               RowBox[{"Show", "[", 
                RowBox[{"overlayTrAngle", ",", "cpos", ",", 
                 RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
               RowBox[{"Show", "[", 
                RowBox[{"overlayPD", ",", "cpos", ",", 
                 RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
               RowBox[{"Show", "[", 
                RowBox[{"overlayMaxLen", ",", "cpos", ",", 
                 RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
               RowBox[{"Show", "[", 
                RowBox[{"overlaySensitivity", ",", "cpos", ",", 
                 RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}], "}"}], 
             "]"}], ",", 
            RowBox[{"Column", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Plotter", "[", 
                 RowBox[{
                 "dset", ",", "\[Theta]", ",", "br", ",", "\[Mu]\[Psi]data", 
                  ",", 
                  RowBox[{"{", 
                   RowBox[{"\[Gamma]", ",", "xc", ",", "yc"}], "}"}]}], "]"}],
                 ",", 
                RowBox[{"Button", "[", 
                 RowBox[{"\"\<Export\>\"", ",", 
                  RowBox[{
                   RowBox[{"exportDesign", "[", 
                    RowBox[{"dset", ",", "\[Theta]", ",", "br", ",", 
                    RowBox[{"{", 
                    RowBox[{"\[Gamma]", ",", "xc", ",", "yc"}], "}"}]}], 
                    "]"}], ";", " ", 
                   RowBox[{"Beep", "[", "]"}], ";"}], ",", 
                  RowBox[{"Appearance", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"\"\<DialogBox\>\"", ",", "\"\<Pressed\>\""}], 
                    "}"}]}]}], "]"}]}], "}"}], ",", 
              RowBox[{"Alignment", "\[Rule]", " ", "Center"}]}], "]"}]}], 
           "}"}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"p", ",", "1", ",", 
            RowBox[{"\"\<Paths \>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"edgesG", "[", 
               RowBox[{"[", 
                RowBox[{"jn", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
             "\"\<-\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"edgesG", "[", 
               RowBox[{"[", 
                RowBox[{"jn", ",", " ", "2"}], "]"}], "]"}], "]"}]}]}], "}"}],
           ",", "1", ",", 
          RowBox[{"Length", "[", "ePart", "]"}], ",", "1", ",", 
          RowBox[{"ControlType", "\[Rule]", " ", "Setter"}]}], "}"}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"t", ",", "0.5", ",", "\"\<Edge Tracker\>\""}], "}"}], ",",
           "0", ",", "1"}], "}"}], "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"br", ",", "1", ",", "\"\<Branch\>\""}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2"}], "}"}], ",", 
          RowBox[{"ControlType", "\[Rule]", " ", "RadioButton"}]}], "}"}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\[Theta]", ",", 
            RowBox[{"\[Mu]\[Psi]data", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
            "\"\<Input \[Mu]\>\""}], "}"}], ",", 
          RowBox[{"\[Mu]\[Psi]data", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"\[Mu]\[Psi]data", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\[Gamma]", ",", "1", ",", "\"\<Zoom\>\""}], "}"}], ",", 
          "5", ",", "0.5", ",", 
          RowBox[{"ControlPlacement", "\[Rule]", " ", "Bottom"}]}], "}"}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"xc", ",", "0.5", ",", "\"\<Swipe\>\""}], "}"}], ",", "1", 
          ",", "0", ",", 
          RowBox[{"ControlPlacement", "\[Rule]", " ", "Bottom"}]}], "}"}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"yc", ",", "0", ",", "\"\<Scroll\>\""}], "}"}], ",", "0.5",
           ",", 
          RowBox[{"-", "0.5"}], ",", 
          RowBox[{"ControlPlacement", "\[Rule]", " ", "Bottom"}]}], "}"}]}], 
       "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.828324039146139*^9, 3.828324046870373*^9}, {
   3.828324081445372*^9, 3.828324309627548*^9}, {3.82832437363472*^9, 
   3.8283244256322246`*^9}, 3.828325587599922*^9, {3.828325630621229*^9, 
   3.8283256540925198`*^9}, {3.8283269469736576`*^9, 
   3.8283269918670354`*^9}, {3.828327029208069*^9, 3.828327029767144*^9}, 
   3.8283270688768063`*^9, {3.8283272292287397`*^9, 3.828327231422945*^9}, {
   3.828328437056261*^9, 3.8283284413443813`*^9}, {3.828328987282029*^9, 
   3.828328999563992*^9}, {3.828374114646806*^9, 3.8283741274967823`*^9}, {
   3.828374935948279*^9, 3.828374944024403*^9}, {3.8283751440854335`*^9, 
   3.8283751444088507`*^9}, {3.8283754196981664`*^9, 3.828375478437155*^9}, {
   3.8283765288274975`*^9, 3.8283765323094997`*^9}, {3.828446045257841*^9, 
   3.8284460466999664`*^9}, {3.8284576262504425`*^9, 
   3.8284576804025593`*^9}, {3.8284629285661926`*^9, 3.82846297749448*^9}, {
   3.8284630364938045`*^9, 3.8284630783540783`*^9}, {3.8284632597345448`*^9, 
   3.828463356820567*^9}, {3.828463426442043*^9, 3.828463489813636*^9}, {
   3.828463560123925*^9, 3.8284636326494937`*^9}, {3.8284637600781937`*^9, 
   3.8284637988373137`*^9}, {3.828463832545677*^9, 3.8284638815978107`*^9}, {
   3.8284639204543943`*^9, 3.8284639478911037`*^9}, {3.8284777962486296`*^9, 
   3.828477802401099*^9}, {3.828477836851055*^9, 3.8284778370272813`*^9}, {
   3.8286247343250895`*^9, 3.8286247640451145`*^9}, {3.828625684099772*^9, 
   3.8286256843988557`*^9}, {3.8289684394234676`*^9, 
   3.8289684751042194`*^9}, {3.828968697536911*^9, 3.828968731535277*^9}, {
   3.828968783789719*^9, 3.8289688610663776`*^9}, {3.8289694968694253`*^9, 
   3.828969497011995*^9}, {3.8292247034157248`*^9, 3.8292247094606867`*^9}, {
   3.8292248271787972`*^9, 3.8292249103392305`*^9}, {3.829734788927707*^9, 
   3.8297348057188997`*^9}, 3.830647229754357*^9, {3.8306474963860517`*^9, 
   3.8306474975347586`*^9}, {3.830943447259306*^9, 3.8309434515069466`*^9}, {
   3.837699685309939*^9, 3.8376996861813784`*^9}, {3.8377002331782036`*^9, 
   3.8377002511510086`*^9}, {3.837700296401595*^9, 3.8377002970035*^9}, {
   3.8377003270396338`*^9, 3.837700331321003*^9}, {3.8377003619184036`*^9, 
   3.8377004116945844`*^9}, {3.837700441931765*^9, 3.837700455956287*^9}, {
   3.837700496906276*^9, 3.8377005891033072`*^9}, {3.837700627082054*^9, 
   3.837700628557511*^9}, {3.8377006698049545`*^9, 3.837700747698625*^9}, {
   3.8377009230896435`*^9, 3.8377009245623627`*^9}, {3.8377009778915887`*^9, 
   3.83770099504115*^9}, {3.837701057122859*^9, 3.837701057908929*^9}, {
   3.837774649170529*^9, 3.8377746506076365`*^9}, {3.837777528874876*^9, 
   3.8377775424298134`*^9}, {3.837779120661485*^9, 3.837779124534363*^9}, 
   3.837779283535931*^9, {3.8377862594417377`*^9, 3.8377863002036686`*^9}, {
   3.837786333437978*^9, 3.8377864369193583`*^9}, {3.8377865078149624`*^9, 
   3.8377865081476927`*^9}, {3.8377865588476925`*^9, 3.837786562160155*^9}, 
   3.8377870729731236`*^9, {3.8377904887421246`*^9, 3.837790497116646*^9}, {
   3.8377906162296925`*^9, 3.837790652553647*^9}, 3.837791473742942*^9, {
   3.837793235077775*^9, 3.8377935057569265`*^9}, 3.8377935468597035`*^9, {
   3.8377938108523917`*^9, 3.837793818342842*^9}, {3.8377939030997467`*^9, 
   3.83779393757197*^9}, {3.8377942457687836`*^9, 3.8377942657886534`*^9}, {
   3.8377946103268347`*^9, 3.8377946515850616`*^9}, {3.8377946855358286`*^9, 
   3.8377947173719873`*^9}, {3.837794751481064*^9, 3.83779478053586*^9}, 
   3.837794824235301*^9, {3.837794900545578*^9, 3.8377949025839615`*^9}, {
   3.837794938525957*^9, 3.837794963243684*^9}, {3.838908113038663*^9, 
   3.838908114019619*^9}, {3.838908302068643*^9, 3.838908368179907*^9}, 
   3.8389084175457554`*^9, {3.838911055204631*^9, 3.8389110897863398`*^9}, {
   3.838911137993453*^9, 3.838911140111231*^9}, {3.8389112039709325`*^9, 
   3.838911225081294*^9}, {3.8389842250661945`*^9, 3.8389842426451087`*^9}, {
   3.838984279122012*^9, 3.8389842991523333`*^9}, {3.838984338503516*^9, 
   3.8389843762234025`*^9}, 3.838984703027095*^9, {3.8389848463883843`*^9, 
   3.8389848899481564`*^9}, 3.8389849200382357`*^9, {3.838984966687019*^9, 
   3.838984967811139*^9}, {3.8390595085542116`*^9, 3.839059530071252*^9}, {
   3.839061856987808*^9, 3.839061861009533*^9}, {3.8390620290282745`*^9, 
   3.8390620303815165`*^9}, {3.839075253948413*^9, 3.8390752735098777`*^9}, {
   3.8390754367831273`*^9, 3.8390754388797045`*^9}, {3.839075532874263*^9, 
   3.8390755424408703`*^9}, {3.8390755912450285`*^9, 3.839075591657117*^9}, {
   3.839076736871021*^9, 3.8390767511235704`*^9}, {3.8390768198131723`*^9, 
   3.839076822348735*^9}, {3.8390768784510317`*^9, 3.8390769243226852`*^9}, {
   3.8390769796205006`*^9, 3.839077034269272*^9}, {3.839077079953321*^9, 
   3.839077082856245*^9}, {3.839077163182266*^9, 3.8390771642027836`*^9}, {
   3.839224296284999*^9, 3.8392243202602696`*^9}, {3.839224383387819*^9, 
   3.8392243996719837`*^9}, {3.839231060382986*^9, 3.8392310849189773`*^9}, {
   3.839231128245371*^9, 3.839231134588848*^9}, {3.839231282673319*^9, 
   3.839231330696454*^9}, {3.8392314150128365`*^9, 3.839231442074726*^9}, {
   3.8392314787033415`*^9, 3.8392314868289275`*^9}, {3.839231590087455*^9, 
   3.839231591630559*^9}, {3.8392324292850485`*^9, 3.8392324813913264`*^9}, {
   3.839232566419506*^9, 3.8392325705440817`*^9}, {3.8392329523300915`*^9, 
   3.8392329912924376`*^9}, {3.839233038476335*^9, 3.839233066588817*^9}, {
   3.8392339530488005`*^9, 3.83923397629366*^9}, {3.839234013370981*^9, 
   3.8392340181605263`*^9}, {3.83923405146494*^9, 3.8392340603337483`*^9}, {
   3.8392675623317213`*^9, 3.839267605470291*^9}, {3.839317165070187*^9, 
   3.839317170240878*^9}, {3.839317350959031*^9, 3.839317351442174*^9}, {
   3.839318770588874*^9, 3.8393187753763266`*^9}, {3.8407022428227634`*^9, 
   3.8407022892098184`*^9}, {3.840704670756003*^9, 3.8407047195959435`*^9}, 
   3.8407058145504208`*^9, {3.8410898036544666`*^9, 3.8410898545012813`*^9}, 
   3.8411254899728394`*^9, 3.8411273354278083`*^9, 3.8411275198684206`*^9, {
   3.841127899477844*^9, 3.8411279030835257`*^9}, {3.8411279614898195`*^9, 
   3.8411279747702503`*^9}, {3.841128148225458*^9, 3.8411281673562374`*^9}, {
   3.8411282111245565`*^9, 3.8411282119868617`*^9}, {3.841128254332055*^9, 
   3.8411282551575*^9}, {3.841128295356705*^9, 3.8411282964181848`*^9}, {
   3.8411283403132973`*^9, 3.841128347998727*^9}, {3.841128395281932*^9, 
   3.841128410694315*^9}, {3.8411378637519693`*^9, 3.8411378663891106`*^9}, 
   3.8411379316832743`*^9, 3.8411379812528057`*^9, {3.841307869710801*^9, 
   3.8413078769692183`*^9}, {3.8413080049017305`*^9, 
   3.8413080094063377`*^9}, {3.8442834486914062`*^9, 3.844283451916499*^9}, 
   3.8442836113986807`*^9, {3.8442837686644526`*^9, 3.844283769123745*^9}, {
   3.844283805419618*^9, 3.8442838076925144`*^9}, 3.8442838674092207`*^9, {
   3.8442839100674114`*^9, 3.8442839132713647`*^9}, {3.8442839542686424`*^9, 
   3.8442839569147696`*^9}, {3.8442843085140653`*^9, 3.8442843086364965`*^9}, 
   3.844284348066942*^9, {3.8442950716025224`*^9, 3.8442950736699905`*^9}, {
   3.844302879858878*^9, 3.8443028806105256`*^9}, {3.844497339521777*^9, 
   3.844497341446305*^9}, {3.8447652038928814`*^9, 3.8447652195051284`*^9}, {
   3.8447679498358974`*^9, 3.844767950160031*^9}, {3.845048688685812*^9, 
   3.845048757759906*^9}, {3.8456772781160107`*^9, 3.8456772909040065`*^9}, {
   3.845677742877453*^9, 3.8456777571591797`*^9}, {3.855333682960165*^9, 
   3.8553336980147142`*^9}, {3.855334124037632*^9, 3.8553341249728394`*^9}, {
   3.855334734176389*^9, 3.855334739725788*^9}, {3.8553347725073767`*^9, 
   3.8553347833218327`*^9}, {3.85533558887044*^9, 3.8553356877032084`*^9}, {
   3.855336027180785*^9, 3.8553360682502236`*^9}, {3.8557569975264916`*^9, 
   3.8557570036216106`*^9}, {3.855757198280225*^9, 3.8557572242054143`*^9}, {
   3.855769493931999*^9, 3.85576949708955*^9}, {3.8557696421815486`*^9, 
   3.85576964662018*^9}, {3.8557716144482713`*^9, 3.8557716274291105`*^9}, {
   3.8557717193463964`*^9, 3.855771732791486*^9}, {3.8557750225626783`*^9, 
   3.855775049407983*^9}, {3.855775090929902*^9, 3.8557750927673836`*^9}, {
   3.855775306625285*^9, 3.8557753078936405`*^9}, {3.85577534875047*^9, 
   3.8557754041952333`*^9}, {3.8557755699426785`*^9, 3.855775612931177*^9}, {
   3.855775851059823*^9, 3.8557758690957036`*^9}, 3.8557760199415855`*^9, {
   3.855776085440974*^9, 3.8557760863033233`*^9}, {3.85577870050056*^9, 
   3.855778714703624*^9}, {3.8557787554314594`*^9, 3.8557787561625414`*^9}, {
   3.855778859643628*^9, 3.8557788850625935`*^9}, {3.855779295780745*^9, 
   3.8557793128548126`*^9}, {3.855789174391142*^9, 3.8557891948461356`*^9}, {
   3.8557892478863745`*^9, 3.8557892682231107`*^9}, {3.8558240150474463`*^9, 
   3.8558240358390174`*^9}, 3.8558241019645805`*^9, {3.8558242752222395`*^9, 
   3.8558242885198107`*^9}, {3.8558243559408116`*^9, 3.855824361353277*^9}, 
   3.8558247761572485`*^9, 3.8558255871726403`*^9, 3.855836375855521*^9, {
   3.855837485661262*^9, 3.8558375483904524`*^9}, {3.8558377098968935`*^9, 
   3.855837717134967*^9}, {3.855838617979749*^9, 3.855838623493844*^9}, {
   3.8558392559888706`*^9, 3.8558392619896526`*^9}, {3.8558400633652983`*^9, 
   3.8558400641708794`*^9}, {3.855840168436639*^9, 3.855840186686441*^9}, {
   3.8558402307199125`*^9, 3.8558402356055202`*^9}, {3.8558403795548763`*^9, 
   3.8558404045944653`*^9}, {3.855840634195908*^9, 3.8558406768266172`*^9}, 
   3.855840710888511*^9, {3.8558443739506807`*^9, 3.855844434290161*^9}, {
   3.855844559229332*^9, 3.855844566135372*^9}, {3.8558446341036243`*^9, 
   3.855844640132945*^9}, {3.8558446849990997`*^9, 3.855844687865267*^9}, 
   3.8558447312711787`*^9},
 CellLabel->"In[38]:=",ExpressionUUID->"cb769fdd-3c05-43a3-858a-87419db0bf7b"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Design specification and other settings,", "Chapter",
 CellChangeTimes->{{3.826989173048962*^9, 3.826989187759984*^9}, {
  3.827199860537114*^9, 
  3.8271998697678027`*^9}},ExpressionUUID->"5322ff04-2a43-480b-9e85-\
51aa733462bc"],

Cell["\<\
Define the function task specification as \
\[OpenCurlyDoubleQuote]\[Mu]\[Psi]data\[CloseCurlyDoubleQuote], a set of \
ordered pairs that take values in the range (-\[Pi], \[Pi] ].\
\>", "Text",
 CellChangeTimes->{{3.8283767246804934`*^9, 
  3.8283768202865868`*^9}},ExpressionUUID->"2c1045da-8aa6-4b9b-b2bd-\
bf7f12ad22e6"],

Cell[CellGroupData[{

Cell["Humanoid finger data,", "Subsubsection",
 CellChangeTimes->{{3.85584498732862*^9, 
  3.8558449931257772`*^9}},ExpressionUUID->"07e45f19-a193-4244-8acc-\
28f668a710c7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Mu]\[Psi]data", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.060"}], ",", "0.0245"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.120"}], ",", "0.0532"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.180"}], ",", "0.0860"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.240"}], ",", "0.123"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.300"}], ",", "0.164"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.360"}], ",", "0.210"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.420"}], ",", "0.259"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.480"}], ",", "0.313"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.540"}], ",", "0.371"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.600"}], ",", "0.433"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.660"}], ",", "0.499"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.720"}], ",", "0.569"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.780"}], ",", "0.644"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.840"}], ",", "0.723"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.900"}], ",", "0.806"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.960"}], ",", "0.893"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1.020"}], ",", "0.984"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1.080"}], ",", "1.080"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1.140"}], ",", "1.179"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1.200"}], ",", "1.283"}], "}"}]}], "}"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"Humanoid", " ", "finger", " ", "data"}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.826989234674838*^9, 3.826989235032087*^9}, {
   3.8269988621894627`*^9, 3.826998876402376*^9}, {3.827002149308692*^9, 
   3.827002151335883*^9}, {3.8270022360975995`*^9, 3.827002236505743*^9}, 
   3.82700233726645*^9, {3.827002383199896*^9, 3.827002387900708*^9}, {
   3.827002589068245*^9, 3.8270025927252727`*^9}, {3.8270049935777683`*^9, 
   3.827004995137553*^9}, {3.827005258933591*^9, 3.827005261039792*^9}, {
   3.8270071217719173`*^9, 3.8270071250953746`*^9}, {3.827007185479782*^9, 
   3.8270071880967493`*^9}, 3.827009012474237*^9, {3.827009049848709*^9, 
   3.827009101397586*^9}, {3.827009245780301*^9, 3.8270092495657454`*^9}, {
   3.8270093590400968`*^9, 3.8270093828439407`*^9}, {3.8270100008554487`*^9, 
   3.827010003061554*^9}, {3.8270101183740683`*^9, 3.8270101208900557`*^9}, {
   3.8270114940892925`*^9, 3.8270114973558016`*^9}, {3.8270179628460155`*^9, 
   3.8270179652342176`*^9}, 3.827151629898443*^9, 3.827151663859152*^9, {
   3.827154347808229*^9, 3.8271543725851474`*^9}, {3.8271544555894794`*^9, 
   3.8271544723501067`*^9}, {3.8271549145098596`*^9, 
   3.8271549179029913`*^9}, {3.8271549511966915`*^9, 3.827155007019635*^9}, {
   3.827199841544186*^9, 3.827199886298647*^9}, {3.8273260485875373`*^9, 
   3.827326048949023*^9}, {3.827335232116922*^9, 3.8273352324621444`*^9}, {
   3.8274028182620726`*^9, 3.827402888537284*^9}, {3.827402944179594*^9, 
   3.827402948509753*^9}, {3.827404643889189*^9, 3.8274046501600447`*^9}, {
   3.827405159604886*^9, 3.8274052348237705`*^9}, {3.827407334161087*^9, 
   3.8274073763943434`*^9}, {3.827411498473765*^9, 3.827411502964302*^9}, {
   3.827593359883607*^9, 3.827593360248237*^9}, {3.8280656056552644`*^9, 
   3.828065637627833*^9}, {3.8280660734434643`*^9, 3.828066094756415*^9}, 
   3.8280669009000826`*^9, {3.828067008975272*^9, 3.828067016127124*^9}, {
   3.828067399275346*^9, 3.828067405174281*^9}, {3.8280674730693913`*^9, 
   3.828067481095809*^9}, {3.828098707438613*^9, 3.82809870893277*^9}, {
   3.8281006161151657`*^9, 3.8281006198151937`*^9}, {3.8281065971895037`*^9, 
   3.8281066003676233`*^9}, {3.8281070787941074`*^9, 
   3.8281070823545694`*^9}, {3.828199150931627*^9, 3.8281991543004723`*^9}, {
   3.8281994673530307`*^9, 3.8281994720281324`*^9}, {3.8282009443600063`*^9, 
   3.8282009612102103`*^9}, {3.8282013677047997`*^9, 3.828201371442216*^9}, {
   3.82820479038287*^9, 3.8282048050163393`*^9}, {3.8282050106999865`*^9, 
   3.8282050119265423`*^9}, {3.8282159929305134`*^9, 3.828215997601283*^9}, {
   3.828216067605596*^9, 3.828216073487549*^9}, {3.8282163152628746`*^9, 
   3.8282163186218786`*^9}, {3.8282164383640475`*^9, 
   3.8282164460761876`*^9}, {3.8282740370104976`*^9, 
   3.8282740466160817`*^9}, {3.8282743233102083`*^9, 3.828274392710521*^9}, {
   3.828274427278859*^9, 3.8282744299235907`*^9}, {3.828282916670545*^9, 
   3.8282829245240145`*^9}, {3.8282832204007187`*^9, 3.8282832206945224`*^9}, 
   3.8282843507140193`*^9, {3.8283249454174175`*^9, 3.828324949256797*^9}, {
   3.828330005637559*^9, 3.8283300137959557`*^9}, 3.8283304645810766`*^9, 
   3.8283768471891546`*^9, {3.828376899034289*^9, 3.8283769026985474`*^9}, {
   3.828377118727371*^9, 3.8283771549355354`*^9}, {3.8283776030941343`*^9, 
   3.8283776184501534`*^9}, {3.8283777681688166`*^9, 3.828377774004774*^9}, {
   3.8283778242542334`*^9, 3.828377853324461*^9}, 3.828386819141035*^9, 
   3.82838687948843*^9, {3.828387170358309*^9, 3.828387170565317*^9}, {
   3.828387329340314*^9, 3.828387331229257*^9}, {3.8283873621496954`*^9, 
   3.828387377015732*^9}, {3.8283876209978724`*^9, 3.828387623895811*^9}, 
   3.8283886760300875`*^9, 3.828388857609503*^9, {3.8283888889219365`*^9, 
   3.8283888902009363`*^9}, {3.828389156548741*^9, 3.828389168304514*^9}, {
   3.8283893453282523`*^9, 3.828389345751954*^9}, {3.828390520019497*^9, 
   3.828390525977004*^9}, 3.8283907038516955`*^9, {3.828396883964332*^9, 
   3.828396904158188*^9}, {3.828396949968935*^9, 3.828396958386833*^9}, {
   3.8283970448089523`*^9, 3.8283970456207657`*^9}, {3.828397098396098*^9, 
   3.8283971028462524`*^9}, {3.8283971521013565`*^9, 
   3.8283971527193265`*^9}, {3.8283973322033644`*^9, 3.828397337557719*^9}, {
   3.8283974672356963`*^9, 3.828397468639214*^9}, {3.8283977819394717`*^9, 
   3.8283977892043257`*^9}, {3.82839783987716*^9, 3.8283978560442405`*^9}, 
   3.8283983129044294`*^9, {3.8283992238756237`*^9, 3.828399253895105*^9}, 
   3.8283992996231103`*^9, {3.828399423210593*^9, 3.8283994729141216`*^9}, {
   3.8283995739508743`*^9, 3.8283996002209997`*^9}, {3.8284380732970676`*^9, 
   3.8284380961602917`*^9}, 3.828439037682032*^9, {3.8284453544936147`*^9, 
   3.8284453600236497`*^9}, {3.828460504404299*^9, 3.828460507640763*^9}, {
   3.8284615074080997`*^9, 3.8284615107730956`*^9}, {3.828463655100318*^9, 
   3.82846365735468*^9}, {3.8284639923358307`*^9, 3.828463995720687*^9}, {
   3.8286230988005295`*^9, 3.828623145797901*^9}, {3.8286238344305964`*^9, 
   3.828623838038114*^9}, {3.82862396051178*^9, 3.828623985345693*^9}, {
   3.8286263924725866`*^9, 3.8286264438417006`*^9}, {3.8286265196649837`*^9, 
   3.8286265225913734`*^9}, {3.829154242868457*^9, 3.82915424592303*^9}, {
   3.829734837965578*^9, 3.8297348415812902`*^9}, {3.830639359410962*^9, 
   3.830639364489813*^9}, {3.8306399917010837`*^9, 3.830639997745216*^9}, {
   3.8390794594378967`*^9, 3.8390795114096994`*^9}, {3.839186651832406*^9, 
   3.8391866554251943`*^9}, {3.839225724240344*^9, 3.839225727932264*^9}, {
   3.8392315049561844`*^9, 3.839231508525777*^9}, {3.8392346488010583`*^9, 
   3.8392346726034994`*^9}, {3.839236482483988*^9, 3.839236486869052*^9}, {
   3.8392393516936245`*^9, 3.839239361512879*^9}, 3.839239476864896*^9, {
   3.8392395839905043`*^9, 3.839239588854848*^9}, 3.83923963522758*^9, {
   3.839239921720686*^9, 3.8392399320642204`*^9}, {3.8392400547867765`*^9, 
   3.8392400551407022`*^9}, {3.8392401145381365`*^9, 
   3.8392401229425097`*^9}, {3.839240359225588*^9, 3.839240368783227*^9}, {
   3.839280450646587*^9, 3.8392804591141696`*^9}, {3.839281212948944*^9, 
   3.839281218953305*^9}, {3.8393168930255795`*^9, 3.839316902053999*^9}, {
   3.839318306326703*^9, 3.8393183121227627`*^9}, {3.8393237707731147`*^9, 
   3.839323773190322*^9}, {3.839329592793321*^9, 3.839329596837677*^9}, {
   3.8395008327725677`*^9, 3.8395008412629538`*^9}, {3.83950210487402*^9, 
   3.8395021094587355`*^9}, 3.839502144729737*^9, {3.839587382075179*^9, 
   3.8395873878201237`*^9}, {3.841126896359406*^9, 3.841126903307434*^9}, {
   3.8413079544288516`*^9, 3.8413079590657153`*^9}, {3.843144531773528*^9, 
   3.8431445438203545`*^9}, 3.843145925570929*^9, 3.8431463598505096`*^9, 
   3.8431464094092064`*^9, 3.8431464664486713`*^9, {3.8431465069649887`*^9, 
   3.843146535280278*^9}, {3.8433152048120136`*^9, 3.843315210904323*^9}, {
   3.8433158990721617`*^9, 3.8433160086335936`*^9}, {3.843316102807655*^9, 
   3.843316115933858*^9}, {3.8433161869618187`*^9, 3.8433161881545086`*^9}, {
   3.84331629947219*^9, 3.84331630532543*^9}, {3.843316501047657*^9, 
   3.843316509820298*^9}, {3.8433166111920357`*^9, 3.8433166118532257`*^9}, {
   3.843665498241103*^9, 3.8436656214945955`*^9}, {3.8436656529088016`*^9, 
   3.8436656854614067`*^9}, {3.843665743222307*^9, 3.8436657433978386`*^9}, {
   3.8436657782064767`*^9, 3.843665846149815*^9}, {3.843665909503118*^9, 
   3.8436659141744637`*^9}, {3.8436659505643373`*^9, 
   3.8436659563500834`*^9}, {3.8436660516199837`*^9, 3.84366606509408*^9}, {
   3.8436661638640623`*^9, 3.8436661741277676`*^9}, {3.8436663416497316`*^9, 
   3.8436663813467817`*^9}, {3.843666548608329*^9, 3.8436617368105354`*^9}, {
   3.843663394157858*^9, 3.843663424045222*^9}, {3.84366349683654*^9, 
   3.84366351363239*^9}, {3.843737226679967*^9, 3.843737262780219*^9}, {
   3.843830657987932*^9, 3.8438306618609166`*^9}, {3.844282971954852*^9, 
   3.8442829878610888`*^9}, {3.844294998827124*^9, 3.844295005819766*^9}, {
   3.8443024625604944`*^9, 3.844302467761215*^9}, {3.855334244010555*^9, 
   3.8553342587644916`*^9}, {3.855334324475567*^9, 3.8553343706916943`*^9}, {
   3.855334411308567*^9, 3.855334586124685*^9}, {3.855335510020336*^9, 
   3.8553355391274395`*^9}, 3.8557568130829487`*^9, 3.8557584525569067`*^9, 
   3.8557587120749483`*^9, 3.8557691418236322`*^9, 3.8557749931152277`*^9, 
   3.8557787235254335`*^9, 3.8557793186473308`*^9, 3.8557892154026346`*^9, 
   3.8558240433643584`*^9, 3.8558450262610493`*^9, 3.8558471104964905`*^9, 
   3.855847476038829*^9, 3.8558476023799105`*^9, 3.855855566384902*^9, 
   3.8558612108951025`*^9, 3.855866963387231*^9, 3.8559354604262295`*^9, {
   3.8559455853695173`*^9, 3.85594559407241*^9}},
 CellLabel->"In[39]:=",ExpressionUUID->"f992536d-b3c2-4b7e-9d1e-d0e6590f206e"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hummingbird flapping motion data,", "Subsubsection",
 CellChangeTimes->{{3.85584498732862*^9, 
  3.855845006558343*^9}},ExpressionUUID->"edf9d325-ea91-4a9e-a7e6-\
5e77302fd468"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"\[Mu]\[Psi]data", "=", 
     RowBox[{"N", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "0.613"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox["\[Pi]", "10"], ",", 
           RowBox[{"-", "0.999"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox["\[Pi]", "5"], ",", 
           RowBox[{"-", "1.212"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"3", " ", "\[Pi]"}], "10"], ",", 
           RowBox[{"-", "1.241"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"2", " ", "\[Pi]"}], "5"], ",", 
           RowBox[{"-", "1.100"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox["\[Pi]", "2"], ",", 
           RowBox[{"-", "0.800"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"3", " ", "\[Pi]"}], "5"], ",", 
           RowBox[{"-", "0.400"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"7", " ", "\[Pi]"}], "10"], ",", "0.003"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"4", " ", "\[Pi]"}], "5"], ",", "0.356"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"9", " ", "\[Pi]"}], "10"], ",", "0.644"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Pi]", ",", "0.866"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"11", " ", "\[Pi]"}], "10"], ",", "1.019"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"6", " ", "\[Pi]"}], "5"], ",", "1.102"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"13", " ", "\[Pi]"}], "10"], ",", "1.114"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"7", " ", "\[Pi]"}], "5"], ",", "1.061"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"3", " ", "\[Pi]"}], "2"], ",", "0.947"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"8", " ", "\[Pi]"}], "5"], ",", "0.774"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"17", " ", "\[Pi]"}], "10"], ",", "0.536"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"9", " ", "\[Pi]"}], "5"], ",", "0.225"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"19", " ", "\[Pi]"}], "10"], ",", 
           RowBox[{"-", "0.167"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"2", " ", "\[Pi]"}], ",", 
           RowBox[{"-", "0.613"}]}], "}"}]}], "}"}], ",", "10"}], "]"}]}], 
    ";"}], "*)"}], 
  RowBox[{"(*", 
   RowBox[{"Hummingbird", " ", "flapping", " ", "motion"}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.826989234674838*^9, 3.826989235032087*^9}, {
   3.8269988621894627`*^9, 3.826998876402376*^9}, {3.827002149308692*^9, 
   3.827002151335883*^9}, {3.8270022360975995`*^9, 3.827002236505743*^9}, 
   3.82700233726645*^9, {3.827002383199896*^9, 3.827002387900708*^9}, {
   3.827002589068245*^9, 3.8270025927252727`*^9}, {3.8270049935777683`*^9, 
   3.827004995137553*^9}, {3.827005258933591*^9, 3.827005261039792*^9}, {
   3.8270071217719173`*^9, 3.8270071250953746`*^9}, {3.827007185479782*^9, 
   3.8270071880967493`*^9}, 3.827009012474237*^9, {3.827009049848709*^9, 
   3.827009101397586*^9}, {3.827009245780301*^9, 3.8270092495657454`*^9}, {
   3.8270093590400968`*^9, 3.8270093828439407`*^9}, {3.8270100008554487`*^9, 
   3.827010003061554*^9}, {3.8270101183740683`*^9, 3.8270101208900557`*^9}, {
   3.8270114940892925`*^9, 3.8270114973558016`*^9}, {3.8270179628460155`*^9, 
   3.8270179652342176`*^9}, 3.827151629898443*^9, 3.827151663859152*^9, {
   3.827154347808229*^9, 3.8271543725851474`*^9}, {3.8271544555894794`*^9, 
   3.8271544723501067`*^9}, {3.8271549145098596`*^9, 
   3.8271549179029913`*^9}, {3.8271549511966915`*^9, 3.827155007019635*^9}, {
   3.827199841544186*^9, 3.827199886298647*^9}, {3.8273260485875373`*^9, 
   3.827326048949023*^9}, {3.827335232116922*^9, 3.8273352324621444`*^9}, {
   3.8274028182620726`*^9, 3.827402888537284*^9}, {3.827402944179594*^9, 
   3.827402948509753*^9}, {3.827404643889189*^9, 3.8274046501600447`*^9}, {
   3.827405159604886*^9, 3.8274052348237705`*^9}, {3.827407334161087*^9, 
   3.8274073763943434`*^9}, {3.827411498473765*^9, 3.827411502964302*^9}, {
   3.827593359883607*^9, 3.827593360248237*^9}, {3.8280656056552644`*^9, 
   3.828065637627833*^9}, {3.8280660734434643`*^9, 3.828066094756415*^9}, 
   3.8280669009000826`*^9, {3.828067008975272*^9, 3.828067016127124*^9}, {
   3.828067399275346*^9, 3.828067405174281*^9}, {3.8280674730693913`*^9, 
   3.828067481095809*^9}, {3.828098707438613*^9, 3.82809870893277*^9}, {
   3.8281006161151657`*^9, 3.8281006198151937`*^9}, {3.8281065971895037`*^9, 
   3.8281066003676233`*^9}, {3.8281070787941074`*^9, 
   3.8281070823545694`*^9}, {3.828199150931627*^9, 3.8281991543004723`*^9}, {
   3.8281994673530307`*^9, 3.8281994720281324`*^9}, {3.8282009443600063`*^9, 
   3.8282009612102103`*^9}, {3.8282013677047997`*^9, 3.828201371442216*^9}, {
   3.82820479038287*^9, 3.8282048050163393`*^9}, {3.8282050106999865`*^9, 
   3.8282050119265423`*^9}, {3.8282159929305134`*^9, 3.828215997601283*^9}, {
   3.828216067605596*^9, 3.828216073487549*^9}, {3.8282163152628746`*^9, 
   3.8282163186218786`*^9}, {3.8282164383640475`*^9, 
   3.8282164460761876`*^9}, {3.8282740370104976`*^9, 
   3.8282740466160817`*^9}, {3.8282743233102083`*^9, 3.828274392710521*^9}, {
   3.828274427278859*^9, 3.8282744299235907`*^9}, {3.828282916670545*^9, 
   3.8282829245240145`*^9}, {3.8282832204007187`*^9, 3.8282832206945224`*^9}, 
   3.8282843507140193`*^9, {3.8283249454174175`*^9, 3.828324949256797*^9}, {
   3.828330005637559*^9, 3.8283300137959557`*^9}, 3.8283304645810766`*^9, 
   3.8283768471891546`*^9, {3.828376899034289*^9, 3.8283769026985474`*^9}, {
   3.828377118727371*^9, 3.8283771549355354`*^9}, {3.8283776030941343`*^9, 
   3.8283776184501534`*^9}, {3.8283777681688166`*^9, 3.828377774004774*^9}, {
   3.8283778242542334`*^9, 3.828377853324461*^9}, 3.828386819141035*^9, 
   3.82838687948843*^9, {3.828387170358309*^9, 3.828387170565317*^9}, {
   3.828387329340314*^9, 3.828387331229257*^9}, {3.8283873621496954`*^9, 
   3.828387377015732*^9}, {3.8283876209978724`*^9, 3.828387623895811*^9}, 
   3.8283886760300875`*^9, 3.828388857609503*^9, {3.8283888889219365`*^9, 
   3.8283888902009363`*^9}, {3.828389156548741*^9, 3.828389168304514*^9}, {
   3.8283893453282523`*^9, 3.828389345751954*^9}, {3.828390520019497*^9, 
   3.828390525977004*^9}, 3.8283907038516955`*^9, {3.828396883964332*^9, 
   3.828396904158188*^9}, {3.828396949968935*^9, 3.828396958386833*^9}, {
   3.8283970448089523`*^9, 3.8283970456207657`*^9}, {3.828397098396098*^9, 
   3.8283971028462524`*^9}, {3.8283971521013565`*^9, 
   3.8283971527193265`*^9}, {3.8283973322033644`*^9, 3.828397337557719*^9}, {
   3.8283974672356963`*^9, 3.828397468639214*^9}, {3.8283977819394717`*^9, 
   3.8283977892043257`*^9}, {3.82839783987716*^9, 3.8283978560442405`*^9}, 
   3.8283983129044294`*^9, {3.8283992238756237`*^9, 3.828399253895105*^9}, 
   3.8283992996231103`*^9, {3.828399423210593*^9, 3.8283994729141216`*^9}, {
   3.8283995739508743`*^9, 3.8283996002209997`*^9}, {3.8284380732970676`*^9, 
   3.8284380961602917`*^9}, 3.828439037682032*^9, {3.8284453544936147`*^9, 
   3.8284453600236497`*^9}, {3.828460504404299*^9, 3.828460507640763*^9}, {
   3.8284615074080997`*^9, 3.8284615107730956`*^9}, {3.828463655100318*^9, 
   3.82846365735468*^9}, {3.8284639923358307`*^9, 3.828463995720687*^9}, {
   3.8286230988005295`*^9, 3.828623145797901*^9}, {3.8286238344305964`*^9, 
   3.828623838038114*^9}, {3.82862396051178*^9, 3.828623985345693*^9}, {
   3.8286263924725866`*^9, 3.8286264438417006`*^9}, {3.8286265196649837`*^9, 
   3.8286265225913734`*^9}, {3.829154242868457*^9, 3.82915424592303*^9}, {
   3.829734837965578*^9, 3.8297348415812902`*^9}, {3.830639359410962*^9, 
   3.830639364489813*^9}, {3.8306399917010837`*^9, 3.830639997745216*^9}, {
   3.8390794594378967`*^9, 3.8390795114096994`*^9}, {3.839186651832406*^9, 
   3.8391866554251943`*^9}, {3.839225724240344*^9, 3.839225727932264*^9}, {
   3.8392315049561844`*^9, 3.839231508525777*^9}, {3.8392346488010583`*^9, 
   3.8392346726034994`*^9}, {3.839236482483988*^9, 3.839236486869052*^9}, {
   3.8392393516936245`*^9, 3.839239361512879*^9}, 3.839239476864896*^9, {
   3.8392395839905043`*^9, 3.839239588854848*^9}, 3.83923963522758*^9, {
   3.839239921720686*^9, 3.8392399320642204`*^9}, {3.8392400547867765`*^9, 
   3.8392400551407022`*^9}, {3.8392401145381365`*^9, 
   3.8392401229425097`*^9}, {3.839240359225588*^9, 3.839240368783227*^9}, {
   3.839280450646587*^9, 3.8392804591141696`*^9}, {3.839281212948944*^9, 
   3.839281218953305*^9}, {3.8393168930255795`*^9, 3.839316902053999*^9}, {
   3.839318306326703*^9, 3.8393183121227627`*^9}, {3.8393237707731147`*^9, 
   3.839323773190322*^9}, {3.839329592793321*^9, 3.839329596837677*^9}, {
   3.8395008327725677`*^9, 3.8395008412629538`*^9}, {3.83950210487402*^9, 
   3.8395021094587355`*^9}, 3.839502144729737*^9, {3.839587382075179*^9, 
   3.8395873878201237`*^9}, {3.841126896359406*^9, 3.841126903307434*^9}, {
   3.8413079544288516`*^9, 3.8413079590657153`*^9}, {3.843144531773528*^9, 
   3.8431445438203545`*^9}, 3.843145925570929*^9, 3.8431463598505096`*^9, 
   3.8431464094092064`*^9, 3.8431464664486713`*^9, {3.8431465069649887`*^9, 
   3.843146535280278*^9}, {3.8433152048120136`*^9, 3.843315210904323*^9}, {
   3.8433158990721617`*^9, 3.8433160086335936`*^9}, {3.843316102807655*^9, 
   3.843316115933858*^9}, {3.8433161869618187`*^9, 3.8433161881545086`*^9}, {
   3.84331629947219*^9, 3.84331630532543*^9}, {3.843316501047657*^9, 
   3.843316509820298*^9}, {3.8433166111920357`*^9, 3.8433166118532257`*^9}, {
   3.843665498241103*^9, 3.8436656214945955`*^9}, {3.8436656529088016`*^9, 
   3.8436656854614067`*^9}, {3.843665743222307*^9, 3.8436657433978386`*^9}, {
   3.8436657782064767`*^9, 3.843665846149815*^9}, {3.843665909503118*^9, 
   3.8436659141744637`*^9}, {3.8436659505643373`*^9, 
   3.8436659563500834`*^9}, {3.8436660516199837`*^9, 3.84366606509408*^9}, {
   3.8436661638640623`*^9, 3.8436661741277676`*^9}, {3.8436663416497316`*^9, 
   3.8436663813467817`*^9}, {3.843666548608329*^9, 3.8436617368105354`*^9}, {
   3.843663394157858*^9, 3.843663424045222*^9}, {3.84366349683654*^9, 
   3.84366351363239*^9}, {3.843737226679967*^9, 3.843737262780219*^9}, {
   3.843830657987932*^9, 3.8438306618609166`*^9}, {3.844282971954852*^9, 
   3.8442829878610888`*^9}, {3.844294998827124*^9, 3.844295005819766*^9}, {
   3.8443024625604944`*^9, 3.844302467761215*^9}, {3.855334244010555*^9, 
   3.8553342587644916`*^9}, 3.855335534759914*^9, {3.855756724319111*^9, 
   3.855756816451604*^9}, 3.8557584491567025`*^9, 3.855758708741971*^9, 
   3.855769138717256*^9, 3.855774996134097*^9, 3.855778720568678*^9, 
   3.85577932148128*^9, 3.8557892181810737`*^9, 3.855824049896284*^9, 
   3.855845023626303*^9, 3.8558471135583363`*^9, 3.8558474729249773`*^9, 
   3.8558476047992706`*^9, 3.8558556138675337`*^9, 3.85586121808924*^9, 
   3.8558669601902704`*^9, 3.855935463259555*^9, 
   3.8559455826797113`*^9},ExpressionUUID->"1747bc26-4bf6-48d3-9125-\
fd0e7e21882a"],

Cell["\<\
Set the tolerance value for discerning the real solutions from the solution \
set.\
\>", "Text",
 CellChangeTimes->{{3.828376851970847*^9, 3.8283768835518303`*^9}, {
  3.8309377814657855`*^9, 
  3.8309377832011433`*^9}},ExpressionUUID->"f0c9dbb6-973e-4f09-9fb2-\
fc16456ef7cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"realTol", "=", 
   SuperscriptBox["10", 
    RowBox[{"-", "6"}]]}], ";"}]], "Input",
 CellChangeTimes->{{3.826989234674838*^9, 3.826989235032087*^9}, {
   3.8269988621894627`*^9, 3.826998876402376*^9}, {3.827002149308692*^9, 
   3.827002151335883*^9}, {3.8270022360975995`*^9, 3.827002236505743*^9}, 
   3.82700233726645*^9, {3.827002383199896*^9, 3.827002387900708*^9}, {
   3.827002589068245*^9, 3.8270025927252727`*^9}, {3.8270049935777683`*^9, 
   3.827004995137553*^9}, {3.827005258933591*^9, 3.827005261039792*^9}, {
   3.8270071217719173`*^9, 3.8270071250953746`*^9}, {3.827007185479782*^9, 
   3.8270071880967493`*^9}, 3.827009012474237*^9, {3.827009049848709*^9, 
   3.827009101397586*^9}, {3.827009245780301*^9, 3.8270092495657454`*^9}, {
   3.8270093590400968`*^9, 3.8270093828439407`*^9}, {3.8270100008554487`*^9, 
   3.827010003061554*^9}, {3.8270101183740683`*^9, 3.8270101208900557`*^9}, {
   3.8270114940892925`*^9, 3.8270114973558016`*^9}, {3.8270179628460155`*^9, 
   3.8270179652342176`*^9}, 3.827151629898443*^9, 3.827151663859152*^9, {
   3.827154347808229*^9, 3.8271543725851474`*^9}, {3.8271544555894794`*^9, 
   3.8271544723501067`*^9}, {3.8271549145098596`*^9, 
   3.8271549179029913`*^9}, {3.8271549511966915`*^9, 3.827155007019635*^9}, {
   3.827199841544186*^9, 3.827199886298647*^9}, {3.8273260485875373`*^9, 
   3.827326048949023*^9}, {3.827335232116922*^9, 3.8273352324621444`*^9}, {
   3.8274028182620726`*^9, 3.827402888537284*^9}, {3.827402944179594*^9, 
   3.827402948509753*^9}, {3.827404643889189*^9, 3.8274046501600447`*^9}, {
   3.827405159604886*^9, 3.8274052348237705`*^9}, {3.827407334161087*^9, 
   3.8274073763943434`*^9}, {3.827411498473765*^9, 3.827411502964302*^9}, {
   3.827593359883607*^9, 3.827593360248237*^9}, {3.8280656056552644`*^9, 
   3.828065637627833*^9}, {3.8280660734434643`*^9, 3.828066094756415*^9}, 
   3.8280669009000826`*^9, {3.828067008975272*^9, 3.828067016127124*^9}, {
   3.828067399275346*^9, 3.828067405174281*^9}, {3.8280674730693913`*^9, 
   3.828067481095809*^9}, {3.828098707438613*^9, 3.82809870893277*^9}, {
   3.8281006161151657`*^9, 3.8281006198151937`*^9}, {3.8281065971895037`*^9, 
   3.8281066003676233`*^9}, {3.8281070787941074`*^9, 
   3.8281070823545694`*^9}, {3.828199150931627*^9, 3.8281991543004723`*^9}, {
   3.8281994673530307`*^9, 3.8281994720281324`*^9}, {3.8282009443600063`*^9, 
   3.8282009612102103`*^9}, {3.8282013677047997`*^9, 3.828201371442216*^9}, {
   3.82820479038287*^9, 3.8282048050163393`*^9}, {3.8282050106999865`*^9, 
   3.8282050119265423`*^9}, {3.8282159929305134`*^9, 3.828215997601283*^9}, {
   3.828216067605596*^9, 3.828216073487549*^9}, {3.8282163152628746`*^9, 
   3.8282163186218786`*^9}, {3.8282164383640475`*^9, 
   3.8282164460761876`*^9}, {3.8282740370104976`*^9, 
   3.8282740466160817`*^9}, {3.8282743233102083`*^9, 3.828274392710521*^9}, {
   3.828274427278859*^9, 3.8282744299235907`*^9}, {3.828282916670545*^9, 
   3.8282829245240145`*^9}, {3.8282832204007187`*^9, 3.8282832206945224`*^9}, 
   3.8282843507140193`*^9, {3.8283249454174175`*^9, 3.828324949256797*^9}, {
   3.828330005637559*^9, 3.8283300137959557`*^9}, 3.8283304645810766`*^9, 
   3.8283768471891546`*^9},
 CellLabel->"In[40]:=",ExpressionUUID->"8c67636b-e081-4a4d-85c7-7ba61e5e05cb"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Root-finding and saddle analysis,", "Chapter",
 CellChangeTimes->{{3.8271997840427933`*^9, 3.827199790607896*^9}, {
  3.827323705310583*^9, 3.8273237154354076`*^9}, {3.8273361239785576`*^9, 
  3.827336130800933*^9}, {3.82740694111985*^9, 
  3.8274069426395473`*^9}},ExpressionUUID->"1f628fb3-93ec-4710-a7d0-\
2753ca8cb944"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"ndesigns", ",", "neigen"}], "}"}], "=", 
   RowBox[{"fnGenSolve", "[", 
    RowBox[{"\[Mu]\[Psi]data", ",", "realTol"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.826864438477213*^9, 3.826864457069584*^9}, 
   3.8268645702110476`*^9, 3.8268662058380136`*^9, 3.8268662720493326`*^9, {
   3.826866329405038*^9, 3.826866371793227*^9}, 3.8268667470677605`*^9, 
   3.8268668948029356`*^9, {3.8269735167559767`*^9, 3.82697351734461*^9}, {
   3.826974378789843*^9, 3.8269743799188533`*^9}, {3.8269745837478943`*^9, 
   3.826974588945794*^9}, {3.826981972944027*^9, 3.8269819856813135`*^9}, 
   3.82698719139892*^9, 3.8269891639061527`*^9, 3.826989195951065*^9, {
   3.826989229943574*^9, 3.826989242300431*^9}, {3.8269895752873173`*^9, 
   3.8269895862503767`*^9}, 3.826997740963091*^9, {3.826997810398911*^9, 
   3.826997846555661*^9}, {3.826997910529632*^9, 3.8269979115606084`*^9}, {
   3.826998142038006*^9, 3.826998143987583*^9}, {3.826998212819109*^9, 
   3.8269982156235065`*^9}, {3.826998287745393*^9, 3.826998290145905*^9}, {
   3.826998462924489*^9, 3.826998495760272*^9}, {3.826998541708366*^9, 
   3.8269986589024897`*^9}, {3.8269988407412047`*^9, 3.826998841093401*^9}, {
   3.8269988848921075`*^9, 3.8269988948234787`*^9}, {3.8269990222171855`*^9, 
   3.8269990237041354`*^9}, {3.8270021052287693`*^9, 
   3.8270021072626896`*^9}, {3.8270023614634895`*^9, 
   3.8270023669181695`*^9}, {3.8270025339892383`*^9, 
   3.8270025460021963`*^9}, {3.827004864296995*^9, 3.827004867890154*^9}, {
   3.8270053519682207`*^9, 3.8270053537567935`*^9}, {3.8270071124525814`*^9, 
   3.8270071164052258`*^9}, {3.827007175570478*^9, 3.8270071794802556`*^9}, {
   3.8270072738135567`*^9, 3.8270072791942744`*^9}, {3.8270073918040495`*^9, 
   3.827007417467923*^9}, {3.827007670609064*^9, 3.827007671897496*^9}, {
   3.8270083570503206`*^9, 3.827008384109578*^9}, {3.82701003170598*^9, 
   3.827010035069539*^9}, {3.8270101287331057`*^9, 3.827010129855342*^9}, {
   3.8270108073257575`*^9, 3.8270108083819413`*^9}, {3.8270117892765884`*^9, 
   3.8270118233142247`*^9}, {3.827012264966546*^9, 3.8270122665462084`*^9}, {
   3.8271950647632847`*^9, 3.8271950748767443`*^9}, {3.827195794340686*^9, 
   3.8271958248447275`*^9}, {3.827197513854951*^9, 3.8271975154989758`*^9}, {
   3.827197610407372*^9, 3.8271976117818785`*^9}, 3.8271997286943817`*^9, {
   3.8271999852954865`*^9, 3.827200007176144*^9}, {3.8272000391324787`*^9, 
   3.8272000736300354`*^9}, {3.8272001266378055`*^9, 3.827200126963848*^9}, {
   3.827238871866635*^9, 3.827238917026298*^9}, 3.8273237248990917`*^9, {
   3.827323841513407*^9, 3.8273238496805534`*^9}, {3.8273260510469093`*^9, 
   3.827326051265766*^9}, {3.8273263400296082`*^9, 3.8273263447635913`*^9}, {
   3.8273356738557973`*^9, 3.8273357181990747`*^9}, {3.8273358047329903`*^9, 
   3.8273358083696823`*^9}, 3.8275933699228783`*^9, 3.8280639969406357`*^9, 
   3.8283218234151983`*^9, 3.8283220261652613`*^9},
 CellLabel->"In[41]:=",ExpressionUUID->"b7b9ad1b-5abb-4b1b-83a8-dabdbbed3b2e"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Number of solutions found: \"\>", "\[InvisibleSpace]", "25", 
   "\[InvisibleSpace]", "\<\"/25\"\>"}],
  SequenceForm["Number of solutions found: ", 25, "/25"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.8392804675588126`*^9, 3.8392812248331704`*^9, 3.83931690924598*^9, 
   3.8393183185021715`*^9, 3.8393237777471642`*^9, 3.839326123314537*^9, 
   3.839329602479185*^9, 3.8394916554834433`*^9, 3.8394939685484405`*^9, 
   3.839498786283988*^9, 3.839500845792883*^9, 3.8395021155533347`*^9, 
   3.8395021499695807`*^9, 3.839587393613307*^9, 3.839924714591745*^9, 
   3.8400966558546762`*^9, 3.8402967966332674`*^9, 3.8407007728492107`*^9, 
   3.841086392955409*^9, 3.841089873419354*^9, 3.8410900924921937`*^9, 
   3.8411269089844503`*^9, 3.8413078847618103`*^9, 3.841307963833911*^9, 
   3.841313481490773*^9, 3.841839439190988*^9, 3.843144550380494*^9, 
   3.8431459318436766`*^9, 3.8431463663047256`*^9, 3.8431464146656685`*^9, {
   3.8431464717029066`*^9, 3.8431464750437393`*^9}, {3.8431465124773016`*^9, 
   3.8431465405892134`*^9}, 3.843312422332708*^9, 3.843312466700965*^9, 
   3.843315219183899*^9, {3.8433159519725447`*^9, 3.84331598372919*^9}, 
   3.843316021634199*^9, 3.8433161357118073`*^9, {3.843316202177918*^9, 
   3.8433162360715866`*^9}, 3.8433165178351603`*^9, 3.8433166197433376`*^9, 
   3.8436653625804996`*^9, {3.8436659414720984`*^9, 3.8436659629637766`*^9}, 
   3.84366607211736*^9, 3.8436661845868015`*^9, 3.8436664112210894`*^9, {
   3.8436666138925037`*^9, 3.8436617477048893`*^9}, 3.8436634319464397`*^9, 
   3.8436635225749145`*^9, 3.8437372785973425`*^9, 3.8437379283094425`*^9, 
   3.843739080878336*^9, 3.843740030871488*^9, 3.843740307893321*^9, 
   3.843830698328064*^9, 3.843833443972936*^9, 3.8442829956927624`*^9, 
   3.8442950117454348`*^9, 3.844302473989115*^9, 3.844468197598259*^9, 
   3.8444954959424524`*^9, 3.844765236764258*^9, 3.845026682306282*^9, 
   3.8451439210414343`*^9, 3.8456697006054273`*^9, 3.8553300877657523`*^9, {
   3.8553307958221684`*^9, 3.855330809615934*^9}, {3.855330888341917*^9, 
   3.855330909044821*^9}, 3.8553309573339767`*^9, 3.8553309934418116`*^9, 
   3.8553310403310175`*^9, 3.855331477976426*^9, 3.855332946425948*^9, 
   3.855334687635594*^9, 3.855335547619893*^9, {3.855406420370962*^9, 
   3.855395762262842*^9}, 3.855397343234021*^9, 3.855755003342244*^9, 
   3.8557568214217873`*^9, 3.855758457007433*^9, 3.855758717313937*^9, 
   3.855769147598236*^9, 3.8557695077579646`*^9, 3.8557712429177647`*^9, 
   3.855771635026174*^9, 3.8557717806408186`*^9, {3.8557749871765738`*^9, 
   3.855775001527011*^9}, 3.855775058203415*^9, 3.855778731012882*^9, 
   3.855779325725447*^9, 3.855789224847821*^9, 3.8557892810577555`*^9, 
   3.8557895531032467`*^9, 3.855824054389904*^9, 3.855824381720598*^9, 
   3.8558247859357257`*^9, 3.8558392402755456`*^9, 3.855839502237859*^9, 
   3.8558405131175175`*^9, 3.855845047459931*^9, 3.8558471182103443`*^9, 
   3.855847293996518*^9, 3.8558474814119205`*^9, 3.8558476090703087`*^9, 
   3.8558555730239687`*^9, 3.85585561818752*^9, 3.855861224823818*^9, 
   3.855866969319919*^9, 3.8558670882471256`*^9, 3.855929325062751*^9, 
   3.85593033732547*^9, 3.855935467871003*^9, 3.855945599558683*^9, 
   3.855949389029525*^9},
 CellLabel->
  "During evaluation of \
In[41]:=",ExpressionUUID->"cccd9538-3f8c-4f61-966c-52dc9e8a0c0b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Number of real solutions: \"\>", "\[InvisibleSpace]", "7"}],
  SequenceForm["Number of real solutions: ", 7],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.8392804675588126`*^9, 3.8392812248331704`*^9, 3.83931690924598*^9, 
   3.8393183185021715`*^9, 3.8393237777471642`*^9, 3.839326123314537*^9, 
   3.839329602479185*^9, 3.8394916554834433`*^9, 3.8394939685484405`*^9, 
   3.839498786283988*^9, 3.839500845792883*^9, 3.8395021155533347`*^9, 
   3.8395021499695807`*^9, 3.839587393613307*^9, 3.839924714591745*^9, 
   3.8400966558546762`*^9, 3.8402967966332674`*^9, 3.8407007728492107`*^9, 
   3.841086392955409*^9, 3.841089873419354*^9, 3.8410900924921937`*^9, 
   3.8411269089844503`*^9, 3.8413078847618103`*^9, 3.841307963833911*^9, 
   3.841313481490773*^9, 3.841839439190988*^9, 3.843144550380494*^9, 
   3.8431459318436766`*^9, 3.8431463663047256`*^9, 3.8431464146656685`*^9, {
   3.8431464717029066`*^9, 3.8431464750437393`*^9}, {3.8431465124773016`*^9, 
   3.8431465405892134`*^9}, 3.843312422332708*^9, 3.843312466700965*^9, 
   3.843315219183899*^9, {3.8433159519725447`*^9, 3.84331598372919*^9}, 
   3.843316021634199*^9, 3.8433161357118073`*^9, {3.843316202177918*^9, 
   3.8433162360715866`*^9}, 3.8433165178351603`*^9, 3.8433166197433376`*^9, 
   3.8436653625804996`*^9, {3.8436659414720984`*^9, 3.8436659629637766`*^9}, 
   3.84366607211736*^9, 3.8436661845868015`*^9, 3.8436664112210894`*^9, {
   3.8436666138925037`*^9, 3.8436617477048893`*^9}, 3.8436634319464397`*^9, 
   3.8436635225749145`*^9, 3.8437372785973425`*^9, 3.8437379283094425`*^9, 
   3.843739080878336*^9, 3.843740030871488*^9, 3.843740307893321*^9, 
   3.843830698328064*^9, 3.843833443972936*^9, 3.8442829956927624`*^9, 
   3.8442950117454348`*^9, 3.844302473989115*^9, 3.844468197598259*^9, 
   3.8444954959424524`*^9, 3.844765236764258*^9, 3.845026682306282*^9, 
   3.8451439210414343`*^9, 3.8456697006054273`*^9, 3.8553300877657523`*^9, {
   3.8553307958221684`*^9, 3.855330809615934*^9}, {3.855330888341917*^9, 
   3.855330909044821*^9}, 3.8553309573339767`*^9, 3.8553309934418116`*^9, 
   3.8553310403310175`*^9, 3.855331477976426*^9, 3.855332946425948*^9, 
   3.855334687635594*^9, 3.855335547619893*^9, {3.855406420370962*^9, 
   3.855395762262842*^9}, 3.855397343234021*^9, 3.855755003342244*^9, 
   3.8557568214217873`*^9, 3.855758457007433*^9, 3.855758717313937*^9, 
   3.855769147598236*^9, 3.8557695077579646`*^9, 3.8557712429177647`*^9, 
   3.855771635026174*^9, 3.8557717806408186`*^9, {3.8557749871765738`*^9, 
   3.855775001527011*^9}, 3.855775058203415*^9, 3.855778731012882*^9, 
   3.855779325725447*^9, 3.855789224847821*^9, 3.8557892810577555`*^9, 
   3.8557895531032467`*^9, 3.855824054389904*^9, 3.855824381720598*^9, 
   3.8558247859357257`*^9, 3.8558392402755456`*^9, 3.855839502237859*^9, 
   3.8558405131175175`*^9, 3.855845047459931*^9, 3.8558471182103443`*^9, 
   3.855847293996518*^9, 3.8558474814119205`*^9, 3.8558476090703087`*^9, 
   3.8558555730239687`*^9, 3.85585561818752*^9, 3.855861224823818*^9, 
   3.855866969319919*^9, 3.8558670882471256`*^9, 3.855929325062751*^9, 
   3.85593033732547*^9, 3.855935467871003*^9, 3.855945599558683*^9, 
   3.8559493890404963`*^9},
 CellLabel->
  "During evaluation of \
In[41]:=",ExpressionUUID->"72b112ac-7ca7-4b5d-8815-bb66ec16c9e2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ndesigns", "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.828387934736498*^9, 3.828387943189232*^9}},
 CellLabel->"In[42]:=",ExpressionUUID->"13d52392-1ebb-4027-96fa-c2f22ef58799"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.17275637242921532`", 
      RowBox[{"-", "0.1179454283177708`"}], 
      RowBox[{"-", "0.9481729496645838`"}], "0.07907404227040195`", 
      "0.384703858593801`"},
     {"0.04233335991327149`", 
      RowBox[{"-", "0.1028234088980697`"}], 
      RowBox[{"-", "0.3694839523477108`"}], 
      RowBox[{"-", "0.055174681967788984`"}], "0.27992706426066455`"},
     {
      RowBox[{"-", "0.44432977814106506`"}], 
      RowBox[{"-", "0.28880724717801604`"}], "0.02792754278673546`", 
      "0.1529137564088091`", "0.2814309156981281`"},
     {
      RowBox[{"-", "0.7779511112337344`"}], 
      RowBox[{"-", "0.6068324322140364`"}], "0.04897021824770507`", 
      "0.3591011546019438`", "0.5024990555626699`"},
     {
      RowBox[{"-", "1.338196003785567`"}], 
      RowBox[{"-", "0.9131035747074039`"}], "1.259097875814613`", 
      "0.21649436985370263`", "0.3211310406936889`"},
     {
      RowBox[{"-", "0.7857321763024241`"}], 
      RowBox[{"-", "0.4277294347293983`"}], "0.30666526331721045`", 
      "0.44661470657722646`", "0.32026982849007224`"},
     {"0", "0", "0", "0", "0"}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.8297347212054358`*^9, 3.829734848711622*^9, 3.8306268747455206`*^9, 
   3.8306384463032007`*^9, 3.830639391832592*^9, 3.8306401235302057`*^9, 
   3.8308530809890633`*^9, 3.830937791034196*^9, 3.8376881906816397`*^9, 
   3.8376961859807863`*^9, 3.8376964334608564`*^9, 3.837696595793204*^9, {
   3.837696700540737*^9, 3.8376967135014844`*^9}, 3.837696840471511*^9, 
   3.837697453563924*^9, 3.837697956686513*^9, 3.837698227019644*^9, 
   3.837699079991508*^9, 3.837699266564265*^9, 3.837774605373869*^9, 
   3.8386390640753927`*^9, 3.838897355657366*^9, 3.839058313247144*^9, 
   3.839079535793952*^9, 3.8391627056029587`*^9, 3.839186663203867*^9, 
   3.8392257358296366`*^9, 3.8392258368368692`*^9, 3.8392315144339113`*^9, 
   3.8392315606057158`*^9, 3.839234680612175*^9, 3.839236494281996*^9, 
   3.8392379270208373`*^9, 3.839238723089837*^9, 3.839238785785204*^9, 
   3.839238834849825*^9, 3.8392393710933685`*^9, 3.8392395960785646`*^9, 
   3.83923964459406*^9, {3.8392399285522685`*^9, 3.8392399390260983`*^9}, 
   3.8392400654947987`*^9, 3.8392401326218405`*^9, 3.8392403752143693`*^9, 
   3.8392455925677786`*^9, 3.839268671990658*^9, 3.8392689027461033`*^9, 
   3.839280472450005*^9, 3.8392812256380496`*^9, 3.8393169109869113`*^9, 
   3.8393183195773864`*^9, 3.839323778840242*^9, 3.839326125117299*^9, 
   3.8393296033871975`*^9, 3.839491655565027*^9, 3.839493968648992*^9, 
   3.839498786351817*^9, 3.839500847058772*^9, 3.8395021161926208`*^9, 
   3.839502151637285*^9, 3.839587394605919*^9, 3.8399247157016788`*^9, 
   3.840096656630597*^9, 3.8402967986696253`*^9, 3.840700772976773*^9, 
   3.8410863942348385`*^9, 3.8410898743322906`*^9, 3.8410900933340607`*^9, 
   3.841126910475567*^9, 3.8413078849134045`*^9, 3.8413079643567567`*^9, 
   3.841313481634482*^9, 3.8418394396237535`*^9, 3.84314455206924*^9, 
   3.843145933296183*^9, 3.8431463675522747`*^9, 3.843146416607527*^9, 
   3.84314647632078*^9, {3.843146513931547*^9, 3.843146542367996*^9}, 
   3.8433124225744286`*^9, 3.843312467684765*^9, 3.843315220175754*^9, 
   3.843315953145565*^9, 3.8433160272734966`*^9, 3.843316137138344*^9, {
   3.8433162039986057`*^9, 3.8433162407924905`*^9}, 3.8433165190618925`*^9, 
   3.8433166206187315`*^9, 3.843665365348095*^9, {3.843665944749307*^9, 
   3.8436659644291058`*^9}, 3.843666073093588*^9, 3.8436661860684*^9, 
   3.843666412470925*^9, {3.843666615099389*^9, 3.843661749647434*^9}, 
   3.843663433119053*^9, 3.8436635235209703`*^9, 3.8437372806638603`*^9, 
   3.843737929816126*^9, 3.843739082094766*^9, 3.843740031086844*^9, 
   3.8437403090803795`*^9, 3.843830698793997*^9, 3.8438334440645227`*^9, 
   3.844282997884964*^9, 3.844295013237537*^9, 3.844302475147339*^9, 
   3.844468198203305*^9, 3.8444955013194475`*^9, 3.8447652373584104`*^9, 
   3.845026682606638*^9, 3.845143921547432*^9, 3.8456697011811547`*^9, 
   3.8553300899173145`*^9, 3.8553314941095943`*^9, 3.855332947737814*^9, 
   3.85533468921875*^9, 3.8553355485861316`*^9, {3.855406423302478*^9, 
   3.855395763177148*^9}, 3.855397344442999*^9, 3.855755004300561*^9, 
   3.855756823118593*^9, 3.8557584579497786`*^9, 3.855758718278786*^9, 
   3.8557693438711047`*^9, 3.8557695093819504`*^9, 3.8557712437434573`*^9, 
   3.855771636135275*^9, 3.855771800737118*^9, 3.855775002831991*^9, 
   3.8557750591066723`*^9, 3.8557787322311144`*^9, 3.855779326724658*^9, 
   3.8557892254888444`*^9, 3.85578928257059*^9, 3.855789553929777*^9, 
   3.8558240549224787`*^9, 3.8558243828374653`*^9, 3.85582478707041*^9, 
   3.8558392411830673`*^9, 3.8558395029814887`*^9, 3.8558405139825606`*^9, 
   3.855845082338152*^9, 3.8558471187723703`*^9, 3.8558472947747993`*^9, 
   3.855847482240759*^9, 3.85584761000854*^9, 3.855855573649424*^9, 
   3.8558556190842266`*^9, 3.8558612268473225`*^9, 3.8558669703153877`*^9, 
   3.8558670890151477`*^9, 3.8559293258955307`*^9, 3.855930338199596*^9, 
   3.85593546926333*^9, 3.855945600316266*^9, 3.8559493900652*^9},
 CellLabel->
  "Out[42]//MatrixForm=",ExpressionUUID->"9b0b2dfc-2f7d-462c-bc34-\
e9202f530b8b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"objF", "[", 
    RowBox[{
     RowBox[{"\[Mu]\[Psi]set", "[", "\[Mu]\[Psi]data", "]"}], ",", "#"}], 
    "]"}], "&"}], "/@", "ndesigns"}]], "Input",
 CellChangeTimes->{{3.8284472044744368`*^9, 3.828447212801484*^9}, {
  3.8284473636504526`*^9, 3.8284473765356345`*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"2326f8dd-25cd-4f64-bc2c-6eeb1d0d14e6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.00002926829891758409`", ",", "0.00011622209726201704`", ",", 
   "0.0044744833847962795`", ",", "0.00007173997320908398`", ",", 
   "0.000028524846214850186`", ",", "0.000051590452767591444`", ",", "0.`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.8297347212682657`*^9, 3.8297348507132726`*^9, 3.8306268747653165`*^9, 
   3.8306384667485843`*^9, 3.830639393298232*^9, 3.830640125557455*^9, {
   3.83085308290095*^9, 3.830853091592703*^9}, 3.830937793030856*^9, 
   3.837688190759264*^9, 3.837696186000784*^9, 3.8376967159490075`*^9, 
   3.837696842287121*^9, 3.837697453595169*^9, 3.8376979587379546`*^9, 
   3.837698103694566*^9, 3.837698229664595*^9, 3.837699081448681*^9, 
   3.8376992683005486`*^9, 3.8377746068937397`*^9, 3.8386390641355395`*^9, 
   3.838897355730147*^9, 3.8390583133292904`*^9, 3.8390795370866756`*^9, 
   3.8391627056797547`*^9, 3.839186664652916*^9, 3.839225737489355*^9, 
   3.839225836893696*^9, 3.8392315156402283`*^9, 3.839231561631548*^9, 
   3.839234681424119*^9, 3.839236495809743*^9, 3.8392379270377903`*^9, 
   3.839238723140934*^9, 3.8392387858654757`*^9, 3.839238834867778*^9, 
   3.8392393778545876`*^9, 3.8392395975411034`*^9, 3.839239646779998*^9, 
   3.8392399406185474`*^9, 3.8392400670507865`*^9, 3.839240133949301*^9, 
   3.8392403766510005`*^9, 3.8392455935106716`*^9, 3.8392686720371637`*^9, 
   3.839268902793974*^9, 3.839280474202111*^9, 3.839281227480982*^9, 
   3.839316913020852*^9, 3.839318320575207*^9, 3.839323779722769*^9, 
   3.8393261264950037`*^9, 3.8393296048906007`*^9, 3.839491655578024*^9, 
   3.8394939687122803`*^9, 3.8394987863947268`*^9, 3.8395008485396614`*^9, 
   3.839502117090996*^9, 3.8395021527685328`*^9, 3.839587395632679*^9, 
   3.839924720169598*^9, 3.840096658171729*^9, 3.840296799682418*^9, 
   3.840700773025379*^9, 3.841086396063579*^9, 3.8410898759823103`*^9, 
   3.8410900939655313`*^9, 3.8411269119160852`*^9, 3.8413078863590913`*^9, 
   3.841307965708417*^9, 3.8413134817302065`*^9, 3.8418394396525316`*^9, 
   3.843144553705741*^9, 3.843145934667982*^9, 3.84314654408753*^9, 
   3.843312422657239*^9, 3.843312468649827*^9, 3.843315221904166*^9, 
   3.843316028804128*^9, 3.843316139024558*^9, 3.8433162053010707`*^9, 
   3.84331624200741*^9, 3.843316519935851*^9, 3.84331662186458*^9, 
   3.8436653662885785`*^9, 3.8436659653201747`*^9, 3.8436660746722274`*^9, 
   3.8436661877658052`*^9, 3.84366641454981*^9, {3.8436666160840282`*^9, 
   3.843661751416184*^9}, 3.843663434530238*^9, 3.843663524984974*^9, 
   3.8437372821478634`*^9, 3.843737934192144*^9, 3.8437390834458914`*^9, 
   3.8437400310998163`*^9, 3.8437403107019377`*^9, 3.8438306988727865`*^9, 
   3.8438334441056905`*^9, 3.8442829992590733`*^9, 3.844295014428302*^9, 
   3.8443024764842668`*^9, 3.844468198273156*^9, 3.844495502989094*^9, 
   3.8447652374102955`*^9, 3.8450266826810846`*^9, 3.845143921626221*^9, 
   3.8456697012643375`*^9, 3.8553300917593985`*^9, 3.855331495281828*^9, 
   3.855332953812336*^9, 3.8553346904699693`*^9, 3.855335082385109*^9, 
   3.8553355536358595`*^9, {3.855406426654287*^9, 3.8553957665463877`*^9}, {
   3.855397359875074*^9, 3.8553973765023518`*^9}, 3.8557550087364607`*^9, 
   3.8557569236771955`*^9, 3.855758461160087*^9, 3.855758721186923*^9, 
   3.8557693520938225`*^9, 3.8557695106492777`*^9, 3.8557712446934967`*^9, 
   3.855771637663518*^9, 3.855771801462428*^9, 3.855775004357671*^9, 
   3.855775060909912*^9, 3.8557787332640963`*^9, 3.855779328450456*^9, 
   3.85578922665643*^9, 3.8557892846669865`*^9, 3.8557895552343636`*^9, 
   3.855824055908253*^9, 3.855824383721278*^9, 3.855824799319147*^9, 
   3.855839242430032*^9, 3.8558395044684024`*^9, 3.855840515850066*^9, 
   3.855845083430281*^9, 3.855847120044794*^9, 3.855847296558298*^9, 
   3.855847483567453*^9, 3.855847610806176*^9, 3.8558555749175415`*^9, 
   3.855855619750926*^9, 3.8558612283205633`*^9, 3.8558669716583247`*^9, 
   3.855867090618147*^9, 3.85593033961103*^9, 3.8559354708153543`*^9, 
   3.8559456021835403`*^9, 3.8559493913830023`*^9},
 CellLabel->"Out[43]=",ExpressionUUID->"505ba5ca-49c1-48fd-bb00-02a7782db31c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"neigen", "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", "1"}], "]"}], "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.8283881302090025`*^9, 3.8283881413370004`*^9}},
 CellLabel->"In[44]:=",ExpressionUUID->"59413cd9-1f70-4b7a-9a29-441938d053fc"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"72.1315743985863`", "15.462107262816048`", "0.5010933910557389`", 
      "0.0031153807292957237`", "0.00002359376825538034`"},
     {"59.3535939497426`", "7.349883299310296`", "0.11433328921013602`", 
      RowBox[{"-", "0.002200396385076331`"}], "0.0016758092139011424`"},
     {"43.50383226540666`", "1.9261987563249123`", "0.09640520332437383`", 
      RowBox[{"-", "0.09506024996945718`"}], 
      RowBox[{"-", "0.046413700293859196`"}]},
     {"33.22255191813881`", "1.067757723359921`", "0.15853647571848126`", 
      "0.018945713180745147`", 
      RowBox[{"-", "0.0002167580623836136`"}]},
     {"37.58808703968743`", "8.702348699875976`", "1.8527102774950648`", 
      "0.014080869210200145`", "7.93303454515204`*^-6"},
     {"33.10006442486566`", "0.14359719133867757`", "0.03586098726627024`", 
      "0.011671674677543476`", 
      RowBox[{"-", "0.0029329391374769303`"}]},
     {"57.415917402194374`", "5.4845278494331176`", "0.09366171014591412`", 
      "0.005846216807685465`", "0.00004682141892189099`"}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.829734721332095*^9, 3.829734852453581*^9, 3.830626874783783*^9, 
   3.830638467980689*^9, 3.8306393945807505`*^9, 3.8306401276988144`*^9, 
   3.8308530941967382`*^9, 3.8309377949985933`*^9, 3.8376881908150854`*^9, 
   3.837696186040783*^9, 3.8376967169581947`*^9, 3.8376968435160427`*^9, 
   3.837697453626413*^9, 3.8376979603108444`*^9, 3.8376981054410276`*^9, 
   3.8376982310688105`*^9, 3.837698400346518*^9, 3.8376990830308704`*^9, 
   3.837699270121855*^9, 3.8377746077714233`*^9, 3.8386390641808596`*^9, 
   3.8388973557950315`*^9, 3.839058313404088*^9, 3.839079538495208*^9, 
   3.8391627057485704`*^9, 3.839186665625416*^9, 3.8392257390035334`*^9, 
   3.8392258369569044`*^9, 3.8392315168550434`*^9, 3.8392315622010455`*^9, 
   3.839234682188019*^9, 3.839236496539566*^9, 3.8392379270557427`*^9, 
   3.8392387231925125`*^9, 3.8392387859224696`*^9, 3.839238834883415*^9, 
   3.839239380197281*^9, 3.8392395985000753`*^9, 3.839239648322757*^9, 
   3.8392399416337614`*^9, 3.839240067825412*^9, 3.839240135355583*^9, 
   3.839240377481886*^9, 3.8392455942407136`*^9, 3.8392686720889564`*^9, 
   3.8392689028418474`*^9, 3.839280475057994*^9, 3.83928122857703*^9, 
   3.8393169139335284`*^9, 3.8393183214331026`*^9, 3.839323780433788*^9, 
   3.839326128138258*^9, 3.8393296056551924`*^9, 3.839491655596365*^9, 
   3.8394939687749453`*^9, 3.8394987864395714`*^9, 3.8395008491186876`*^9, 
   3.8395021186353273`*^9, 3.839502153902269*^9, 3.8395873963871584`*^9, 
   3.8399247415293627`*^9, 3.840096658972985*^9, 3.8402968004453135`*^9, 
   3.8407007730715694`*^9, 3.841086396992474*^9, 3.841089877729333*^9, 
   3.841090094541552*^9, 3.8411269126480865`*^9, 3.8413078871487894`*^9, 
   3.841307966417283*^9, 3.8413134818229585`*^9, 3.841839439666604*^9, 
   3.843144554795382*^9, 3.8431459359124565`*^9, 3.843146544721797*^9, 
   3.8433124227453938`*^9, 3.8433124696442146`*^9, 3.8433152230090795`*^9, 
   3.843316030062665*^9, 3.843316139905562*^9, 3.843316206748296*^9, 
   3.843316242774747*^9, 3.8433165223465223`*^9, 3.8433166233387213`*^9, 
   3.843665368787893*^9, 3.8436659661223965`*^9, 3.843666075762642*^9, 
   3.8436661883916826`*^9, 3.843666415503774*^9, {3.8436666173478365`*^9, 
   3.8436617521563263`*^9}, 3.843663435743801*^9, 3.8436635259165926`*^9, 
   3.8437372834606524`*^9, 3.8437379351429048`*^9, 3.8437390842197213`*^9, 
   3.8437400311609397`*^9, 3.84374031134363*^9, 3.843830698939605*^9, 
   3.843833444155246*^9, 3.84428300007335*^9, 3.844295015453435*^9, 
   3.844302477693392*^9, 3.8444681983338156`*^9, 3.8444955041447735`*^9, 
   3.844765237456302*^9, 3.845026682752846*^9, 3.8451439217060456`*^9, 
   3.8456697013369637`*^9, 3.8553300931816936`*^9, 3.8553314963205566`*^9, 
   3.855334691855458*^9, 3.855335084787905*^9, 3.8553355553693237`*^9, {
   3.855406427308645*^9, 3.8553957683612757`*^9}, 3.8553973792723923`*^9, 
   3.8557550093878317`*^9, 3.8557569697589064`*^9, 3.8557584625384583`*^9, 
   3.855758722029483*^9, 3.8557693530126176`*^9, 3.8557695121208134`*^9, 
   3.855771245367077*^9, 3.855771638815583*^9, 3.8557718027881856`*^9, 
   3.8557750054147387`*^9, 3.855775061539896*^9, 3.855778735104726*^9, 
   3.855779329275381*^9, 3.855789227821867*^9, 3.8557892859512672`*^9, 
   3.8557895557913785`*^9, 3.855824056586998*^9, 3.8558243846979313`*^9, 
   3.855824800448617*^9, 3.8558392437095203`*^9, 3.855839505698804*^9, 
   3.8558405166032066`*^9, 3.855845085026352*^9, 3.8558471213847075`*^9, 
   3.855847297132535*^9, 3.855847484290001*^9, 3.85584761152038*^9, 
   3.855855575567769*^9, 3.8558556203894324`*^9, 3.85586122952839*^9, 
   3.855866973171221*^9, 3.855867091788137*^9, 3.8559303401629343`*^9, 
   3.855935471419568*^9, 3.8559456035182858`*^9, 3.855949392966503*^9},
 CellLabel->
  "Out[44]//MatrixForm=",ExpressionUUID->"511c9f77-3bc0-4e9c-9fe8-\
385a4f355dea"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"IFnSet", "=", 
   RowBox[{"saddleAnalysis", "[", 
    RowBox[{"\[Mu]\[Psi]data", ",", 
     RowBox[{"{", 
      RowBox[{"ndesigns", ",", "neigen"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.826864438477213*^9, 3.826864457069584*^9}, 
   3.8268645702110476`*^9, 3.8268662058380136`*^9, 3.8268662720493326`*^9, {
   3.826866329405038*^9, 3.826866371793227*^9}, 3.8268667470677605`*^9, 
   3.8268668948029356`*^9, {3.8269735167559767`*^9, 3.82697351734461*^9}, {
   3.826974378789843*^9, 3.8269743799188533`*^9}, {3.8269745837478943`*^9, 
   3.826974588945794*^9}, {3.826981972944027*^9, 3.8269819856813135`*^9}, 
   3.82698719139892*^9, 3.8269891639061527`*^9, 3.826989195951065*^9, {
   3.826989229943574*^9, 3.826989242300431*^9}, {3.8269895752873173`*^9, 
   3.8269895862503767`*^9}, 3.826997740963091*^9, {3.826997810398911*^9, 
   3.826997846555661*^9}, {3.826997910529632*^9, 3.8269979115606084`*^9}, {
   3.826998142038006*^9, 3.826998143987583*^9}, {3.826998212819109*^9, 
   3.8269982156235065`*^9}, {3.826998287745393*^9, 3.826998290145905*^9}, {
   3.826998462924489*^9, 3.826998495760272*^9}, {3.826998541708366*^9, 
   3.8269986589024897`*^9}, {3.8269988407412047`*^9, 3.826998841093401*^9}, {
   3.8269988848921075`*^9, 3.8269988948234787`*^9}, {3.8269990222171855`*^9, 
   3.8269990237041354`*^9}, {3.8270021052287693`*^9, 
   3.8270021072626896`*^9}, {3.8270023614634895`*^9, 
   3.8270023669181695`*^9}, {3.8270025339892383`*^9, 
   3.8270025460021963`*^9}, {3.827004864296995*^9, 3.827004867890154*^9}, {
   3.8270053519682207`*^9, 3.8270053537567935`*^9}, {3.8270071124525814`*^9, 
   3.8270071164052258`*^9}, {3.827007175570478*^9, 3.8270071794802556`*^9}, {
   3.8270072738135567`*^9, 3.8270072791942744`*^9}, {3.8270073918040495`*^9, 
   3.827007417467923*^9}, {3.827007670609064*^9, 3.827007671897496*^9}, {
   3.8270083570503206`*^9, 3.827008384109578*^9}, {3.82701003170598*^9, 
   3.827010035069539*^9}, {3.8270101287331057`*^9, 3.827010129855342*^9}, {
   3.8270108073257575`*^9, 3.8270108083819413`*^9}, {3.8270117892765884`*^9, 
   3.8270118233142247`*^9}, {3.827012264966546*^9, 3.8270122665462084`*^9}, {
   3.8271950647632847`*^9, 3.8271950748767443`*^9}, {3.827195794340686*^9, 
   3.8271958248447275`*^9}, {3.827197513854951*^9, 3.8271975154989758`*^9}, {
   3.827197610407372*^9, 3.8271976117818785`*^9}, 3.8271997286943817`*^9, {
   3.8271999852954865`*^9, 3.827200007176144*^9}, {3.8272000391324787`*^9, 
   3.8272000736300354`*^9}, {3.8272001266378055`*^9, 3.827200126963848*^9}, {
   3.827238871866635*^9, 3.827238917026298*^9}, 3.8273237248990917`*^9, {
   3.827323841513407*^9, 3.8273238496805534`*^9}, {3.8273260510469093`*^9, 
   3.827326051265766*^9}, {3.8273263400296082`*^9, 3.8273263447635913`*^9}, {
   3.8273356738557973`*^9, 3.8273357181990747`*^9}, {3.8273358047329903`*^9, 
   3.8273358083696823`*^9}, 3.8275933699228783`*^9, 3.8280639969406357`*^9, 
   3.8283218234151983`*^9, 3.8283218765862064`*^9, 3.8283220017584057`*^9, {
   3.8284640043968096`*^9, 3.8284640067407217`*^9}, {3.828881302269228*^9, 
   3.828881303221733*^9}, {3.8289779368447065`*^9, 3.828977938082235*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"76bd0505-7b7f-403e-8137-1097079ee9e6"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Saddle-Minima Graph,", "Chapter",
 CellChangeTimes->{{3.8268661308245244`*^9, 3.8268661326536274`*^9}, {
  3.826982118250987*^9, 3.826982120864538*^9}, {3.8269892030744047`*^9, 
  3.8269892041629496`*^9}, {3.8269977552565727`*^9, 3.8269977577257032`*^9}, {
  3.8273657674823666`*^9, 
  3.827365777028346*^9}},ExpressionUUID->"d047bb86-c03c-47a0-a9d9-\
25095bede22d"],

Cell[TextData[{
 "Run the following command ",
 StyleBox["only",
  FontSlant->"Italic"],
 " after ensuring \[OpenCurlyDoubleQuote]\[Mu]\[Psi]data, ndesigns, neigen, \
IFnSet\[CloseCurlyDoubleQuote] are defined/computed as expected."
}], "Text",
 CellChangeTimes->{{3.828376631278787*^9, 3.8283766839909306`*^9}, {
  3.828376934575988*^9, 
  3.8283769430553646`*^9}},ExpressionUUID->"fb7e7ba4-0f61-4135-9b01-\
e12edd9e9a6e"],

Cell["\<\
Instructions for use:

1. Clicking the button in the midpoint of any edge will activate the edge of \
the saddle graph.
2. In case of overlapping edges, the first option, namely, \
\[OpenCurlyDoubleQuote]Paths\[CloseCurlyDoubleQuote] would allow  options to \
pick different edges.
3. \[OpenCurlyDoubleQuote]Edge Tacker\[CloseCurlyDoubleQuote] slider allows \
the user to traverse along an edge of the graph and see the design change.
4. Changing the branch choice would plot the function generated related to \
that choice.
5.  Input slider allows the user to visualize the motion of the chosen design.\
\>", "Text",
 CellChangeTimes->{{3.8559456373327894`*^9, 3.855945697206313*^9}, {
  3.855949095573825*^9, 
  3.855949301645919*^9}},ExpressionUUID->"968564c0-47cd-4b75-80a9-\
8b68992d319b"],

Cell[BoxData[
 RowBox[{"Quiet", "[", 
  RowBox[{"graphFnGen", "[", 
   RowBox[{"\[Mu]\[Psi]data", ",", "ndesigns", ",", "neigen", ",", "IFnSet"}],
    "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.828324497011593*^9, 3.8283245000681753`*^9}, {
   3.8288813070559964`*^9, 3.8288813105136175`*^9}, {3.828977963227729*^9, 
   3.828977965196498*^9}, {3.8309379800975857`*^9, 3.8309379823505607`*^9}, {
   3.837688410778343*^9, 3.837688414918902*^9}, 3.837692244094556*^9, 
   3.837692535711074*^9, {3.8376967356806717`*^9, 3.83769673708617*^9}, 
   3.837696860815983*^9, {3.837697476982997*^9, 3.837697478691183*^9}, 
   3.8376981132299414`*^9, {3.8376992750615883`*^9, 3.8376992770994387`*^9}, 
   3.83777802022153*^9, {3.837779140240404*^9, 3.8377791459460793`*^9}, 
   3.8377792908477187`*^9, 3.8377793343875494`*^9, 3.837786307627499*^9, 
   3.8377902215628543`*^9, 3.8377906657413225`*^9, {3.8390752781259947`*^9, 
   3.839075280070016*^9}, {3.85539697240102*^9, 3.855396973264083*^9}, {
   3.855397387377902*^9, 3.8553973891114683`*^9}, {3.8553975709704494`*^9, 
   3.8553975791734457`*^9}, {3.8557717007971325`*^9, 
   3.8557717019855933`*^9}, {3.855858901321101*^9, 3.855858905724004*^9}, {
   3.855858995784807*^9, 3.8558589966333785`*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"fe7e0076-7e50-4d23-8db3-71e7b015e13e"]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1734.75, 893.25},
WindowMargins->{{185.25, Automatic}, {42.75, Automatic}},
SpellingDictionaries->{"CorrectWords"->{
 "Burmester", "worhtwhile", "neigen", "ndesigns", "\[Mu]\[Psi]data"}},
Magnification:>0.75 Inherited,
FrontEndVersion->"13.0 for Microsoft Windows (64-bit) (December 2, 2021)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"dc425382-3ed8-46ce-931c-37dabcd9f581"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 172, 3, 74, "Title",ExpressionUUID->"11233cd8-bee2-42b9-a262-04a2194cf3c1"],
Cell[755, 27, 38364, 634, 146, "Text",ExpressionUUID->"0b950a6c-dfe6-4dab-960f-97d8c3da6f92"],
Cell[39122, 663, 1794, 43, 59, "Text",ExpressionUUID->"94d771a2-06d8-446b-b178-84454b14df4f"],
Cell[CellGroupData[{
Cell[40941, 710, 270, 4, 51, "Chapter",ExpressionUUID->"37365eae-d1ec-488b-adec-610a9b1f0b7e"],
Cell[41214, 716, 475, 12, 24, "Text",ExpressionUUID->"a1cb924a-3267-42c5-b94f-2eb4c6f84338"],
Cell[41692, 730, 16146, 419, 263, "Input",ExpressionUUID->"3746a4e6-b124-452b-bf62-eb8f2084f2c1"],
Cell[57841, 1151, 355, 7, 24, "Text",ExpressionUUID->"7843c74a-1105-41c0-a217-5fbad5db64e9"],
Cell[58199, 1160, 1991, 39, 22, "Input",ExpressionUUID->"2fdf425f-bdd2-4e5a-bab3-9aa6a7c734d6"],
Cell[60193, 1201, 338, 7, 24, "Text",ExpressionUUID->"5de4dba7-0608-490f-9772-d4b9aa4a723b"],
Cell[60534, 1210, 30952, 713, 2123, "Input",ExpressionUUID->"325a3288-dad6-46a5-99f0-4b1115254a40"],
Cell[91489, 1925, 382, 7, 24, "Text",ExpressionUUID->"235c0da4-3217-4165-9fc2-43f137e0d67d"],
Cell[91874, 1934, 22281, 483, 384, "Input",ExpressionUUID->"12368e44-75e7-42d8-aff4-44da156b77e4"]
}, Closed]],
Cell[CellGroupData[{
Cell[114192, 2422, 237, 4, 44, "Chapter",ExpressionUUID->"99103943-23f1-40ea-8f60-0a6f019ca597"],
Cell[114432, 2428, 301, 7, 24, "Text",ExpressionUUID->"14618afb-9a9e-4632-b604-8ca6aa0b656f"],
Cell[114736, 2437, 4534, 103, 128, "Input",ExpressionUUID->"d36edbc9-17a7-4a56-bf50-91f3069d65c4"],
Cell[119273, 2542, 261, 6, 24, "Text",ExpressionUUID->"4d8c01fb-c257-48e2-82be-cfaa2f3dcd8f"],
Cell[119537, 2550, 9358, 190, 251, "Input",ExpressionUUID->"361c528a-fa78-4eae-a447-10adf2f2033c"],
Cell[128898, 2742, 336, 7, 24, "Text",ExpressionUUID->"fac5ee04-77e5-407d-afcd-1e3e702f42a6"],
Cell[129237, 2751, 7585, 158, 201, "Input",ExpressionUUID->"aec2eb4b-3001-4f1a-abb7-6394121e00bf"],
Cell[136825, 2911, 305, 7, 24, "Text",ExpressionUUID->"9f9839e8-505a-4e48-b437-01ccf7326a7b"],
Cell[137133, 2920, 12103, 252, 315, "Input",ExpressionUUID->"357fdf3d-5d44-4b52-8cce-17af3b2d8827"],
Cell[149239, 3174, 324, 7, 24, "Text",ExpressionUUID->"c7fccc7b-8eb4-4866-9073-720deadb3aaa"],
Cell[149566, 3183, 1618, 44, 100, "Input",ExpressionUUID->"30b5ca36-6abb-40d6-adf0-7c601c1cd34a"],
Cell[151187, 3229, 391, 7, 24, "Text",ExpressionUUID->"8fcb8903-0438-48eb-bee5-e224d4da0952"],
Cell[151581, 3238, 9449, 198, 535, "Input",ExpressionUUID->"b273bea3-a5fe-4f18-90a4-af81d1da42a4"]
}, Closed]],
Cell[CellGroupData[{
Cell[161067, 3441, 161, 3, 44, "Chapter",ExpressionUUID->"011f3f8c-31db-4c9f-9364-c517be417693"],
Cell[CellGroupData[{
Cell[161253, 3448, 176, 3, 50, "Section",ExpressionUUID->"5e05e2bd-52e7-4a0c-9e3e-8d7c273126ad"],
Cell[161432, 3453, 238, 6, 25, "Text",ExpressionUUID->"e833c1d1-e96c-4080-bdbf-9528f06b07ac"],
Cell[161673, 3461, 5691, 144, 215, "Input",ExpressionUUID->"6b981e7a-fe11-4ffe-b231-ad9e892256da"],
Cell[167367, 3607, 300, 7, 25, "Text",ExpressionUUID->"34dc7fc0-3d4f-4cde-be8a-03507d871a98"],
Cell[167670, 3616, 4402, 124, 135, "Input",ExpressionUUID->"79186b96-1a49-4101-95f6-cbb76a0b16d7"],
Cell[172075, 3742, 270, 6, 25, "Text",ExpressionUUID->"921039ca-0063-4fca-89ca-b030d3a76087"],
Cell[172348, 3750, 559, 13, 21, "Input",ExpressionUUID->"5bbd6d1c-dcdb-44cf-8ba5-2401ce353f8d"],
Cell[172910, 3765, 733, 17, 21, "Input",ExpressionUUID->"76743de6-1b34-4d9a-902d-f9521739b5cc"],
Cell[173646, 3784, 676, 16, 21, "Input",ExpressionUUID->"7847f882-1314-45b4-a35e-e5917a7fd337"],
Cell[174325, 3802, 539, 12, 21, "Input",ExpressionUUID->"b5402cb3-ffa9-4446-bf32-284a2413158f"],
Cell[174867, 3816, 273, 6, 25, "Text",ExpressionUUID->"81a6258a-a35e-42ca-8f8e-7287ebbf1b7a"],
Cell[175143, 3824, 22310, 458, 442, "Input",ExpressionUUID->"c749f56d-6974-45da-9d0b-9e63b6f9ea30"],
Cell[197456, 4284, 261, 6, 24, "Text",ExpressionUUID->"de8f7891-3182-4f8a-9729-f70ccd21664d"],
Cell[197720, 4292, 13336, 254, 225, "Input",ExpressionUUID->"0233a10c-dd8c-4a7f-b97f-a1d0cda2dcdc"]
}, Closed]],
Cell[CellGroupData[{
Cell[211093, 4551, 272, 4, 40, "Section",ExpressionUUID->"1cd405a8-5614-4138-b154-14ec8879ad21"],
Cell[211368, 4557, 1015, 24, 36, "Input",ExpressionUUID->"1d87d45d-e21f-47c6-bb1d-8ff5ff0a5667"],
Cell[212386, 4583, 9089, 209, 207, "Input",ExpressionUUID->"490ddcd5-d8c8-4412-8c32-60d687a6314a"],
Cell[221478, 4794, 5463, 133, 280, "Input",ExpressionUUID->"868017dd-0ddc-4676-aa1e-3f10f4445fef"],
Cell[226944, 4929, 1652, 40, 88, "Input",ExpressionUUID->"41f3bc72-ddb9-4259-805c-35e6e3cbe5b4"],
Cell[228599, 4971, 7433, 170, 207, "Input",ExpressionUUID->"4fca05fc-bab8-4019-aa2c-5f7e75cb9df3"],
Cell[236035, 5143, 5422, 133, 280, "Input",ExpressionUUID->"f889b159-75c2-4e5f-8fc0-b388129b3b00"],
Cell[241460, 5278, 5496, 130, 242, "Input",ExpressionUUID->"913807e6-e711-4688-9762-722341c95005"],
Cell[246959, 5410, 9128, 211, 221, "Input",ExpressionUUID->"fc0916d9-b244-4b84-9de4-2bf5d28fd577"],
Cell[256090, 5623, 5896, 145, 207, "Input",ExpressionUUID->"798a6ed4-d803-420b-8f78-c2da8b0b7a5e"],
Cell[261989, 5770, 8928, 208, 207, "Input",ExpressionUUID->"d402e15b-36a0-4939-9448-76414884e720"],
Cell[270920, 5980, 1593, 40, 113, "Input",ExpressionUUID->"93b03d8c-3ad4-4cb8-9013-375fdbff6299"],
Cell[272516, 6022, 8855, 207, 221, "Input",ExpressionUUID->"b8b9c0eb-f395-42ec-bb6b-ac6eaaa90016"],
Cell[281374, 6231, 2872, 72, 145, "Input",ExpressionUUID->"ac336509-1bbc-4c59-b01d-7c16450f63c8"],
Cell[284249, 6305, 2491, 61, 159, "Input",ExpressionUUID->"740a0822-bae3-4c7d-9a7b-d09ff8454c78"],
Cell[286743, 6368, 9443, 222, 264, "Input",ExpressionUUID->"ed0c5d64-401e-4fdd-b50c-d2d00615ecd9"]
}, Closed]],
Cell[CellGroupData[{
Cell[296223, 6595, 213, 4, 40, "Section",ExpressionUUID->"18855450-8db6-43bd-af54-100bcb063cdf"],
Cell[296439, 6601, 325, 7, 24, "Text",ExpressionUUID->"992e824f-87eb-48a8-a90c-a0b4b6a7d873"],
Cell[296767, 6610, 37926, 812, 1436, "Input",ExpressionUUID->"cb769fdd-3c05-43a3-858a-87419db0bf7b"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[334742, 7428, 236, 4, 51, "Chapter",ExpressionUUID->"5322ff04-2a43-480b-9e85-51aa733462bc"],
Cell[334981, 7434, 334, 7, 27, "Text",ExpressionUUID->"2c1045da-8aa6-4b9b-b2bd-bf7f12ad22e6"],
Cell[CellGroupData[{
Cell[335340, 7445, 173, 3, 34, "Subsubsection",ExpressionUUID->"07e45f19-a193-4244-8acc-28f668a710c7"],
Cell[335516, 7450, 10944, 187, 50, "Input",ExpressionUUID->"f992536d-b3c2-4b7e-9d1e-d0e6590f206e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[346497, 7642, 183, 3, 34, "Subsubsection",ExpressionUUID->"edf9d325-ea91-4a9e-a7e6-5e77302fd468"],
Cell[346683, 7647, 11856, 213, 43, "Input",ExpressionUUID->"1747bc26-4bf6-48d3-9125-fd0e7e21882a"],
Cell[358542, 7862, 287, 7, 27, "Text",ExpressionUUID->"f0c9dbb6-973e-4f09-9fb2-fc16456ef7cd"],
Cell[358832, 7871, 3311, 48, 22, "Input",ExpressionUUID->"8c67636b-e081-4a4d-85c7-7ba61e5e05cb"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[362192, 7925, 329, 5, 51, "Chapter",ExpressionUUID->"1f628fb3-93ec-4710-a7d0-2753ca8cb944"],
Cell[CellGroupData[{
Cell[362546, 7934, 3075, 45, 21, "Input",ExpressionUUID->"b7b9ad1b-5abb-4b1b-83a8-dabdbbed3b2e"],
Cell[CellGroupData[{
Cell[365646, 7983, 3398, 51, 18, "Print",ExpressionUUID->"cccd9538-3f8c-4f61-966c-52dc9e8a0c0b"],
Cell[369047, 8036, 3349, 50, 18, "Print",ExpressionUUID->"72b112ac-7ca7-4b5d-8815-bb66ec16c9e2"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[372445, 8092, 211, 3, 21, "Input",ExpressionUUID->"13d52392-1ebb-4027-96fa-c2f22ef58799"],
Cell[372659, 8097, 5591, 96, 110, "Output",ExpressionUUID->"9b0b2dfc-2f7d-462c-bc34-e9202f530b8b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[378287, 8198, 395, 9, 21, "Input",ExpressionUUID->"2326f8dd-25cd-4f64-bc2c-6eeb1d0d14e6"],
Cell[378685, 8209, 4131, 60, 24, "Output",ExpressionUUID->"505ba5ca-49c1-48fd-bb00-02a7782db31c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[382853, 8274, 292, 6, 21, "Input",ExpressionUUID->"59413cd9-1f70-4b7a-9a29-441938d053fc"],
Cell[383148, 8282, 5323, 85, 112, "Output",ExpressionUUID->"511c9f77-3bc0-4e9c-9fe8-385a4f355dea"]
}, Open  ]],
Cell[388486, 8370, 3258, 47, 21, "Input",ExpressionUUID->"76bd0505-7b7f-403e-8137-1097079ee9e6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[391781, 8422, 372, 6, 51, "Chapter",ExpressionUUID->"d047bb86-c03c-47a0-a9d9-25095bede22d"],
Cell[392156, 8430, 423, 10, 27, "Text",ExpressionUUID->"fb7e7ba4-0f61-4135-9b01-e12edd9e9a6e"],
Cell[392582, 8442, 804, 17, 136, "Text",ExpressionUUID->"968564c0-47cd-4b75-80a9-8b68992d319b"],
Cell[393389, 8461, 1324, 20, 21, "Input",ExpressionUUID->"fe7e0076-7e50-4d23-8db3-71e7b015e13e"]
}, Open  ]]
}, Open  ]]
}
]
*)

